/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function($){for(var e=[],T=0,O=$.length;T<O;T++)e[T]=Y[$[T]];return e};define(Y[49],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(N){return(P,d,u)=>{let m=null,y=null;if(typeof u.value=="function"?(m="value",y=u.value):typeof u.get=="function"&&(m="get",y=u.get),!y)throw new Error("not supported");u[m]=N(y,d)}}function O(N,P,d){let u=null,m=null;if(typeof d.value=="function"?(u="value",m=d.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(u="get",m=d.get),!m)throw new Error("not supported");const y=`$memoize$${P}`;d[u]=function(...p){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[y]}}e.memoize=O;function k(N,P,d){return T((u,m)=>{const y=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...I){this[p]||(this[p]=d?d():void 0),clearTimeout(this[y]),P&&(this[p]=P(this[p],...I),I=[this[p]]),this[y]=setTimeout(()=>{u.apply(this,I),this[p]=d?d():void 0},N)}})}e.debounce=k;function L(N,P,d){return T((u,m)=>{const y=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,I=`$throttle$lastRun$${m}`,w=`$throttle$pending$${m}`;return function(...S){if(this[p]||(this[p]=d?d():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...S)),this[w])return;const E=this[I]+N;E<=Date.now()?(this[I]=Date.now(),u.apply(this,[this[p]]),this[p]=d?d():void 0):(this[w]=!0,this[y]=setTimeout(()=>{this[w]=!1,this[I]=Date.now(),u.apply(this,[this[p]]),this[p]=d?d():void 0},E-Date.now()))}})}e.throttle=L}),define(Y[70],Z([0,1,10]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(d,u){if(!d)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=O;function k(d,u="Unreachable"){throw new Error(u)}e.assertNever=k;function L(d){if(!d)throw new T.BugIndicatingError("Assertion Failed")}e.assert=L;function N(d){if(!d()){debugger;d(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function P(d,u){let m=0;for(;m<d.length-1;){const y=d[m],p=d[m+1];if(!u(y,p))return!1;m++}return!0}e.checkAdjacentItems=P}),define(Y[50],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function N(t,n=!1){let i=0;const r=t.length;let o="",c=0,a=16,h=0;function D(Q){let ge=0,ce=0;for(;ge<Q;){const re=t.charCodeAt(i);if(re>=48&&re<=57)ce=ce*16+re-48;else if(re>=65&&re<=70)ce=ce*16+re-65+10;else if(re>=97&&re<=102)ce=ce*16+re-97+10;else break;i++,ge++}return ge<Q&&(ce=-1),ce}function j(Q){i=Q,o="",c=0,a=16,h=0}function W(){const Q=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return h=3,t.substring(Q,i);let ge=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;ge=i}else h=3;return t.substring(Q,ge)}function J(){let Q="",ge=i;for(;;){if(i>=r){Q+=t.substring(ge,i),h=2;break}const ce=t.charCodeAt(i);if(ce===34){Q+=t.substring(ge,i),i++;break}if(ce===92){if(Q+=t.substring(ge,i),i++,i>=r){h=2;break}switch(t.charCodeAt(i++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const me=D(4);me>=0?Q+=String.fromCharCode(me):h=4;break}default:h=5}ge=i;continue}if(ce>=0&&ce<=31)if(d(ce)){Q+=t.substring(ge,i),h=2;break}else h=6;i++}return Q}function X(){if(o="",h=0,c=i,i>=r)return c=r,a=17;let Q=t.charCodeAt(i);if(P(Q)){do i++,o+=String.fromCharCode(Q),Q=t.charCodeAt(i);while(P(Q));return a=15}if(d(Q))return i++,o+=String.fromCharCode(Q),Q===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(Q){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=J(),a=10;case 47:{const ge=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!d(t.charCodeAt(i));)i++;return o=t.substring(ge,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const ce=r-1;let re=!1;for(;i<ce;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,re=!0;break}i++}return re||(i++,h=1),o=t.substring(ge,i),a=13}return o+=String.fromCharCode(Q),i++,a=16}case 45:if(o+=String.fromCharCode(Q),i++,i===r||!u(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=W(),a=11;default:for(;i<r&&ee(Q);)i++,Q=t.charCodeAt(i);if(c!==i){switch(o=t.substring(c,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(Q),i++,a=16}}function ee(Q){if(P(Q)||d(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let Q;do Q=X();while(Q>=12&&Q<=15);return Q}return{setPosition:j,getPosition:()=>i,scan:n?ne:X,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>h}}e.createScanner=N;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function y(t,n){const i=[],r=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(D,j,W,J){c.value=D,c.offset=j,c.length=W,c.type=J,c.colonOffset=void 0,o=c}try{v(t,{onObjectBegin:(D,j)=>{if(n<=D)throw r;o=void 0,a=n>D,i.push("")},onObjectProperty:(D,j,W)=>{if(n<j||(h(D,j,W,"property"),i[i.length-1]=D,n<=j+W))throw r},onObjectEnd:(D,j)=>{if(n<=D)throw r;o=void 0,i.pop()},onArrayBegin:(D,j)=>{if(n<=D)throw r;o=void 0,i.push(0)},onArrayEnd:(D,j)=>{if(n<=D)throw r;o=void 0,i.pop()},onLiteralValue:(D,j,W)=>{if(n<j||(h(D,j,W,s(D)),n<=j+W))throw r},onSeparator:(D,j,W)=>{if(n<=j)throw r;if(D===":"&&o&&o.type==="property")o.colonOffset=j,a=!1,o=void 0;else if(D===","){const J=i[i.length-1];typeof J=="number"?i[i.length-1]=J+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(D){if(D!==r)throw D}return{path:i,previousNode:o,isAtPropertyKey:a,matches:D=>{let j=0;for(let W=0;j<D.length&&W<i.length;W++)if(D[j]===i[W]||D[j]==="*")j++;else if(D[j]!=="**")return!1;return j===D.length}}}e.getLocation=y;function p(t,n=[],i=L.DEFAULT){let r=null,o=[];const c=[];function a(D){Array.isArray(o)?o.push(D):r!==null&&(o[r]=D)}return v(t,{onObjectBegin:()=>{const D={};a(D),c.push(o),o=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const D=[];a(D),c.push(o),o=D,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(D,j,W)=>{n.push({error:D,offset:j,length:W})}},i),o[0]}e.parse=p;function I(t,n=[],i=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){r.type==="property"&&(r.length=D-r.offset,r=r.parent)}function c(D){return r.children.push(D),D}v(t,{onObjectBegin:D=>{r=c({type:"object",offset:D,length:-1,parent:r,children:[]})},onObjectProperty:(D,j,W)=>{r=c({type:"property",offset:j,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:D,offset:j,length:W,parent:r})},onObjectEnd:(D,j)=>{r.length=D+j-r.offset,r=r.parent,o(D+j)},onArrayBegin:(D,j)=>{r=c({type:"array",offset:D,length:-1,parent:r,children:[]})},onArrayEnd:(D,j)=>{r.length=D+j-r.offset,r=r.parent,o(D+j)},onLiteralValue:(D,j,W)=>{c({type:s(D),offset:j,length:W,parent:r,value:D}),o(j+W)},onSeparator:(D,j,W)=>{r.type==="property"&&(D===":"?r.colonOffset=j:D===","&&o(j))},onError:(D,j,W)=>{n.push({error:D,offset:j,length:W})}},i);const h=r.children[0];return h&&delete h.parent,h}e.parseTree=I;function w(t,n){if(!t)return;let i=t;for(const r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===r){i=c.children[1],o=!0;break}if(!o)return}else{const o=r;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=w;function S(t){if(!t.parent||!t.parent.children)return[];const n=S(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;n.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&n.push(i)}return n}e.getNodePath=S;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":{const n=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(n[i.children[0].value]=E(r))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function l(t,n,i=!1){return n>=t.offset&&n<t.offset+t.length||i&&n===t.offset+t.length}e.contains=l;function g(t,n,i=!1){if(l(t,n,i)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const c=g(r[o],n,i);if(c)return c}return t}}e.findNodeAtOffset=g;function v(t,n,i=L.DEFAULT){const r=N(t,!1);function o(q){return q?()=>q(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(q){return q?te=>q(te,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=o(n.onObjectBegin),h=c(n.onObjectProperty),D=o(n.onObjectEnd),j=o(n.onArrayBegin),W=o(n.onArrayEnd),J=c(n.onLiteralValue),X=c(n.onSeparator),ee=o(n.onComment),ne=c(n.onError),Q=i&&i.disallowComments,ge=i&&i.allowTrailingComma;function ce(){for(;;){const q=r.scan();switch(r.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:Q||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(q){case 12:case 13:Q?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return q}}}function re(q,te=[],b=[]){if(ne(q),te.length+b.length>0){let R=r.getToken();for(;R!==17;){if(te.indexOf(R)!==-1){ce();break}else if(b.indexOf(R)!==-1)break;R=ce()}}}function me(q){const te=r.getTokenValue();return q?J(te):h(te),ce(),!0}function M(){switch(r.getToken()){case 11:{let q=0;try{q=JSON.parse(r.getTokenValue()),typeof q!="number"&&(re(2),q=0)}catch{re(2)}J(q);break}case 7:J(null);break;case 8:J(!0);break;case 9:J(!1);break;default:return!1}return ce(),!0}function A(){return r.getToken()!==10?(re(3,[],[2,5]),!1):(me(!1),r.getToken()===6?(X(":"),ce(),G()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function U(){a(),ce();let q=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(q||re(4,[],[]),X(","),ce(),r.getToken()===2&&ge)break}else q&&re(6,[],[]);A()||re(4,[],[2,5]),q=!0}return D(),r.getToken()!==2?re(7,[2],[]):ce(),!0}function V(){j(),ce();let q=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(q||re(4,[],[]),X(","),ce(),r.getToken()===4&&ge)break}else q&&re(6,[],[]);G()||re(4,[],[4,5]),q=!0}return W(),r.getToken()!==4?re(8,[4],[]):ce(),!0}function G(){switch(r.getToken()){case 3:return V();case 1:return U();case 10:return me(!0);default:return M()}}return ce(),r.getToken()===17?i.allowEmptyContent?!0:(re(4,[],[]),!1):G()?(r.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.visit=v;function f(t,n){const i=N(t),r=[];let o,c=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:c!==a&&r.push(t.substring(c,a)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),c=i.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function $(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function N(d){L.push(d,Date.now())}function P(){const d=[];for(let u=0;u<L.length;u+=2)d.push({name:L[u],startTime:L[u+1]});return d}return{mark:N,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const N of performance.getEntriesByType("mark"))L.push({name:N.name,startTime:Math.round(k+N.startTime)});return L}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function T(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=T(O))}(),function($,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var O in T)(typeof exports=="object"?exports:$)[O]=T[O]}}(typeof self<"u"?self:this,function(){return function($){var e={};function T(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return $[O].call(k.exports,k,k.exports,T),k.l=!0,k.exports}return T.m=$,T.c=e,T.d=function(O,k,L){T.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:L})},T.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},T.t=function(O,k){if(1&k&&(O=T(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var L=Object.create(null);if(T.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var N in O)T.d(L,N,function(P){return O[P]}.bind(null,N));return L},T.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return T.d(k,"a",k),k},T.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},T.p="",T(T.s=0)}([function($,e,T){(function(O){var k;e=$.exports=b,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],u=0,m=u++;d[m]="0|[1-9]\\d*";var y=u++;d[y]="[0-9]+";var p=u++;d[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=u++;d[I]="("+d[m]+")\\.("+d[m]+")\\.("+d[m]+")";var w=u++;d[w]="("+d[y]+")\\.("+d[y]+")\\.("+d[y]+")";var S=u++;d[S]="(?:"+d[m]+"|"+d[p]+")";var E=u++;d[E]="(?:"+d[y]+"|"+d[p]+")";var l=u++;d[l]="(?:-("+d[S]+"(?:\\."+d[S]+")*))";var g=u++;d[g]="(?:-?("+d[E]+"(?:\\."+d[E]+")*))";var v=u++;d[v]="[0-9A-Za-z-]+";var f=u++;d[f]="(?:\\+("+d[v]+"(?:\\."+d[v]+")*))";var s=u++,t="v?"+d[I]+d[l]+"?"+d[f]+"?";d[s]="^"+t+"$";var n="[v=\\s]*"+d[w]+d[g]+"?"+d[f]+"?",i=u++;d[i]="^"+n+"$";var r=u++;d[r]="((?:<|>)?=?)";var o=u++;d[o]=d[y]+"|x|X|\\*";var c=u++;d[c]=d[m]+"|x|X|\\*";var a=u++;d[a]="[v=\\s]*("+d[c]+")(?:\\.("+d[c]+")(?:\\.("+d[c]+")(?:"+d[l]+")?"+d[f]+"?)?)?";var h=u++;d[h]="[v=\\s]*("+d[o]+")(?:\\.("+d[o]+")(?:\\.("+d[o]+")(?:"+d[g]+")?"+d[f]+"?)?)?";var D=u++;d[D]="^"+d[r]+"\\s*"+d[a]+"$";var j=u++;d[j]="^"+d[r]+"\\s*"+d[h]+"$";var W=u++;d[W]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var J=u++;d[J]="(?:~>?)";var X=u++;d[X]="(\\s*)"+d[J]+"\\s+",P[X]=new RegExp(d[X],"g");var ee=u++;d[ee]="^"+d[J]+d[a]+"$";var ne=u++;d[ne]="^"+d[J]+d[h]+"$";var Q=u++;d[Q]="(?:\\^)";var ge=u++;d[ge]="(\\s*)"+d[Q]+"\\s+",P[ge]=new RegExp(d[ge],"g");var ce=u++;d[ce]="^"+d[Q]+d[a]+"$";var re=u++;d[re]="^"+d[Q]+d[h]+"$";var me=u++;d[me]="^"+d[r]+"\\s*("+n+")$|^$";var M=u++;d[M]="^"+d[r]+"\\s*("+t+")$|^$";var A=u++;d[A]="(\\s*)"+d[r]+"\\s*("+n+"|"+d[a]+")",P[A]=new RegExp(d[A],"g");var U=u++;d[U]="^\\s*("+d[a]+")\\s+-\\s+("+d[a]+")\\s*$";var V=u++;d[V]="^\\s*("+d[h]+")\\s+-\\s+("+d[h]+")\\s*$";var G=u++;d[G]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)k(q,d[q]),P[q]||(P[q]=new RegExp(d[q]));function te(z,H){if(z instanceof b)return z;if(typeof z!="string"||z.length>L||!(H?P[i]:P[s]).test(z))return null;try{return new b(z,H)}catch{return null}}function b(z,H){if(z instanceof b){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof b))return new b(z,H);k("SemVer",z,H),this.loose=H;var K=z.trim().match(H?P[i]:P[s]);if(!K)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var ve=+he;if(ve>=0&&ve<N)return ve}return he}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=te,e.valid=function(z,H){var K=te(z,H);return K?K.version:null},e.clean=function(z,H){var K=te(z.trim().replace(/^[=v]+/,""),H);return K?K.version:null},e.SemVer=b,b.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},b.prototype.toString=function(){return this.version},b.prototype.compare=function(z){return k("SemVer.compare",this.version,this.loose,z),z instanceof b||(z=new b(z,this.loose)),this.compareMain(z)||this.comparePre(z)},b.prototype.compareMain=function(z){return z instanceof b||(z=new b(z,this.loose)),C(this.major,z.major)||C(this.minor,z.minor)||C(this.patch,z.patch)},b.prototype.comparePre=function(z){if(z instanceof b||(z=new b(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],he=z.prerelease[H];if(k("prerelease compare",H,K,he),K===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(K===void 0)return-1;if(K!==he)return C(K,he)}while(++H)},b.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,K,he){typeof K=="string"&&(he=K,K=void 0);try{return new b(z,K).inc(H,he).version}catch{return null}},e.diff=function(z,H){if(ie(z,H))return null;var K=te(z),he=te(H);if(K.prerelease.length||he.prerelease.length){for(var ve in K)if((ve==="major"||ve==="minor"||ve==="patch")&&K[ve]!==he[ve])return"pre"+ve;return"prerelease"}for(var ve in K)if((ve==="major"||ve==="minor"||ve==="patch")&&K[ve]!==he[ve])return ve},e.compareIdentifiers=C;var R=/^[0-9]+$/;function C(z,H){var K=R.test(z),he=R.test(H);return K&&he&&(z=+z,H=+H),K&&!he?-1:he&&!K?1:z<H?-1:z>H?1:0}function F(z,H,K){return new b(z,K).compare(new b(H,K))}function B(z,H,K){return F(z,H,K)>0}function x(z,H,K){return F(z,H,K)<0}function ie(z,H,K){return F(z,H,K)===0}function se(z,H,K){return F(z,H,K)!==0}function pe(z,H,K){return F(z,H,K)>=0}function ye(z,H,K){return F(z,H,K)<=0}function ae(z,H,K,he){var ve;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),ve=z===K;break;case"!==":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),ve=z!==K;break;case"":case"=":case"==":ve=ie(z,K,he);break;case"!=":ve=se(z,K,he);break;case">":ve=B(z,K,he);break;case">=":ve=pe(z,K,he);break;case"<":ve=x(z,K,he);break;case"<=":ve=ye(z,K,he);break;default:throw new TypeError("Invalid operator: "+H)}return ve}function ue(z,H){if(z instanceof ue){if(z.loose===H)return z;z=z.value}if(!(this instanceof ue))return new ue(z,H);k("comparator",z,H),this.loose=H,this.parse(z),this.semver===le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(z,H){return C(H,z)},e.major=function(z,H){return new b(z,H).major},e.minor=function(z,H){return new b(z,H).minor},e.patch=function(z,H){return new b(z,H).patch},e.compare=F,e.compareLoose=function(z,H){return F(z,H,!0)},e.rcompare=function(z,H,K){return F(H,z,K)},e.sort=function(z,H){return z.sort(function(K,he){return e.compare(K,he,H)})},e.rsort=function(z,H){return z.sort(function(K,he){return e.rcompare(K,he,H)})},e.gt=B,e.lt=x,e.eq=ie,e.neq=se,e.gte=pe,e.lte=ye,e.cmp=ae,e.Comparator=ue;var le={};function oe(z,H){if(z instanceof oe)return z.loose===H?z:new oe(z.raw,H);if(z instanceof ue)return new oe(z.value,H);if(!(this instanceof oe))return new oe(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function fe(z){return!z||z.toLowerCase()==="x"||z==="*"}function Te(z,H,K,he,ve,Re,Se,Le,Pe,Oe,je,Ie,Ne){return((H=fe(K)?"":fe(he)?">="+K+".0.0":fe(ve)?">="+K+"."+he+".0":">="+H)+" "+(Le=fe(Pe)?"":fe(Oe)?"<"+(+Pe+1)+".0.0":fe(je)?"<"+Pe+"."+(+Oe+1)+".0":Ie?"<="+Pe+"."+Oe+"."+je+"-"+Ie:"<="+Le)).trim()}function Fe(z,H){for(var K=0;K<z.length;K++)if(!z[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<z.length;K++)if(k(z[K].semver),z[K].semver!==le&&z[K].semver.prerelease.length>0){var he=z[K].semver;if(he.major===H.major&&he.minor===H.minor&&he.patch===H.patch)return!0}return!1}return!0}function De(z,H,K){try{H=new oe(H,K)}catch{return!1}return H.test(z)}function Me(z,H,K,he){var ve,Re,Se,Le,Pe;switch(z=new b(z,he),H=new oe(H,he),K){case">":ve=B,Re=ye,Se=x,Le=">",Pe=">=";break;case"<":ve=x,Re=pe,Se=B,Le="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(z,H,he))return!1;for(var Oe=0;Oe<H.set.length;++Oe){var je=H.set[Oe],Ie=null,Ne=null;if(je.forEach(function(Ce){Ce.semver===le&&(Ce=new ue(">=0.0.0")),Ie=Ie||Ce,Ne=Ne||Ce,ve(Ce.semver,Ie.semver,he)?Ie=Ce:Se(Ce.semver,Ne.semver,he)&&(Ne=Ce)}),Ie.operator===Le||Ie.operator===Pe||(!Ne.operator||Ne.operator===Le)&&Re(z,Ne.semver)||Ne.operator===Pe&&Se(z,Ne.semver))return!1}return!0}ue.prototype.parse=function(z){var H=this.loose?P[me]:P[M],K=z.match(H);if(!K)throw new TypeError("Invalid comparator: "+z);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new b(K[2],this.loose):this.semver=le},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(z){return k("Comparator.test",z,this.loose),this.semver===le||(typeof z=="string"&&(z=new b(z,this.loose)),ae(z,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(z,H){if(!(z instanceof ue))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new oe(z.value,H),De(this.value,K,H);if(z.operator==="")return K=new oe(this.value,H),De(z.semver,K,H);var he=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Re=this.semver.version===z.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Le=ae(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Pe=ae(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return he||ve||Re&&Se||Le||Pe},e.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),k("range",z,H);var K=H?P[V]:P[U];z=z.replace(K,Te),k("hyphen replace",z),z=z.replace(P[A],"$1$2$3"),k("comparator trim",z,P[A]),z=(z=(z=z.replace(P[X],"$1~")).replace(P[ge],"$1^")).split(/\s+/).join(" ");var he=H?P[me]:P[M],ve=z.split(" ").map(function(Re){return function(Se,Le){return k("comp",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(je){return function(Ie,Ne){k("caret",Ie,Ne);var Ce=Ne?P[re]:P[ce];return Ie.replace(Ce,function(Ue,we,Ee,be,ke){var Ae;return k("caret",Ie,Ue,we,Ee,be,ke),fe(we)?Ae="":fe(Ee)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":fe(be)?Ae=we==="0"?">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+".0 <"+(+we+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+ke+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+ke+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+ke+" <"+(+we+1)+".0.0"):(k("no pr"),Ae=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+" <"+(+we+1)+".0.0"),k("caret return",Ae),Ae})}(je,Oe)}).join(" ")}(Se,Le),k("caret",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(je){return function(Ie,Ne){var Ce=Ne?P[ne]:P[ee];return Ie.replace(Ce,function(Ue,we,Ee,be,ke){var Ae;return k("tilde",Ie,Ue,we,Ee,be,ke),fe(we)?Ae="":fe(Ee)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":fe(be)?Ae=">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=">="+we+"."+Ee+"."+be+ke+" <"+we+"."+(+Ee+1)+".0"):Ae=">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0",k("tilde return",Ae),Ae})}(je,Oe)}).join(" ")}(Se,Le),k("tildes",Se),Se=function(Pe,Oe){return k("replaceXRanges",Pe,Oe),Pe.split(/\s+/).map(function(je){return function(Ie,Ne){Ie=Ie.trim();var Ce=Ne?P[j]:P[D];return Ie.replace(Ce,function(Ue,we,Ee,be,ke,Ae){k("xRange",Ie,Ue,we,Ee,be,ke,Ae);var We=fe(Ee),ze=We||fe(be),Be=ze||fe(ke);return we==="="&&Be&&(we=""),We?Ue=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(ze&&(be=0),Be&&(ke=0),we===">"?(we=">=",ze?(Ee=+Ee+1,be=0,ke=0):Be&&(be=+be+1,ke=0)):we==="<="&&(we="<",ze?Ee=+Ee+1:be=+be+1),Ue=we+Ee+"."+be+"."+ke):ze?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Be&&(Ue=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0"),k("xRange return",Ue),Ue})}(je,Oe)}).join(" ")}(Se,Le),k("xrange",Se),Se=function(Pe,Oe){return k("replaceStars",Pe,Oe),Pe.trim().replace(P[G],"")}(Se,Le),k("stars",Se),Se}(Re,H)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Re){return!!Re.match(he)})),ve=ve.map(function(Re){return new ue(Re,H)})},oe.prototype.intersects=function(z,H){if(!(z instanceof oe))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(he){return z.set.some(function(ve){return ve.every(function(Re){return he.intersects(Re,H)})})})})},e.toComparators=function(z,H){return new oe(z,H).set.map(function(K){return K.map(function(he){return he.value}).join(" ").trim().split(" ")})},oe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new b(z,this.loose));for(var H=0;H<this.set.length;H++)if(Fe(this.set[H],z))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(z,H,K){var he=null,ve=null;try{var Re=new oe(H,K)}catch{return null}return z.forEach(function(Se){Re.test(Se)&&(he&&ve.compare(Se)!==-1||(ve=new b(he=Se,K)))}),he},e.minSatisfying=function(z,H,K){var he=null,ve=null;try{var Re=new oe(H,K)}catch{return null}return z.forEach(function(Se){Re.test(Se)&&(he&&ve.compare(Se)!==1||(ve=new b(he=Se,K)))}),he},e.validRange=function(z,H){try{return new oe(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,K){return Me(z,H,"<",K)},e.gtr=function(z,H,K){return Me(z,H,">",K)},e.outside=Me,e.prerelease=function(z,H){var K=te(z,H);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(z,H,K){return z=new oe(z,K),H=new oe(H,K),z.intersects(H)},e.coerce=function(z){if(z instanceof b)return z;if(typeof z!="string")return null;var H=z.match(P[W]);return H==null?null:te((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,T(1))},function($,e){var T,O,k=$.exports={};function L(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function P(E){if(T===setTimeout)return setTimeout(E,0);if((T===L||!T)&&setTimeout)return T=setTimeout,setTimeout(E,0);try{return T(E,0)}catch{try{return T.call(null,E,0)}catch{return T.call(this,E,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:L}catch{T=L}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var d,u=[],m=!1,y=-1;function p(){m&&d&&(m=!1,d.length?u=d.concat(u):y=-1,u.length&&I())}function I(){if(!m){var E=P(p);m=!0;for(var l=u.length;l;){for(d=u,u=[];++y<l;)d&&d[y].run();y=-1,l=u.length}d=null,m=!1,function(g){if(O===clearTimeout)return clearTimeout(g);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(g);try{O(g)}catch{try{return O.call(null,g)}catch{return O.call(this,g)}}}(E)}}function w(E,l){this.fun=E,this.array=l}function S(){}k.nextTick=function(E){var l=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)l[g-1]=arguments[g];u.push(new w(E,l)),u.length!==1||m||P(I)},w.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(E){return[]},k.binding=function(E){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(E){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Y[71],Z([0,1]),function($,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(P,d,u){this.level=P,this.key=d,this.value=u,this.forward=[]}}const k=void 0;class L{constructor(P,d=2**16){this.comparator=P,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new O(this.c,k,k)}get size(){return this.f}clear(){this.e=new O(this.c,k,k)}has(P){return Boolean(L.g(this,P,this.comparator))}get(P){return L.g(this,P,this.comparator)?.value}set(P,d){return L.h(this,P,d,this.comparator)&&(this.f+=1),this}delete(P){const d=L.k(this,P,this.comparator);return d&&(this.f-=1),d}forEach(P,d){let u=this.e.forward[0];for(;u;)P.call(d,u.value,u.key,this),u=u.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",d=this.e.forward[0];for(;d;)P+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return P}static g(P,d,u){let m=P.e;for(let y=P.d-1;y>=0;y--)for(;m.forward[y]&&u(m.forward[y].key,d)<0;)m=m.forward[y];if(m=m.forward[0],m&&u(m.key,d)===0)return m}static h(P,d,u,m){const y=[];let p=P.e;for(let I=P.d-1;I>=0;I--){for(;p.forward[I]&&m(p.forward[I].key,d)<0;)p=p.forward[I];y[I]=p}if(p=p.forward[0],p&&m(p.key,d)===0)return p.value=u,!1;{const I=L.j(P);if(I>P.d){for(let w=P.d;w<I;w++)y[w]=P.e;P.d=I}p=new O(I,d,u);for(let w=0;w<I;w++)p.forward[w]=y[w].forward[w],y[w].forward[w]=p;return!0}}static j(P,d=.5){let u=1;for(;Math.random()<d&&u<P.c;)u+=1;return u}static k(P,d,u){const m=[];let y=P.e;for(let p=P.d-1;p>=0;p--){for(;y.forward[p]&&u(y.forward[p].key,d)<0;)y=y.forward[p];m[p]=y}if(y=y.forward[0],!y||u(y.key,d)!==0)return!1;for(let p=0;p<P.d&&m[p].forward[p]===y;p++)m[p].forward[p]=y.forward[p];for(;P.d>0&&P.e.forward[P.d-1]===k;)P.d-=1;return!0}}e.SkipList=L}),define(Y[43],Z([0,1,10,2]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const s=f;return s?typeof s.read=="function":!1}e.isReadable=k;function L(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function N(f){const s=f;return s?L(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=N;function P(f,s){return new d(f,s)}e.newWriteableStream=P;class d{constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,T.onUnexpectedError)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let n;switch(s){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const i=n.indexOf(t);i>=0&&n.splice(i,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(f,s){const t=[];let n;for(;(n=f.read())!==null;)t.push(n);return s(t)}e.consumeReadable=u;function m(f,s,t){const n=[];let i;for(;(i=f.read())!==null&&n.length<t;)n.push(i);return i===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return f.read()}}}e.peekReadable=m;function y(f,s){return new Promise((t,n)=>{const i=[];p(f,{onData:r=>{s&&i.push(r)},onError:r=>{s?n(r):t(void 0)},onEnd:()=>{t(s?s(i):void 0)}})})}e.consumeStream=y;function p(f,s){let t=!1;return f.on("error",n=>{t||s.onError(n)}),f.on("end",()=>{t||s.onEnd()}),f.on("data",n=>{t||s.onData(n)}),(0,O.toDisposable)(()=>t=!0)}e.listenStream=p;function I(f,s){return new Promise((t,n)=>{const i=new O.DisposableStore,r=[],o=h=>{if(r.push(h),r.length>s)return i.dispose(),f.pause(),t({stream:f,buffer:r,ended:!1})},c=h=>n(h),a=()=>t({stream:f,buffer:r,ended:!0});i.add((0,O.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),i.add((0,O.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),i.add((0,O.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=I;function w(f,s){const t=P(s);return t.end(f),t}e.toStream=w;function S(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function E(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=E;function l(f,s,t){const n=P(t);return p(f,{onData:i=>n.write(s.data(i)),onError:i=>n.error(s.error?s.error(i):i),onEnd:()=>n.end()}),n}e.transform=l;function g(f,s,t){let n=!1;return{read:()=>{const i=s.read();return n?i:(n=!0,i!==null?t([f,i]):f)}}}e.prefixedReadable=g;function v(f,s,t){let n=!1;const i=P(t);return p(s,{onData:r=>n?i.write(r):(n=!0,i.write(t([f,r]))),onError:r=>i.error(r),onEnd:()=>{n||(n=!0,i.write(f)),i.end()}}),i}e.prefixedStream=v}),define(Y[15],Z([0,1,43]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let k,L;class N{static alloc(h){return O?new N(Buffer.allocUnsafe(h)):new N(new Uint8Array(h))}static wrap(h){return O&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new N(h)}static fromString(h,D){return!(D?.dontUseNodeBuffer||!1)&&O?new N(Buffer.from(h)):(k||(k=new TextEncoder),new N(k.encode(h)))}static fromByteArray(h){const D=N.alloc(h.length);for(let j=0,W=h.length;j<W;j++)D.buffer[j]=h[j];return D}static concat(h,D){if(typeof D>"u"){D=0;for(let J=0,X=h.length;J<X;J++)D+=h[J].byteLength}const j=N.alloc(D);let W=0;for(let J=0,X=h.length;J<X;J++){const ee=h[J];j.set(ee,W),W+=ee.byteLength}return j}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=N.alloc(this.byteLength);return h.set(this),h}toString(){return O?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(h,D){return new N(this.buffer.subarray(h,D))}set(h,D){if(h instanceof N)this.buffer.set(h.buffer,D);else if(h instanceof Uint8Array)this.buffer.set(h,D);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),D);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return u(this.buffer,h)}writeUInt32BE(h,D){m(this.buffer,h,D)}readUInt32LE(h){return y(this.buffer,h)}writeUInt32LE(h,D){p(this.buffer,h,D)}readUInt8(h){return I(this.buffer,h)}writeUInt8(h,D){w(this.buffer,h,D)}}e.VSBuffer=N;function P(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=P;function d(a,h,D){a[D+0]=h&255,h=h>>>8,a[D+1]=h&255}e.writeUInt16LE=d;function u(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=u;function m(a,h,D){a[D+3]=h,h=h>>>8,a[D+2]=h,h=h>>>8,a[D+1]=h,h=h>>>8,a[D]=h}e.writeUInt32BE=m;function y(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=y;function p(a,h,D){a[D+0]=h&255,h=h>>>8,a[D+1]=h&255,h=h>>>8,a[D+2]=h&255,h=h>>>8,a[D+3]=h&255}e.writeUInt32LE=p;function I(a,h){return a[h]}e.readUInt8=I;function w(a,h,D){a[D]=h}e.writeUInt8=w;function S(a){return T.consumeReadable(a,h=>N.concat(h))}e.readableToBuffer=S;function E(a){return T.toReadable(a)}e.bufferToReadable=E;function l(a){return T.consumeStream(a,h=>N.concat(h))}e.streamToBuffer=l;async function g(a){return a.ended?N.concat(a.buffer):N.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=g;function v(a){return T.toStream(a,h=>N.concat(h))}e.bufferToStream=v;function f(a){return T.transform(a,{data:h=>typeof h=="string"?N.fromString(h):N.wrap(h)},h=>N.concat(h))}e.streamToBufferReadableStream=f;function s(a){return T.newWriteableStream(h=>N.concat(h),a)}e.newWriteableBufferStream=s;function t(a,h){return T.prefixedReadable(a,h,D=>N.concat(D))}e.prefixedBufferReadable=t;function n(a,h){return T.prefixedStream(a,h,D=>N.concat(D))}e.prefixedBufferStream=n;function i(a){let h=0,D=0,j=0;const W=new Uint8Array(Math.floor(a.length/4*3)),J=ee=>{switch(D){case 3:W[j++]=h|ee,D=0;break;case 2:W[j++]=h|ee>>>2,h=ee<<6,D=3;break;case 1:W[j++]=h|ee>>>4,h=ee<<4,D=2;break;default:h=ee<<2,D=1}};for(let ee=0;ee<a.length;ee++){const ne=a.charCodeAt(ee);if(ne>=65&&ne<=90)J(ne-65);else if(ne>=97&&ne<=122)J(ne-97+26);else if(ne>=48&&ne<=57)J(ne-48+52);else if(ne===43||ne===45)J(62);else if(ne===47||ne===95)J(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ee]}`)}}const X=j;for(;D>0;)J(0);return N.wrap(W).slice(0,X)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},h=!0,D=!1){const j=D?o:r;let W="";const J=a.byteLength%3;let X=0;for(;X<a.byteLength-J;X+=3){const ee=a[X+0],ne=a[X+1],Q=a[X+2];W+=j[ee>>>2],W+=j[(ee<<4|ne>>>4)&63],W+=j[(ne<<2|Q>>>6)&63],W+=j[Q&63]}if(J===1){const ee=a[X+0];W+=j[ee>>>2],W+=j[ee<<4&63],h&&(W+="==")}else if(J===2){const ee=a[X+0],ne=a[X+1];W+=j[ee>>>2],W+=j[(ee<<4|ne>>>4)&63],W+=j[ne<<2&63],h&&(W+="=")}return W}e.encodeBase64=c}),define(Y[29],Z([0,1,5]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const g=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([v,f])=>{g[v]=f&&typeof f=="object"?O(f):f}),g}e.deepClone=O;function k(l){if(!l||typeof l!="object")return l;const g=[l];for(;g.length>0;){const v=g.shift();Object.freeze(v);for(const f in v)if(L.call(v,f)){const s=v[f];typeof s=="object"&&!Object.isFrozen(s)&&!(0,T.isTypedArray)(s)&&g.push(s)}}return l}e.deepFreeze=k;const L=Object.prototype.hasOwnProperty;function N(l,g){return P(l,g,new Set)}e.cloneAndChange=N;function P(l,g,v){if((0,T.isUndefinedOrNull)(l))return l;const f=g(l);if(typeof f<"u")return f;if(Array.isArray(l)){const s=[];for(const t of l)s.push(P(t,g,v));return s}if((0,T.isObject)(l)){if(v.has(l))throw new Error("Cannot clone recursive data-structure");v.add(l);const s={};for(const t in l)L.call(l,t)&&(s[t]=P(l[t],g,v));return v.delete(l),s}return l}function d(l,g,v=!0){return(0,T.isObject)(l)?((0,T.isObject)(g)&&Object.keys(g).forEach(f=>{f in l?v&&((0,T.isObject)(l[f])&&(0,T.isObject)(g[f])?d(l[f],g[f],v):l[f]=g[f]):l[f]=g[f]}),l):g}e.mixin=d;function u(l,g){if(l===g)return!0;if(l==null||g===null||g===void 0||typeof l!=typeof g||typeof l!="object"||Array.isArray(l)!==Array.isArray(g))return!1;let v,f;if(Array.isArray(l)){if(l.length!==g.length)return!1;for(v=0;v<l.length;v++)if(!u(l[v],g[v]))return!1}else{const s=[];for(f in l)s.push(f);s.sort();const t=[];for(f in g)t.push(f);if(t.sort(),!u(s,t))return!1;for(v=0;v<s.length;v++)if(!u(l[s[v]],g[s[v]]))return!1}return!0}e.equals=u;function m(l){const g=new Set;return JSON.stringify(l,(v,f)=>{if((0,T.isObject)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}e.safeStringify=m;function y(l,g){const v=Object.create(null);return!l||!g||Object.keys(g).forEach(s=>{const t=l[s],n=g[s];u(t,n)||(v[s]=n)}),v}e.distinct=y;function p(l,g){const v=g.toLowerCase(),f=Object.keys(l).find(s=>s.toLowerCase()===v);return f?l[f]:l[g]}e.getCaseInsensitive=p;function I(l,g){const v=Object.create(null);for(const[f,s]of Object.entries(l))g(f,s)&&(v[f]=s);return v}e.filter=I;function w(l){let g=[],v=Object.getPrototypeOf(l);for(;Object.prototype!==v;)g=g.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return g}e.getAllPropertyNames=w;function S(l){const g=[];for(const v of w(l))typeof l[v]=="function"&&g.push(v);return g}e.getAllMethodNames=S;function E(l,g){const v=s=>function(){const t=Array.prototype.slice.call(arguments,0);return g(s,t)},f={};for(const s of l)f[s]=v(s);return f}e.createProxyObject=E}),define(Y[30],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return T.test(k)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let d=0;d<P.length;d++)P[d]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),N=[];for(let P=0;P<256;P++)N.push(P.toString(16).padStart(2,"0"));return function(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let d=0,u="";return u+=N[L[d++]],u+=N[L[d++]],u+=N[L[d++]],u+=N[L[d++]],u+="-",u+=N[L[d++]],u+=N[L[d++]],u+="-",u+=N[L[d++]],u+=N[L[d++]],u+="-",u+=N[L[d++]],u+=N[L[d++]],u+="-",u+=N[L[d++]],u+=N[L[d++]],u+=N[L[d++]],u+=N[L[d++]],u+=N[L[d++]],u+=N[L[d++]],u}}()}),define(Y[72],Z([0,1,33]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(N){const P=N.replace(/\-/g,":").toLowerCase();return!O.has(P)}function L(){const N=(0,T.networkInterfaces)();for(const P in N){const d=N[P];if(d){for(const{mac:u}of d)if(k(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(Y[73],Z([6,7]),function($,e){return $.create("vs/base/common/date",e)}),define(Y[74],Z([0,1,73]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,k=O*60,L=k*24,N=L*7,P=L*30,d=L*365;function u(y,p,I){typeof y!="number"&&(y=y.getTime());const w=Math.round((new Date().getTime()-y)/1e3);if(w<-30)return(0,T.localize)(0,null,u(new Date().getTime()+w*1e3,!1));if(w<30)return(0,T.localize)(1,null);let S;return w<O?(S=w,p?S===1?I?(0,T.localize)(2,null,S):(0,T.localize)(3,null,S):I?(0,T.localize)(4,null,S):(0,T.localize)(5,null,S):S===1?I?(0,T.localize)(6,null,S):(0,T.localize)(7,null,S):I?(0,T.localize)(8,null,S):(0,T.localize)(9,null,S)):w<k?(S=Math.floor(w/O),p?S===1?I?(0,T.localize)(10,null,S):(0,T.localize)(11,null,S):I?(0,T.localize)(12,null,S):(0,T.localize)(13,null,S):S===1?I?(0,T.localize)(14,null,S):(0,T.localize)(15,null,S):I?(0,T.localize)(16,null,S):(0,T.localize)(17,null,S)):w<L?(S=Math.floor(w/k),p?S===1?I?(0,T.localize)(18,null,S):(0,T.localize)(19,null,S):I?(0,T.localize)(20,null,S):(0,T.localize)(21,null,S):S===1?I?(0,T.localize)(22,null,S):(0,T.localize)(23,null,S):I?(0,T.localize)(24,null,S):(0,T.localize)(25,null,S)):w<N?(S=Math.floor(w/L),p?S===1?(0,T.localize)(26,null,S):(0,T.localize)(27,null,S):S===1?(0,T.localize)(28,null,S):(0,T.localize)(29,null,S)):w<P?(S=Math.floor(w/N),p?S===1?I?(0,T.localize)(30,null,S):(0,T.localize)(31,null,S):I?(0,T.localize)(32,null,S):(0,T.localize)(33,null,S):S===1?I?(0,T.localize)(34,null,S):(0,T.localize)(35,null,S):I?(0,T.localize)(36,null,S):(0,T.localize)(37,null,S)):w<d?(S=Math.floor(w/P),p?S===1?I?(0,T.localize)(38,null,S):(0,T.localize)(39,null,S):I?(0,T.localize)(40,null,S):(0,T.localize)(41,null,S):S===1?I?(0,T.localize)(42,null,S):(0,T.localize)(43,null,S):I?(0,T.localize)(44,null,S):(0,T.localize)(45,null,S)):(S=Math.floor(w/d),p?S===1?I?(0,T.localize)(46,null,S):(0,T.localize)(47,null,S):I?(0,T.localize)(48,null,S):(0,T.localize)(49,null,S):S===1?I?(0,T.localize)(50,null,S):(0,T.localize)(51,null,S):I?(0,T.localize)(52,null,S):(0,T.localize)(53,null,S))}e.fromNow=u;function m(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=m}),define(Y[75],Z([6,7]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Y[34],Z([0,1,19,5,75]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(y,p){return p&&(y.stack||y.stacktrace)?k.localize(0,null,P(y),N(y.stack)||N(y.stacktrace)):P(y)}function N(y){return Array.isArray(y)?y.join(`
`):y}function P(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function d(y=null,p=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const I=T.coalesce(y),w=d(I[0],p);return I.length>1?k.localize(4,null,w,I.length):w}if(O.isString(y))return y;if(y.detail){const I=y.detail;if(I.error)return L(I.error,p);if(I.exception)return L(I.exception,p)}return y.stack?L(y,p):y.message?y.message:k.localize(5,null)}e.toErrorMessage=d;function u(y){const p=y;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=u;function m(y,p){let I;return typeof y=="string"?I=new Error(y):I=y,I.actions=p,I}e.createErrorWithActions=m}),define(Y[76],Z([6,7]),function($,e){return $.create("vs/base/common/jsonErrorMessages",e)}),define(Y[77],Z([0,1,76]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(k){switch(k){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(Y[51],Z([0,1,12]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(O=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(P,...d){const u=d.reduce((p,I)=>(p[I]=!0,p),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!u[p]).forEach(p=>{for(let I=0;I<m.length;I++)if(p.search(m[I])!==-1){delete P[p];break}})}e.sanitizeProcessEnvironment=L;function N(P){!P||(delete P.DEBUG,T.isMacintosh&&delete P.DYLD_LIBRARY_PATH,T.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(Y[52],Z([0,1,31]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(l){return k(l,0)}e.hash=O;function k(l,g){switch(typeof l){case"object":return l===null?L(349,g):Array.isArray(l)?d(l,g):u(l,g);case"string":return P(l,g);case"boolean":return N(l,g);case"number":return L(l,g);case"undefined":return L(937,g);default:return L(617,g)}}e.doHash=k;function L(l,g){return(g<<5)-g+l|0}e.numberHash=L;function N(l,g){return L(l?433:863,g)}function P(l,g){g=L(149417,g);for(let v=0,f=l.length;v<f;v++)g=L(l.charCodeAt(v),g);return g}e.stringHash=P;function d(l,g){return g=L(104579,g),l.reduce((v,f)=>k(f,v),g)}function u(l,g){return g=L(181387,g),Object.keys(l).sort().reduce((v,f)=>(v=P(f,v),k(l[f],v)),g)}class m{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=k(g,this.g),this.g}}e.Hasher=m;var y;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function p(l,g,v=32){const f=v-g,s=~((1<<f)-1);return(l<<g|(s&l)>>>f)>>>0}function I(l,g=0,v=l.byteLength,f=0){for(let s=0;s<v;s++)l[g+s]=f}function w(l,g,v="0"){for(;l.length<g;)l=v+l;return l}function S(l,g=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(v=>v.toString(16).padStart(2,"0")).join(""):w((l>>>0).toString(16),g/4)}e.toHexString=S;class E{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const v=g.length;if(v===0)return;const f=this.p;let s=this.r,t=this.u,n,i;for(t!==0?(n=t,i=-1,t=0):(n=g.charCodeAt(0),i=0);;){let r=n;if(T.isHighSurrogate(n))if(i+1<v){const o=g.charCodeAt(i+1);T.isLowSurrogate(o)?(i++,r=T.computeCodePoint(n,o)):r=65533}else{t=n;break}else T.isLowSurrogate(n)&&(r=65533);if(s=this.w(f,s,r),i++,i<v)n=g.charCodeAt(i);else break}this.r=s,this.u=t}w(g,v,f){return f<128?g[v++]=f:f<2048?(g[v++]=192|(f&1984)>>>6,g[v++]=128|(f&63)>>>0):f<65536?(g[v++]=224|(f&61440)>>>12,g[v++]=128|(f&4032)>>>6,g[v++]=128|(f&63)>>>0):(g[v++]=240|(f&1835008)>>>18,g[v++]=128|(f&258048)>>>12,g[v++]=128|(f&4032)>>>6,g[v++]=128|(f&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=E.g,v=this.q;for(let a=0;a<64;a+=4)g.setUint32(a,v.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,p(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let f=this.h,s=this.l,t=this.m,n=this.n,i=this.o,r,o,c;for(let a=0;a<80;a++)a<20?(r=s&t|~s&n,o=1518500249):a<40?(r=s^t^n,o=1859775393):a<60?(r=s&t|s&n|t&n,o=2400959708):(r=s^t^n,o=3395469782),c=p(f,5)+r+i+o+g.getUint32(a*4,!1)&4294967295,i=n,n=t,t=p(s,30),s=f,f=c;this.h=this.h+f&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=E,E.g=new DataView(new ArrayBuffer(320))}),define(Y[53],Z([0,1,31]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const L="error",N="warning",P="warn",d="info",u="ignore";function m(p){return p?T.equalsIgnoreCase(L,p)?k.Error:T.equalsIgnoreCase(N,p)||T.equalsIgnoreCase(P,p)?k.Warning:T.equalsIgnoreCase(d,p)?k.Info:k.Ignore:k.Ignore}k.fromValue=m;function y(p){switch(p){case k.Error:return L;case k.Warning:return N;case k.Info:return d;default:return u}}k.toString=y}(O||(O={})),e.default=O}),define(Y[78],Z([0,1,11]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(u){const m=u;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.isRemoteConsoleLog=O;function k(u){const m=[];let y;try{const p=JSON.parse(u.arguments),I=p[p.length-1];I&&I.__$stack&&(p.pop(),y=I.__$stack),m.push(...p)}catch{m.push("Unable to log remote console arguments",u.arguments)}return{args:m,stack:y}}e.parse=k;function L(u){if(typeof u!="string")return L(k(u).stack);const m=u;if(m){const y=N(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(p&&p.length===4)return{uri:T.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function N(u){if(!u)return u;const m=u.indexOf(`
`);return m===-1?u:u.substring(0,m)}function P(u,m){const{args:y,stack:p}=k(u),I=typeof y[0]=="string"&&y.length===1;let w=N(p);w&&(w=`(${w.trim()})`);let S=[];if(typeof y[0]=="string"?w&&I?S=[`%c[${m}] %c${y[0]} %c${w}`,d("blue"),d(""),d("grey")]:S=[`%c[${m}] %c${y[0]}`,d("blue"),d(""),...y.slice(1)]:S=[`%c[${m}]%`,d("blue"),...y],w&&!I&&S.push(w),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,S)}e.log=P;function d(u){return`color: ${u}`}}),define(Y[44],Z([0,1,15,31,11]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(u){return JSON.stringify(u,P)}e.stringify=L;function N(u){let m=JSON.parse(u);return m=d(m),m}e.parse=N;function P(u,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,O.regExpFlags)(m)}:m}function d(u,m=0){if(!u||m>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return k.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof T.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let y=0;y<u.length;++y)u[y]=d(u[y],m+1);else for(const y in u)Object.hasOwnProperty.call(u,y)&&(u[y]=d(u[y],m+1))}return u}e.revive=d}),define(Y[79],Z([0,1,33,10,54,30,72]),function($,e,T,O,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(m){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,y=0;const p=(0,T.networkInterfaces)();for(const I in p){const w=p[I];if(w)for(const{mac:S,internal:E}of w)E||(y+=1,this.c(S.toUpperCase())&&(m+=1))}this.b=y>0?m/y:0}return this.b}};let P;async function d(){return P||(P=(async()=>await u()||L.generateUuid())()),P}e.getMachineId=d;async function u(){try{const m=await new Promise((p,I)=>{$(["crypto"],p,I)}),y=(0,N.getMac)();return m.createHash("sha256").update(y,"utf8").digest("hex")}catch(m){O.onUnexpectedError(m);return}}}),define(Y[80],Z([0,1,33,14,20]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,N=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(d||(d={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class y{constructor(s,t,n){this.exePath=s,this.displayName=t,this.a=n}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:f=!1}={}){return f?u===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:f=!1,findPreview:s=!1}={}){const t=p({useAlternateBitness:f});if(!t)return null;const n=O.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(n))return null;let i=-1,r=null;for(const a of await k.Promises.readdir(n)){let h=-1;if(s){const j=a.indexOf("-");if(j<0)continue;const W=a.substring(0,j);if(!L.test(W)||a.substring(j+1)!=="preview")continue;h=parseInt(W,10)}else{if(!L.test(a))continue;h=parseInt(a,10)}if(h<=i)continue;const D=O.join(n,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(D)||(r=D,i=h)}if(!r)return null;const o=t.includes("x86")?" (x86)":"",c=s?" Preview":"";return new y(r,`PowerShell${c}${o}`,!0)}async function w({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const s=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(s))if(t.test(i)){const r=O.join(s,i,"pwsh.exe");return new y(r,n)}return null}function S(){const f=O.join(T.homedir(),".dotnet","tools","pwsh.exe");return new y(f,".NET Core PowerShell Global Tool")}function E(){const f=O.join(process.env.windir,u===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(f,"Windows PowerShell",!0)}async function*l(){let f=await I();f&&(yield f),f=await I({useAlternateBitness:!0}),f&&(yield f),f=await w(),f&&(yield f),f=S(),f&&(yield f),f=await I({findPreview:!0}),f&&(yield f),f=await w({findPreview:!0}),f&&(yield f),f=await I({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=E(),f&&(yield f)}async function*g(){for await(const f of l())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=g;async function v(){for await(const f of g())return f;return null}e.getFirstAvailablePowerShellInstallation=v}),define(Y[55],Z([0,1,14,12,35,51,5,20]),function($,e,T,O,k,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function d(y=k.env){return y.comspec||"cmd.exe"}e.getWindowsShell=d;function u(y){let p=[],I=!1;const w=function(S){if(I){p.push(S);return}(!y.send(S,l=>{if(l&&console.error(l),I=!1,p.length>0){const g=p.slice(0);p=[],g.forEach(v=>w(v))}})||O.isWindows)&&(I=!0)};return{send:w}}e.createQueuedSender=u;var m;(function(y){async function p(I,w,S){if(T.isAbsolute(I))return I;if(w===void 0&&(w=k.cwd()),T.dirname(I)!=="."||(S===void 0&&N.isString(k.env.PATH)&&(S=k.env.PATH.split(T.delimiter)),S===void 0||S.length===0))return T.join(w,I);async function l(g){if(await P.Promises.exists(g)){let v;try{v=await P.Promises.stat(g)}catch(f){f.message.startsWith("EACCES")&&(v=await P.Promises.lstat(g))}return v?!v.isDirectory():!1}return!1}for(const g of S){let v;if(T.isAbsolute(g)?v=T.join(g,I):v=T.join(w,g,I),await l(v))return v;let f=v+".com";if(await l(f)||(f=v+".exe",await l(f)))return f}return T.join(w,I)}y.findExecutable=p})(m=e.win32||(e.win32={}))}),define(Y[81],Z([0,1,33,12,80,55]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function N(I,w){return I===1?O.isWindows?y():L.getWindowsShell(w):u(I,w)}e.getSystemShell=N;function P(I,w){return I===1?O.isWindows?p(w):L.getWindowsShell(w):u(I,w)}e.getSystemShellSync=P;let d=null;function u(I,w){if(O.isLinux&&I===2||O.isMacintosh&&I===3)return"/bin/bash";if(!d){let S;if(O.isWindows)S="/bin/bash";else{if(S=w.SHELL,!S)try{S=(0,T.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}d=S}return d}let m=null;async function y(){return m||(m=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),m}function p(I){if(m)return m;const w=O.isWindows&&parseFloat((0,T.release)())>=10,S=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${I.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return w?E:L.getWindowsShell(I)}});var de=this&&this.__decorate||function($,e,T,O){var k=arguments.length,L=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,T):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($,e,T,O);else for(var P=$.length-1;P>=0;P--)(N=$[P])&&(L=(k<3?N(L):k>3?N(e,T,L):N(e,T))||L);return k>3&&L&&Object.defineProperty(e,T,L),L};define(Y[56],Z([0,1,19,3,15,22,49,10,4,2,44,31,5]),function($,e,T,O,k,L,N,P,d,u,m,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var I;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(I||(I={}));function w(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(S||(S={}));function E(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(l||(l={}));class g{constructor(A){this.b=A,this.a=0}read(A){const U=this.b.slice(this.a,this.a+A);return this.a+=U.byteLength,U}}class v{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(A){this.a.push(A)}}var f;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(f||(f={}));function s(M){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function t(M){return M.read(4).readUInt32BE(0)}function n(M){const A=k.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const i={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},r=typeof Buffer<"u";function o(M,A){if(typeof A>"u")M.write(i.Undefined);else if(typeof A=="string"){const U=k.VSBuffer.fromString(A);M.write(i.String),M.write(s(U.byteLength)),M.write(U)}else if(r&&Buffer.isBuffer(A)){const U=k.VSBuffer.wrap(A);M.write(i.Buffer),M.write(s(U.byteLength)),M.write(U)}else if(A instanceof k.VSBuffer)M.write(i.VSBuffer),M.write(s(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(i.Array),M.write(s(A.length));for(const U of A)o(M,U)}else{const U=k.VSBuffer.fromString(JSON.stringify(A));M.write(i.Object),M.write(s(U.byteLength)),M.write(U)}}function c(M){switch(M.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return M.read(t(M)).toString();case f.Buffer:return M.read(t(M)).buffer;case f.VSBuffer:return M.read(t(M));case f.Array:{const U=t(M),V=[];for(let G=0;G<U;G++)V.push(c(M));return V}case f.Object:return JSON.parse(M.read(t(M)).toString())}}class a{constructor(A,U,V=null,G=1e3){this.h=A,this.j=U,this.k=V,this.l=G,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.p(q)),this.m({type:200})}registerChannel(A,U){this.b.set(A,U),setTimeout(()=>this.v(A),0)}m(A){switch(A.type){case 200:{const U=this.n([A.type]);this.k?.logOutgoing(U,0,1,E(A.type));return}case 201:case 202:case 204:case 203:{const U=this.n([A.type,A.id],A.data);this.k?.logOutgoing(U,A.id,1,E(A.type),A.data);return}}}n(A,U=void 0){const V=new v;return o(V,A),o(V,U),this.o(V.buffer)}o(A){try{return this.h.send(A),A.byteLength}catch{return 0}}p(A){const U=new g(A),V=c(U),G=c(U),q=V[0];switch(q){case 100:return this.k?.logIncoming(A.byteLength,V[1],1,`${w(q)}: ${V[2]}.${V[3]}`,G),this.q({type:q,id:V[1],channelName:V[2],name:V[3],arg:G});case 102:return this.k?.logIncoming(A.byteLength,V[1],1,`${w(q)}: ${V[2]}.${V[3]}`,G),this.s({type:q,id:V[1],channelName:V[2],name:V[3],arg:G});case 101:return this.k?.logIncoming(A.byteLength,V[1],1,`${w(q)}`),this.t({type:q,id:V[1]});case 103:return this.k?.logIncoming(A.byteLength,V[1],1,`${w(q)}`),this.t({type:q,id:V[1]})}}q(A){const U=this.b.get(A.channelName);if(!U){this.u(A);return}const V=new L.CancellationTokenSource;let G;try{G=U.call(this.j,A.name,A.arg,V.token)}catch(b){G=Promise.reject(b)}const q=A.id;G.then(b=>{this.m({id:q,data:b,type:201}),this.d.delete(A.id)},b=>{b instanceof Error?this.m({id:q,data:{message:b.message,name:b.name,stack:b.stack?b.stack.split?b.stack.split(`
`):b.stack:void 0},type:202}):this.m({id:q,data:b,type:203}),this.d.delete(A.id)});const te=(0,u.toDisposable)(()=>V.cancel());this.d.set(A.id,te)}s(A){const U=this.b.get(A.channelName);if(!U){this.u(A);return}const V=A.id,q=U.listen(this.j,A.name,A.arg)(te=>this.m({id:V,data:te,type:204}));this.d.set(A.id,q)}t(A){const U=this.d.get(A.id);U&&(U.dispose(),this.d.delete(A.id))}u(A){let U=this.g.get(A.channelName);U||(U=[],this.g.set(A.channelName,U));const V=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.m({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);U.push({request:A,timeoutTimer:V})}v(A){const U=this.g.get(A);if(U){for(const V of U)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.q(V.request);break;case 102:this.s(V.request);break}this.g.delete(A)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=a;var h;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(A,U=null){this.l=A,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.r(V)),this.j=U}getChannel(A){const U=this;return{call(V,G,q){return U.a?Promise.reject(new P.CancellationError):U.m(A,V,G,q)},listen(V,G){return U.a?d.Event.None:U.n(A,V,G)}}}m(A,U,V,G=L.CancellationToken.None){const q=this.g++,b={id:q,type:100,channelName:A,name:U,arg:V};if(G.isCancellationRequested)return Promise.reject(new P.CancellationError);let R;return new Promise((F,B)=>{if(G.isCancellationRequested)return B(new P.CancellationError);const x=()=>{const ye=ae=>{switch(ae.type){case 201:this.f.delete(q),F(ae.data);break;case 202:{this.f.delete(q);const ue=new Error(ae.data.message);ue.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,ue.name=ae.data.name,B(ue);break}case 203:this.f.delete(q),B(ae.data);break}};this.f.set(q,ye),this.o(b)};let ie=null;this.b===l.Idle?x():(ie=(0,O.createCancelablePromise)(ye=>this.t()),ie.then(()=>{ie=null,x()}));const se=()=>{ie?(ie.cancel(),ie=null):this.o({id:q,type:101}),B(new P.CancellationError)},pe=G.onCancellationRequested(se);R=(0,u.combinedDisposable)((0,u.toDisposable)(se),pe),this.d.add(R)}).finally(()=>{this.d.delete(R)})}n(A,U,V){const G=this.g++,te={id:G,type:102,channelName:A,name:U,arg:V};let b=null;const R=new d.Emitter({onWillAddFirstListener:()=>{b=(0,O.createCancelablePromise)(F=>this.t()),b.then(()=>{b=null,this.d.add(R),this.o(te)})},onDidRemoveLastListener:()=>{b?(b.cancel(),b=null):(this.d.delete(R),this.o({id:G,type:103}))}}),C=F=>R.fire(F.data);return this.f.set(G,C),R.event}o(A){switch(A.type){case 100:case 102:{const U=this.p([A.type,A.id,A.channelName,A.name],A.arg);this.j?.logOutgoing(U,A.id,0,`${w(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const U=this.p([A.type,A.id]);this.j?.logOutgoing(U,A.id,0,w(A.type));return}}}p(A,U=void 0){const V=new v;return o(V,A),o(V,U),this.q(V.buffer)}q(A){try{return this.l.send(A),A.byteLength}catch{return 0}}r(A){const U=new g(A),V=c(U),G=c(U),q=V[0];switch(q){case 200:return this.j?.logIncoming(A.byteLength,0,0,E(q)),this.s({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(A.byteLength,V[1],0,E(q),G),this.s({type:V[0],id:V[1],data:G})}}s(A){if(A.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(A.id)?.(A)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}t(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.dispose)(this.d.values()),this.d.clear()}}de([N.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class j{get connections(){const A=[];return this.f.forEach(U=>A.push(U)),A}constructor(A){this.a=new Map,this.f=new Set,this.g=new d.Emitter,this.onDidAddConnection=this.g.event,this.h=new d.Emitter,this.onDidRemoveConnection=this.h.event,A(({protocol:U,onDidClientDisconnect:V})=>{d.Event.once(U.onMessage)(q=>{const te=new g(q),b=c(te),R=new a(U,b),C=new D(U);this.a.forEach((B,x)=>R.registerChannel(x,B));const F={channelServer:R,channelClient:C,ctx:b};this.f.add(F),this.g.fire(F),V(()=>{R.dispose(),C.dispose(),this.f.delete(F),this.h.fire(F)})})})}getChannel(A,U){const V=this;return{call(G,q,te){let b;if((0,p.isFunction)(U)){const C=(0,T.getRandomElement)(V.connections.filter(U));b=C?Promise.resolve(C):d.Event.toPromise(d.Event.filter(V.onDidAddConnection,U))}else b=U.routeCall(V,G,q);const R=b.then(C=>C.channelClient.getChannel(A));return J(R).call(G,q,te)},listen(G,q){if((0,p.isFunction)(U))return V.j(A,U,G,q);const te=U.routeEvent(V,G,q).then(b=>b.channelClient.getChannel(A));return J(te).listen(G,q)}}}j(A,U,V,G){const q=this;let te=new u.DisposableStore;const b=new d.Emitter({onWillAddFirstListener:()=>{te=new u.DisposableStore;const R=new d.EventMultiplexer,C=new Map,F=x=>{const se=x.channelClient.getChannel(A).listen(V,G),pe=R.add(se);C.set(x,pe)},B=x=>{const ie=C.get(x);!ie||(ie.dispose(),C.delete(x))};q.connections.filter(U).forEach(F),d.Event.filter(q.onDidAddConnection,U)(F,void 0,te),q.onDidRemoveConnection(B,void 0,te),R.event(b.fire,b,te),te.add(R)},onDidRemoveLastListener:()=>{te.dispose()}});return b.event}registerChannel(A,U){this.a.set(A,U),this.f.forEach(V=>{V.channelServer.registerChannel(A,U)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=j;class W{constructor(A,U,V=null){const G=new v;o(G,U),A.send(G.buffer),this.a=new D(A,V),this.d=new a(A,U,V)}getChannel(A){return this.a.getChannel(A)}registerChannel(A,U){this.d.registerChannel(A,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=W;function J(M){return{call(A,U,V){return M.then(G=>G.call(A,U,V))},listen(A,U){const V=new d.Relay;return M.then(G=>V.input=G.listen(A,U)),V.event}}}e.getDelayedChannel=J;function X(M){let A=!1;return{call(U,V,G){return A?M.call(U,V,G):(0,O.timeout)(0).then(()=>A=!0).then(()=>M.call(U,V,G))},listen(U,V){if(A)return M.listen(U,V);const G=new d.Relay;return(0,O.timeout)(0).then(()=>A=!0).then(()=>G.input=M.listen(U,V)),G.event}}}e.getNextTickChannel=X;class ee{constructor(A){this.a=A}routeCall(A){return this.b(A)}routeEvent(A){return this.b(A)}async b(A){for(const U of A.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await d.Event.toPromise(A.onDidAddConnection),await this.b(A)}}e.StaticRouter=ee;var ne;(function(M){function A(q,te){const b=q,R=te&&te.disableMarshalling,C=new Map;for(const F in b)V(F)&&C.set(F,d.Event.buffer(b[F],!0));return new class{listen(F,B,x){const ie=C.get(B);if(ie)return ie;if(G(B)){const se=b[B];if(typeof se=="function")return se.call(b,x)}throw new Error(`Event not found: ${B}`)}call(F,B,x){const ie=b[B];if(typeof ie=="function"){if(!R&&Array.isArray(x))for(let se=0;se<x.length;se++)x[se]=(0,m.revive)(x[se]);return ie.apply(b,x)}throw new Error(`Method not found: ${B}`)}}}M.fromService=A;function U(q,te){const b=te&&te.disableMarshalling;return new Proxy({},{get(R,C){if(typeof C=="string")return te?.properties?.has(C)?te.properties.get(C):G(C)?function(F){return q.listen(C,F)}:V(C)?q.listen(C):async function(...F){let B;te&&!(0,p.isUndefinedOrNull)(te.context)?B=[te.context,...F]:B=F;const x=await q.call(C,B);return b?x:(0,m.revive)(x)};throw new Error(`Property not found: ${String(C)}`)}})}M.toService=U;function V(q){return q[0]==="o"&&q[1]==="n"&&y.isUpperAsciiLetter(q.charCodeAt(2))}function G(q){return/^onDynamic/.test(q)&&y.isUpperAsciiLetter(q.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const A=M.toString();if(A!=="[object Object]")return A}return M}function ce(M){return Array.isArray(M)?M.map(ge):ge(M)}function re(M,A,U,V,G,q,te){te=ce(te);const b=Q[G],R=b[V%b.length];let C=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(q)?(C=C.concat(te),C.push(")")):C.push(te),console.log.apply(console,C)}class me{constructor(A,U){this.d=A,this.f=U,this.a=0,this.b=0}logOutgoing(A,U,V,G,q){this.b+=A,re(this.d,this.b,A,U,V,G,q)}logIncoming(A,U,V,G,q){this.a+=A,re(this.f,this.a,A,U,V,G,q)}}e.IPCLogger=me}),define(Y[82],Z([0,1,57,3,15,22,78,10,4,2,29,55,51,56]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends I.ChannelServer{constructor(l){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=w;class S{constructor(l,g){this.i=l,this.j=g,this.c=new Set,this.g=new Map,this.h=new d.Emitter,this.onDidProcessExit=this.h.event;const v=g&&g.timeout?g.timeout:6e4;this.b=new O.Delayer(v),this.d=null,this.f=null}getChannel(l){const g=this;return{call(v,f,s){return g.k(l,v,f,s)},listen(v,f){return g.l(l,v,f)}}}k(l,g,v,f=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const s=this.n(l),t=(0,O.createCancelablePromise)(r=>s.call(g,v,r)),n=f.onCancellationRequested(()=>t.cancel()),i=(0,u.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{n.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,g,v){if(!this.b)return d.Event.None;this.b.cancel();let f;const s=new d.Emitter({onWillAddFirstListener:()=>{f=this.n(l).listen(g,v)(s.fire,s),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,p.removeDangerousEnvVariables)(g.env),this.d=(0,T.fork)(this.i,l,g);const v=new d.Emitter;d.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,N.isRemoteConsoleLog)(o)){(0,N.log)(o,`IPC Library: ${this.j.serverName}`);return}v.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.j.useQueue?(0,y.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&s.send(o.buffer.toString("base64")),n=v.event,i={send:t,onMessage:n};this.f=new I.ChannelClient(i);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",r),this.c.forEach(a=>(0,u.dispose)(a)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(l){let g=this.g.get(l);return g||(g=this.m.getChannel(l),this.g.set(l,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=S}),define(Y[83],Z([0,1,3,4,2,5]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function P(y){const p=y;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var d;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class u extends k.Disposable{constructor(p,I=Object.create(null)){super(),this.m=p,this.n=I,this.b=this.B(new O.Emitter),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=new T.ThrottledDelayer(u.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(p=>this.r(p)))}r(p){p.changed?.forEach((I,w)=>this.s(w,I)),p.deleted?.forEach(I=>this.s(I,void 0))}s(p,I){if(this.c===d.Closed)return;let w=!1;(0,L.isUndefinedOrNull)(I)?w=this.f.delete(p):this.f.get(p)!==I&&(this.f.set(p,I),w=!0),w&&this.b.fire(p)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(p,I){const w=this.f.get(p);return(0,L.isUndefinedOrNull)(w)?I:w}getBoolean(p,I){const w=this.get(p);return(0,L.isUndefinedOrNull)(w)?I:w==="true"}getNumber(p,I){const w=this.get(p);return(0,L.isUndefinedOrNull)(w)?I:parseInt(w,10)}async set(p,I){if(this.c===d.Closed)return;if((0,L.isUndefinedOrNull)(I))return this.delete(p);const w=String(I);if(this.f.get(p)!==w)return this.f.set(p,w),this.j.set(p,w),this.h.delete(p),this.b.fire(p),this.w()}async delete(p){if(!(this.c===d.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire(p),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=d.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(p).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(p){if(!!this.u)return this.w(p)}async w(p){return this.g.trigger(()=>this.v(),p)}async whenFlushed(){if(!!this.u)return new Promise(p=>this.l.push(p))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=u,u.a=100;class m{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((I,w)=>this.a.set(w,I)),p.delete?.forEach(I=>this.a.delete(I))}async close(){}}e.InMemoryStorageDatabase=m}),define(Y[84],Z([6,7]),function($,e){return $.create("vs/base/node/zip",e)}),define(Y[85],Z([6,7]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Y[86],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Y[87],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Y[88],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Y[89],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Y[90],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Y[91],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Y[92],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Y[93],Z([6,7]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Y[94],Z([6,7]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Y[95],Z([6,7]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Y[96],Z([6,7]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Y[97],Z([6,7]),function($,e){return $.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Y[98],Z([6,7]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Y[99],Z([6,7]),function($,e){return $.create("vs/platform/shell/node/shellEnv",e)}),define(Y[100],Z([6,7]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Y[101],Z([6,7]),function($,e){return $.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Y[102],Z([6,7]),function($,e){return $.create("vs/platform/workspace/common/workspace",e)}),define(Y[103],Z([0,1,74,49,16,14,35,17,11]),function($,e,T,O,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,L.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return d.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(d.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=N.env.VSCODE_PORTABLE;return S?d.URI.file((0,L.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const S=this.args["extensions-download-dir"];return S?d.URI.file((0,L.resolve)(S)):d.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const E=N.env.VSCODE_EXTENSIONS;if(E)return E;const l=N.env.VSCODE_PORTABLE;return l?(0,L.join)(l,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(E=>/^[^:/?#]+?:\/\//.test(E)?d.URI.parse(E):d.URI.file((0,L.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?d.URI.parse(S):d.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(S=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(S))}get extensionLogLevel(){const S=[];for(const E of this.args.log||[]){const l=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(E);l&&l[1]&&l[2]&&S.push([l[1],l[2]])}return S.length?S:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return d.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=N.env.VSCODE_PORTABLE;return S?d.URI.file((0,L.join)(S,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(S){this.args.continueOn=S}get args(){return this.a}constructor(S,E,l){this.a=S,this.b=E,this.c=l,this.editSessionId=this.args.editSessionId}}de([O.memoize],u.prototype,"appRoot",null),de([O.memoize],u.prototype,"userHome",null),de([O.memoize],u.prototype,"userDataPath",null),de([O.memoize],u.prototype,"appSettingsHome",null),de([O.memoize],u.prototype,"tmpDir",null),de([O.memoize],u.prototype,"cacheHome",null),de([O.memoize],u.prototype,"stateResource",null),de([O.memoize],u.prototype,"userRoamingDataHome",null),de([O.memoize],u.prototype,"userDataSyncHome",null),de([O.memoize],u.prototype,"userDataSyncLogResource",null),de([O.memoize],u.prototype,"editSessionsLogResource",null),de([O.memoize],u.prototype,"sync",null),de([O.memoize],u.prototype,"machineSettingsResource",null),de([O.memoize],u.prototype,"workspaceStorageHome",null),de([O.memoize],u.prototype,"localHistoryHome",null),de([O.memoize],u.prototype,"keyboardLayoutResource",null),de([O.memoize],u.prototype,"argvResource",null),de([O.memoize],u.prototype,"isExtensionDevelopment",null),de([O.memoize],u.prototype,"untitledWorkspacesHome",null),de([O.memoize],u.prototype,"installSourcePath",null),de([O.memoize],u.prototype,"builtinExtensionsPath",null),de([O.memoize],u.prototype,"extensionsPath",null),de([O.memoize],u.prototype,"extensionDevelopmentLocationURI",null),de([O.memoize],u.prototype,"extensionDevelopmentKind",null),de([O.memoize],u.prototype,"extensionTestsLocationURI",null),de([O.memoize],u.prototype,"debugExtensionHost",null),de([O.memoize],u.prototype,"logLevel",null),de([O.memoize],u.prototype,"extensionLogLevel",null),de([O.memoize],u.prototype,"serviceMachineIdResource",null),de([O.memoize],u.prototype,"telemetryLogResource",null),de([O.memoize],u.prototype,"disableWorkspaceTrust",null),de([O.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function m(w,S){return I(w["inspect-extensions"],w["inspect-brk-extensions"],5870,S,w.debugId,w.extensionEnvironment)}e.parseExtensionHostPort=m;function y(w,S){return I(w["inspect-search"],w["inspect-brk-search"],5876,S,w.extensionEnvironment)}e.parseSearchPort=y;function p(w,S){return I(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,S,w.extensionEnvironment)}e.parsePtyHostPort=p;function I(w,S,E,l,g,v){const s=Number(S||w)||(l?null:E),t=s?Boolean(!!S):!1;let n;if(v)try{n=JSON.parse(v)}catch{}return{port:s,break:t,debugId:g,env:n}}}),function(){"use strict";function $(e,T,O){function k(N,P){const d=L(N,P),u=[d];return e.isAbsolute(d)||u.unshift(O),e.resolve(...u)}function L(N,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,P);const m=N["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(y,"AppData","Roaming")}break;case"darwin":u=e.join(T.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,P)}return{getUserDataPath:k}}if(typeof define=="function")define(Y[104],Z([154,33,35]),function(e,T,O){return $(e,T,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=$(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[105],Z([0,1,33,103,104]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends O.AbstractNativeEnvironmentService{constructor(P,d){super(P,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P,d.nameShort)},d)}}e.NativeEnvironmentService=L}),define(Y[106],Z([0,1,5,89]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(N,P,d){try{L(N,P,d)}catch(u){console.error(u?.message??u)}return N}e.localizeManifest=k;function L(N,P,d){const u=(m,y,p)=>{const I=m[y];if((0,T.isString)(I)){const w=I,S=w.length;if(S>1&&w[0]==="%"&&w[S-1]==="%"){const E=w.substr(1,S-2);let l=P[E];l===void 0&&d&&(l=d[E]);const g=typeof l=="string"?l:l?.message,v=d?.[E],f=typeof v=="string"?v:v?.message;if(!g){f||console.warn(`[${N.name}]: ${(0,O.localize)(0,null,E)}`);return}if(p&&(y==="title"||y==="category")&&f&&f!==g){const s={value:g,original:f};m[y]=s}else m[y]=g}}else if((0,T.isObject)(I))for(const w in I)I.hasOwnProperty(w)&&(w==="commands"?u(I,w,!0):u(I,w,p));else if(Array.isArray(I))for(let w=0;w<I.length;w++)u(I,w,p)};for(const m in N)N.hasOwnProperty(m)&&u(N,m)}}),define(Y[107],Z([0,1,10]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class O{constructor(){this.a=new Map}register(L,N){this.a.set(L,N)}updateManifest(L){if(!(!Array.isArray(L.activationEvents)||!L.contributes)&&!(typeof L.main>"u"&&typeof L.browser>"u"))for(const N in L.contributes){const P=this.a.get(N);if(!P)continue;const d=L.contributes[N],u=Array.isArray(d)?d:[d];try{P(u,L.activationEvents)}catch(m){(0,T.onUnexpectedError)(m)}}}}e.ImplicitActivationEventsImpl=O,e.ImplicitActivationEvents=new O}),define(Y[45],Z([0,1,17,53,93,39]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function d(l){return l=l.trim(),l==="*"||N.test(l)}e.isValidVersionStr=d;function u(l){if(!d(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=l.match(N);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=u;function m(l){if(!l)return null;const g=l.majorBase,v=l.majorMustEqual,f=l.minorBase;let s=l.minorMustEqual;const t=l.patchBase;let n=l.patchMustEqual;l.hasCaret&&(g===0||(s=!1),n=!1);let i=0;if(l.preRelease){const r=P.exec(l.preRelease);if(r){const[,o,c,a]=r;i=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:g,majorMustEqual:v,minorBase:f,minorMustEqual:s,patchBase:t,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:i}}e.normalizeVersion=m;function y(l,g,v){let f;typeof l=="string"?f=m(u(l)):f=l;let s;g instanceof Date?s=g.getTime():typeof g=="string"&&(s=new Date(g).getTime());let t;if(typeof v=="string"?t=m(u(v)):t=v,!f||!t)return!1;const n=f.majorBase,i=f.minorBase,r=f.patchBase;let o=t.majorBase,c=t.minorBase,a=t.patchBase;const h=t.notBefore;let D=t.majorMustEqual,j=t.minorMustEqual,W=t.patchMustEqual;return t.isMinimum?n>o?!0:n<o?!1:i>c?!0:i<c||s&&s<h?!1:r>=a:(n===1&&o===0&&(!D||!j||!W)&&(o=1,c=0,a=0,D=!0,j=!1,W=!1),n<o?!1:n>o?!D:i<c?!1:i>c?!j:r<a?!1:r>a?!W:!(s&&s<h))}e.isValidVersion=y;function p(l,g,v,f,s){const t=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return t.push([O.default.Error,k.localize(0,null)]),t;if(typeof f.name!="string")return t.push([O.default.Error,k.localize(1,null,"name")]),t;if(typeof f.version!="string")return t.push([O.default.Error,k.localize(2,null,"version")]),t;if(!f.engines)return t.push([O.default.Error,k.localize(3,null,"engines")]),t;if(typeof f.engines.vscode!="string")return t.push([O.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof f.extensionDependencies<"u"&&!E(f.extensionDependencies))return t.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof f.activationEvents<"u"){if(!E(f.activationEvents))return t.push([O.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof f.main>"u"&&typeof f.browser>"u")return t.push([O.default.Error,k.localize(7,null,"activationEvents","main")]),t}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&t.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return t.push([O.default.Error,k.localize(9,null,"main")]),t;{const r=(0,T.joinPath)(v,f.main);(0,T.isEqualOrParent)(r,v)||t.push([O.default.Warning,k.localize(10,null,r.path,v.path)])}if(typeof f.activationEvents>"u")return t.push([O.default.Error,k.localize(11,null,"activationEvents","main")]),t}if(typeof f.browser<"u"){if(typeof f.browser!="string")return t.push([O.default.Error,k.localize(12,null,"browser")]),t;{const r=(0,T.joinPath)(v,f.browser);(0,T.isEqualOrParent)(r,v)||t.push([O.default.Warning,k.localize(13,null,r.path,v.path)])}if(typeof f.activationEvents>"u")return t.push([O.default.Error,k.localize(14,null,"activationEvents","browser")]),t}if(!L.valid(f.version))return t.push([O.default.Error,k.localize(15,null)]),t;const n=[];if(!I(l,g,f,s,n))for(const r of n)t.push([O.default.Error,r]);return t}e.validateExtensionManifest=p;function I(l,g,v,f,s){return f||typeof v.main>"u"&&typeof v.browser>"u"?!0:S(l,g,v.engines.vscode,s)}e.isValidExtensionVersion=I;function w(l,g,v){return l==="*"||S(g,v,l)}e.isEngineValid=w;function S(l,g,v,f=[]){const s=m(u(v));if(!s)return f.push(k.localize(16,null,v)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return f.push(k.localize(17,null,v)),!1}else if(!s.majorMustEqual)return f.push(k.localize(18,null,v)),!1;return y(l,g,s)?!0:(f.push(k.localize(19,null,l,v)),!1)}function E(l){if(!Array.isArray(l))return!1;for(let g=0,v=l.length;g<v;g++)if(typeof l[g]!="string")return!1;return!0}}),define(Y[108],Z([0,1,15,30]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(L,N,P){let d=P&&P.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const m=(await N.readFile(L.serviceMachineIdResource)).value.toString();d=(0,O.isUUID)(m)?m:null}catch{d=null}if(!d){d=(0,O.generateUuid)();try{await N.writeFile(L.serviceMachineIdResource,T.VSBuffer.fromString(d))}catch{}}return P?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=k}),define(Y[46],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(k,L=[],N=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=T}),define(Y[109],Z([0,1,46]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var k;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function L(P,d,u){d instanceof T.SyncDescriptor||(d=new T.SyncDescriptor(d,[],Boolean(u))),O.push([P,d])}e.registerSingleton=L;function N(){return O}e.getSingletonServiceDescriptors=N}),define(Y[110],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(L,N){this.key=L,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class O{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const N of this.a.values())N.outgoing.size===0&&L.push(N);return L}insertEdge(L,N){const P=this.lookupOrInsertNode(L),d=this.lookupOrInsertNode(N);P.outgoing.set(d.key,d),d.incoming.set(P.key,P)}removeNode(L){const N=this.b(L);this.a.delete(N);for(const P of this.a.values())P.outgoing.delete(N),P.incoming.delete(N)}lookupOrInsertNode(L){const N=this.b(L);let P=this.a.get(N);return P||(P=new T(N,L),this.a.set(N,P)),P}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[N,P]of this.a)L.push(`${N}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,N]of this.a){const P=new Set([L]),d=this.c(N,P);if(d)return d}}c(L,N){for(const[P,d]of L.outgoing){if(N.has(P))return[...N,P].join(" -> ");N.add(P);const u=this.c(d,N);if(u)return u;N.delete(P)}}}e.Graph=O}),define(Y[21],Z([0,1,5,11,8]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof O.URI)}e.isConfigurationOverrides=L;function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=N;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function u(l,g){const v=Object.create(null);for(const f in l)m(v,f,l[f],g);return v}e.toValuesTree=u;function m(l,g,v,f){const s=g.split("."),t=s.pop();let n=l;for(let i=0;i<s.length;i++){const r=s[i];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${s.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[t]=v}catch{f(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=m;function y(l,g){const v=g.split(".");p(l,v)}e.removeFromValueTree=y;function p(l,g){const v=g.shift();if(g.length===0){delete l[v];return}if(Object.keys(l).indexOf(v)!==-1){const f=l[v];typeof f=="object"&&!Array.isArray(f)&&(p(f,g),Object.keys(f).length===0&&delete l[v])}}function I(l,g,v){function f(n,i){let r=n;for(const o of i){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=g.split("."),t=f(l,s);return typeof t>"u"?v:t}e.getConfigurationValue=I;function w(l,g,v){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in l?T.isObject(l[f])&&T.isObject(g[f])?w(l[f],g[f],v):v&&(l[f]=g[f]):l[f]=g[f])})}e.merge=w;function S(l,g,v){const f=l.inspect(g),s=l.inspect(v);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:f.defaultValue}e.getMigratedSettingValue=S;function E(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Y[58],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Y[18],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(Y[23],Z([0,1,87,8]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function N(l,g){switch(l){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function P(l,g){return g==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function d(l,g,v){return P(g,v)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===v?!0:u(v).includes(l)}e.isTargetPlatformCompatible=d;function u(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function m(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=m;var y;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var p;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var I;(function(l){l.Install="install",l.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var w;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var S;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(g,v){super(g),this.code=v,this.name=v}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Y[59],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((L,N)=>$(["node-vsce-sign"],async P=>L(P),N))),this.a}async verify(L,N){let P;try{P=await this.b()}catch{return!1}return P.verify(L,N)}}e.ExtensionSignatureVerificationService=O}),define(Y[60],Z([0,1,15,10,95,13]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(m,y,p,I,w,S){let E;try{await P(m,y,p,I,w,S)}catch(l){E=l}finally{E&&w.errorTransformer&&(E=w.errorTransformer(E)),typeof E<"u"&&p.error(E),p.end()}}e.readFileIntoStream=N;async function P(m,y,p,I,w,S){d(S);const E=await m.open(y,{create:!1});try{d(S);let l=0,g=0,v=w&&typeof w.length=="number"?w.length:void 0,f=T.VSBuffer.alloc(Math.min(w.bufferSize,typeof v=="number"?v:w.bufferSize)),s=w&&typeof w.position=="number"?w.position:0,t=0;do g=await m.read(E,s,f.buffer,t,f.byteLength-t),s+=g,t+=g,l+=g,typeof v=="number"&&(v-=g),t===f.byteLength&&(await p.write(I(f)),f=T.VSBuffer.alloc(Math.min(w.bufferSize,typeof v=="number"?v:w.bufferSize)),t=0);while(g>0&&(typeof v!="number"||v>0)&&d(S)&&u(l,w));if(t>0){let n=t;typeof v=="number"&&(n=Math.min(t,v)),p.write(I(f.slice(0,n)))}}catch(l){throw(0,L.ensureFileSystemProviderError)(l)}finally{await m.close(E)}}function d(m){if(m.isCancellationRequested)throw(0,O.canceled)();return!0}function u(m,y){if(y?.limits){if(typeof y.limits.memory=="number"&&m>y.limits.memory)throw(0,L.createFileSystemProviderError)((0,k.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&m>y.limits.size)throw(0,L.createFileSystemProviderError)((0,k.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[111],Z([0,1,4,155,2,12,156]),function($,e,T,O,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(u){const m=this.i(u),y=m.filter(I=>{const w=this.c.get(I.path);return w?!(0,O.patternsEquals)(w.request.excludes,I.excludes)||!(0,O.patternsEquals)(w.request.includes,I.includes):!0}),p=Array.from(this.c.values()).filter(({request:I})=>!m.find(w=>w.path===I.path&&(0,O.patternsEquals)(w.excludes,I.excludes)&&(0,O.patternsEquals)(w.includes,I.includes))).map(({request:I})=>I.path);y.length&&this.j(`Request to start watching: ${y.map(I=>`${I.path} (excludes: ${I.excludes.length>0?I.excludes:"<none>"}, includes: ${I.includes&&I.includes.length>0?JSON.stringify(I.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const I of p)this.h(I);for(const I of y)this.g(I)}g(u){const m=new N.NodeJSFileWatcherLibrary(u,p=>this.a.fire(p),p=>this.b.fire(p),this.f),y={request:u,instance:m};this.c.set(u.path,y)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const m=this.c.get(u);m&&(this.c.delete(u),m.instance.dispose())}i(u){const m=new Map;for(const y of u){const p=L.isLinux?y.path:y.path.toLowerCase();m.set(p,y)}return Array.from(m.values())}async setVerboseLogging(u){this.f=u;for(const[,m]of this.c)m.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,m){return m?`[File Watcher (node.js)] ${u} (path: ${m.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=P}),define(Y[112],Z([0,1,61,111]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends T.AbstractNonRecursiveWatcherClient{constructor(N,P,d){super(N,P,d),this.m()}l(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Y[113],Z([0,1,16,56,82,61]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends L.AbstractUniversalWatcherClient{constructor(d,u,m){super(d,u,m),this.m()}l(d){const u=d.add(new k.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(u.onDidProcessExit(({code:m,signal:y})=>this.n(`terminated by itself with code ${m}, signal: ${y}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(Y[62],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...k){this.a=new Map;for(const[L,N]of k)this.set(L,N)}set(k,L){const N=this.a.get(k);return this.a.set(k,L),N}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=T}),define(Y[114],Z([0,1,3,10,2,46,110,8,62,157]),function($,e,T,O,k,L,N,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class y extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class p{constructor(E=new d.ServiceCollection,l=!1,g,v=m){this.f=E,this.g=l,this.h=g,this.i=v,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=v?g?._globalGraph??new N.Graph(f=>f):void 0}createChild(E){return new p(E,this.g,this,this.i)}invokeFunction(E,...l){const g=w.traceInvocation(this.i,E);let v=!1;try{return E({get:s=>{if(v)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(s,g);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...l)}finally{v=!0,g.stop()}}createInstance(E,...l){let g,v;return E instanceof L.SyncDescriptor?(g=w.traceCreation(this.i,E.ctor),v=this.j(E.ctor,E.staticArguments.concat(l),g)):(g=w.traceCreation(this.i,E),v=this.j(E,l,g)),g.stop(),v}j(E,l=[],g){const v=P._util.getServiceDependencies(E).sort((t,n)=>t.index-n.index),f=[];for(const t of v){const n=this.m(t.id,g);n||this.u(`[createInstance] ${E.name} depends on UNKNOWN service ${t.id}.`,!1),f.push(n)}const s=v.length>0?v[0].index:l.length;if(l.length!==s){console.trace(`[createInstance] First service dependency of ${E.name} at position ${s+1} conflicts with ${l.length} static arguments`);const t=s-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,s)}return Reflect.construct(E,l.concat(f))}k(E,l){if(this.f.get(E)instanceof L.SyncDescriptor)this.f.set(E,l);else if(this.h)this.h.k(E,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(E){const l=this.f.get(E);return!l&&this.h?this.h.l(E):l}m(E,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const g=this.l(E);return g instanceof L.SyncDescriptor?this.q(E,g,l.branch(E,!0)):(l.branch(E,!1),g)}q(E,l,g){if(this.o.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.o.add(E);try{return this.r(E,l,g)}finally{this.o.delete(E)}}r(E,l,g){const v=new N.Graph(t=>t.id.toString());let f=0;const s=[{id:E,desc:l,_trace:g}];for(;s.length;){const t=s.pop();if(v.lookupOrInsertNode(t),f++>1e3)throw new y(v);for(const n of P._util.getServiceDependencies(t.desc.ctor)){const i=this.l(n.id);if(i||this.u(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),i instanceof L.SyncDescriptor){const r={id:n.id,desc:i,_trace:t._trace.branch(n.id,!0)};v.insertEdge(t,r),s.push(r)}}}for(;;){const t=v.roots();if(t.length===0){if(!v.isEmpty())throw new y(v);break}for(const{data:n}of t){if(this.l(n.id)instanceof L.SyncDescriptor){const r=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,r)}v.removeNode(n)}}return this.l(E)}s(E,l,g=[],v,f){if(this.f.get(E)instanceof L.SyncDescriptor)return this.t(E,l,g,v,f);if(this.h)return this.h.s(E,l,g,v,f);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(E,l,g=[],v,f){if(v){const s=new p(void 0,this.g,this,this.i);s.c=String(E);const t=new Map,n=new T.IdleValue(()=>{const i=s.j(l,g,f);for(const[r,o]of t){const c=i[r];if(typeof c=="function")for(const a of o)c.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=t.get(r);return a||(a=new u.LinkedList,t.set(r,a)),(D,j,W)=>{const J=a.push([D,j,W]);return(0,k.toDisposable)(J)}}if(r in i)return i[r];const o=n.value;let c=o[r];return typeof c!="function"||(c=c.bind(o),i[r]=c),c},set(i,r,o){return n.value[r]=o,!0},getPrototypeOf(i){return l.prototype}})}else return this.j(l,g,f)}u(E,l){if(l&&console.warn(E),this.g)throw new Error(E)}}e.InstantiationService=p;var I;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(I||(I={}));class w{static traceInvocation(E,l){return E?new w(1,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(E,l){return E?new w(0,l.name):w.c}constructor(E,l){this.type=E,this.name=l,this.g=Date.now(),this.h=[]}branch(E,l){const g=new w(2,E.toString());return this.h.push([E,l,g]),g}stop(){const E=Date.now()-this.g;w.f+=E;let l=!1;function g(f,s){const t=[],n=new Array(f+1).join("	");for(const[i,r,o]of s.h)if(r&&o){l=!0,t.push(`${n}CREATES -> ${i}`);const c=g(f+1,o);c&&t.push(c)}else t.push(`${n}uses -> ${i}`);return t.join(`
`)}const v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(E>2||l)&&w.all.add(v.join(`
`))}}e.Trace=w,w.all=new Set,w.c=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w.f=0});var _=this&&this.__param||function($,e){return function(T,O){e(T,O,$)}};define(Y[63],Z([0,1,22,2,12,97,23,8]),function($,e,T,O,k,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function d(m){return m.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=d,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let u=class extends O.Disposable{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new T.CancellationTokenSource;setTimeout(()=>y.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const w=p.firstPage.filter(S=>S.properties.localizedLanguages?.length&&S.tags.some(E=>E.startsWith("lp-"))).map(S=>{const E=S.properties.localizedLanguages?.[0],l=d(S);return{...this.f(l,E,S),extensionId:S.identifier.id,galleryExtension:S}});return w.push({...this.f("en","English"),extensionId:"default"}),w}f(y,p,I){const w=p??y;let S;if(w!==y&&(S=`(${y})`),y.toLowerCase()===k.language.toLowerCase()&&(S??="",S+=(0,L.localize)(0,null)),I?.installCount){S??="";const E=I.installCount;let l;E>1e6?l=`${Math.floor(E/1e5)/10}M`:E>1e3?l=`${Math.floor(E/1e3)}K`:l=String(E),S+=` $(cloud-download) ${l}`}return{id:y,label:w,description:S}}};u=de([_(0,N.IExtensionGalleryService)],u),e.LanguagePackBaseService=u}),define(Y[9],Z([0,1,34,4,2,36,12,11,8]),function($,e,T,O,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function u(){return new Date().toISOString()}var m;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function y(c,a,h){switch(a){case m.Trace:c.trace(h);break;case m.Debug:c.debug(h);break;case m.Info:c.info(h);break;case m.Warning:c.warn(h);break;case m.Error:c.error(h);break;case m.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=y;function p(c){let a="";for(let h=0;h<c.length;h++){let D=c[h];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}a+=(h>0?" ":"")+D}return a}e.format=p;class I extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new O.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==m.Off&&this.b<=a}}e.AbstractLogger=I;class w extends I{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...h){this.f(m.Trace)&&this.g(m.Trace,p([a,...h]))}debug(a,...h){this.f(m.Debug)&&this.g(m.Debug,p([a,...h]))}info(a,...h){this.f(m.Info)&&this.g(m.Info,p([a,...h]))}warn(a,...h){this.f(m.Warning)&&this.g(m.Warning,p([a,...h]))}error(a,...h){if(this.f(m.Error))if(a instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=a.stack,this.g(m.Error,p(D))}else this.g(m.Error,p([a,...h]))}flush(){}}e.AbstractMessageLogger=w;class S extends I{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!N.isWindows}trace(a,...h){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...h):console.log(`[main ${u()}]`,a,...h))}debug(a,...h){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...h):console.log(`[main ${u()}]`,a,...h))}info(a,...h){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...h):console.log(`[main ${u()}]`,a,...h))}warn(a,...h){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,a,...h):console.warn(`[main ${u()}]`,a,...h))}error(a,...h){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,a,...h):console.error(`[main ${u()}]`,a,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class E extends I{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...h){this.f(m.Trace)&&console.log("%cTRACE","color: #888",a,...h)}debug(a,...h){this.f(m.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...h)}info(a,...h){this.f(m.Info)&&console.log("%c INFO","color: #33f",a,...h)}warn(a,...h){this.f(m.Warning)&&console.log("%c WARN","color: #993",a,...h)}error(a,...h){this.f(m.Error)&&console.log("%c  ERR","color: #f33",a,...h)}dispose(){}flush(){}}e.ConsoleLogger=E;class l extends I{constructor(a,h=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(h)}trace(a,...h){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(a),...h])}debug(a,...h){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(a),...h])}info(a,...h){this.f(m.Info)&&this.g.log(m.Info,[this.h(a),...h])}warn(a,...h){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(a),...h])}error(a,...h){this.f(m.Error)&&this.g.log(m.Error,[this.h(a),...h])}h(a){return typeof a=="string"?a:(0,T.toErrorMessage)(a,this.f(m.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class g extends I{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const h of this.g)h.setLevel(a);super.setLevel(a)}trace(a,...h){for(const D of this.g)D.trace(a,...h)}debug(a,...h){for(const D of this.g)D.debug(a,...h)}info(a,...h){for(const D of this.g)D.info(a,...h)}warn(a,...h){for(const D of this.g)D.warn(a,...h)}error(a,...h){for(const D of this.g)D.error(a,...h)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=g;class v extends k.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...h){this.b.trace(a,...h)}debug(a,...h){this.b.debug(a,...h)}info(a,...h){this.b.info(a,...h)}warn(a,...h){this.b.warn(a,...h)}error(a,...h){this.b.error(a,...h)}flush(){this.b.flush()}}e.LogService=v;class f extends k.Disposable{constructor(a,h){super(),this.c=a,this.b=new L.ResourceMap,this.B(h(D=>this.setLevel(D)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,h,D){let j=this.b.get(a)?.logger;return j||(D=h?.always?m.Trace:D,j=this.f(a,D??this.c,h),this.b.set(a,{logger:j,logLevel:D})),j}setLevel(a,h){const D=P.URI.isUri(a)?a:void 0,j=D?h:a;if(D){const W=this.b.get(D);W&&W.logLevel!==j&&(W.logLevel=j,W.logger.setLevel(j))}else this.c=j,this.b.forEach(({logLevel:W,logger:J})=>{W===void 0&&J.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=f;class s{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(a){}getLevel(){return m.Info}trace(a,...h){}debug(a,...h){}info(a,...h){}warn(a,...h){}error(a,...h){}critical(a,...h){}dispose(){}flush(){}}e.NullLogger=s;class t extends s{}e.NullLogService=t;class n extends f{constructor(){super(m.Info,O.Event.None)}f(a,h,D){return new s}}e.NullLoggerService=n;function i(c){if(c.verbose)return m.Trace;if(typeof c.logLevel=="string"){const a=o(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function r(c){switch(c){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=r;function o(c){switch(c){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=o}),define(Y[115],Z([0,1,19,3,10,4,2,14,61,9]),function($,e,T,O,k,L,N,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends N.Disposable{constructor(p,I){super(),this.a=p,this.b=I,this.c=this.B(new L.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new L.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.ThrottledDelayer(0)),this.s=[],this.t=this.B(new O.ThrottledDelayer(0))}watch(p,I){return I.recursive||this.b?.watcher?.forceUniversal?this.l(p,I):this.u(p,I)}l(p,I){const w={path:this.C(p),excludes:I.excludes,includes:I.includes,recursive:I.recursive},S=(0,T.insert)(this.j,w);return this.m(),(0,N.toDisposable)(()=>{S(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,k.onUnexpectedError)(p))}n(){this.h||(this.h=this.B(this.p(I=>this.c.fire((0,d.toFileChanges)(I)),I=>this.z(I),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const I of this.j)(0,d.isRecursiveWatchRequest)(I)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const I of this.j)(0,d.isRecursiveWatchRequest)(I)&&p.includes(I.path)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,I){const w={path:this.C(p),excludes:I.excludes,includes:I.includes,recursive:!1},S=(0,T.insert)(this.s,w);return this.v(),(0,N.toDisposable)(()=>{S(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,k.onUnexpectedError)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,d.toFileChanges)(p)),p=>this.z(p),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.r.watch(this.s)}z(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}C(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=m}),define(Y[116],Z([0,1,19,3,15,22,4,52,64,2,54,16,117,17,43,94,13,60,9]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w,S,E,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends u.Disposable{constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new N.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new N.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new O.ResourceQueue)}registerProvider(s,t){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${s}`);const n=new u.DisposableStore;return this.h.set(s,t),this.c.fire({added:!0,scheme:s,provider:t}),n.add(t.onDidChangeFile(i=>this.Q.fire(new E.FileChangesEvent(i,!this.N(t))))),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(i=>this.R.fire(new Error(i)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:s}))),(0,u.toDisposable)(()=>{this.c.fire({added:!1,scheme:s,provider:t}),this.h.delete(s),(0,u.dispose)(n)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const t=[];this.f.fire({scheme:s,join(n){t.push(n)}}),!this.h.has(s)&&await O.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,t){const n=this.h.get(s.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return d.Iterable.map(this.h,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async j(s){if(!(0,I.isAbsolutePath)(s))throw new E.FileOperationError((0,S.localize)(0,null,this.mb(s)),8);await this.activateProvider(s.scheme);const t=this.h.get(s.scheme);if(!t){const n=new Error;throw n.name="ENOPRO",n.message=(0,S.localize)(1,null,s.toString()),n}return t}async k(s){const t=await this.j(s);if((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t)||(0,E.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(s){const t=await this.j(s);if((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.n(s,t)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,S.localize)(2,null,this.mb(s)),1):(0,E.ensureFileSystemProviderError)(n)}}async n(s,t){const n=await this.j(s),i=this.N(n),r=t?.resolveTo,o=t?.resolveSingleChildDescendants,c=t?.resolveMetadata,a=await n.stat(s);let h;return this.p(n,s,a,void 0,!!c,(D,j)=>(h||(h=m.TernarySearchTree.forUris(()=>!i),h.set(s,!0),r&&h.fill(!0,r)),h.get(D.resource)||h.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&o?j===1:!1))}async p(s,t,n,i,r,o){const{providerExtUri:c}=this.M(s),a={resource:t,name:c.basename(t),isFile:(n.type&E.FileType.File)!==0,isDirectory:(n.type&E.FileType.Directory)!==0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&E.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,E.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(a.isDirectory&&o(a,i)){try{const h=await s.readdir(t),D=await O.Promises.settled(h.map(async([j,W])=>{try{const J=c.joinPath(t,j),X=r?await s.stat(J):{type:W};return await this.p(s,J,X,h.length,r,o)}catch(J){return this.b.trace(J),null}}));a.children=(0,T.coalesce)(D)}catch(h){this.b.trace(h),a.children=[]}return a}return a}async resolveAll(s){return O.Promises.settled(s.map(async t=>{try{return{stat:await this.n(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.j(s),n=await t.stat(s);return this.p(t,s,n,void 0,!0,()=>!1)}async exists(s){const t=await this.j(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.r(s,t)}catch(n){return n}return!0}async r(s,t){if(!t?.overwrite&&await this.exists(s))throw new E.FileOperationError((0,S.localize)(3,null,this.mb(s)),3,t)}async createFile(s,t=k.VSBuffer.fromString(""),n){await this.r(s,n);const i=await this.writeFile(s,t);return this.m.fire(new E.FileOperationEvent(s,0,i)),i}async writeFile(s,t,n){const i=this.kb(await this.l(s),s),{providerExtUri:r}=this.M(i);try{await this.s(i,s,n)||await this.O(i,r.dirname(s));let c;if((0,E.hasReadWriteCapability)(i)&&!(t instanceof k.VSBuffer))if((0,w.isReadableStream)(t)){const a=await(0,w.peekStream)(t,3);a.ended?c=k.VSBuffer.concat(a.buffer):c=a}else c=(0,w.peekReadable)(t,a=>k.VSBuffer.concat(a),3);else c=t;!(0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)&&c instanceof k.VSBuffer?await this.bb(i,s,n,c):await this.X(i,s,n,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this.m.fire(new E.FileOperationEvent(s,4))}catch(o){throw new E.FileOperationError((0,S.localize)(4,null,this.mb(s),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async s(s,t,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,S.localize)(5,null,this.mb(t)));let r;try{r=await s.stat(t)}catch{return}if((r.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,S.localize)(6,null,this.mb(t)),0,n);if(this.lb(t,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:r.size}))throw new E.FileOperationError((0,S.localize)(7,null),3,n);return r}async readFile(s,t,n){const i=await this.k(s);return t?.atomic?this.t(i,s,t,n):this.u(i,s,t,n)}async t(s,t,n,i){return new Promise((r,o)=>{this.W.queueFor(t,this.M(s).providerExtUri).queue(async()=>{try{const c=await this.u(s,t,n,i);r(c)}catch(c){o(c)}})})}async u(s,t,n,i){const r=await this.v(s,t,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(s,t,n){const i=await this.k(s);return this.v(i,s,t,n)}async v(s,t,n,i){const r=new L.CancellationTokenSource(i),o=this.D(t,n).then(a=>a,a=>{throw r.cancel(),a});let c;try{return typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&await o,n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)||!((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasFileReadStreamCapability)(s))||(0,E.hasReadWriteCapability)(s)&&n?.preferUnbuffered?c=this.C(s,t,n):(0,E.hasFileReadStreamCapability)(s)?c=this.w(s,t,r.token,n):c=this.z(s,t,r.token,n),{...await o,value:c}}catch(a){c&&await(0,w.consumeStream)(c);const h=(0,S.localize)(8,null,this.mb(t),(0,E.ensureFileSystemProviderError)(a).toString());throw a instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(h,a.stat,n):new E.FileOperationError(h,(0,E.toFileOperationResult)(a),n)}}w(s,t,n,i=Object.create(null)){const r=s.readFileStream(t,i,n);return(0,w.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new E.FileOperationError((0,S.localize)(9,null,this.mb(t),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),i)},o=>k.VSBuffer.concat(o))}z(s,t,n,i=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,t,r,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>new E.FileOperationError((0,S.localize)(10,null,this.mb(t),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),i)},n),r}C(s,t,n){const i=(0,w.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)?r=await s.readFile(t,{atomic:!0}):r=await s.readFile(t),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.F(t,r.byteLength,n),i.end(k.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async D(s,t){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,S.localize)(11,null,this.mb(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==E.ETAG_DISABLED&&t.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,S.localize)(12,null),n,t);return this.F(s,n.size,t),n}F(s,t,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&t>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&t>n.limits.size&&(i=7),typeof i=="number")throw new E.FileOperationError((0,S.localize)(13,null,this.mb(s)),i)}}async canMove(s,t,n){return this.G(s,t,"move",n)}async canCopy(s,t,n){return this.G(s,t,"copy",n)}async G(s,t,n,i){if(s.toString()!==t.toString())try{const r=n==="move"?this.kb(await this.l(s),s):await this.k(s),o=this.kb(await this.l(t),t);await this.L(r,s,o,t,n,i)}catch(r){return r}return!0}async move(s,t,n){const i=this.kb(await this.l(s),s),r=this.kb(await this.l(t),t),o=await this.H(i,s,r,t,"move",!!n),c=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,o==="move"?2:3,c)),c}async copy(s,t,n){const i=await this.k(s),r=this.kb(await this.l(t),t),o=await this.H(i,s,r,t,"copy",!!n),c=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,o==="copy"?3:2,c)),c}async H(s,t,n,i,r,o){if(t.toString()===i.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.L(s,t,n,i,r,o);if(c&&!a&&o&&await this.del(i,{recursive:!0}),await this.O(n,this.M(n).providerExtUri.dirname(i)),r==="copy"){if(s===n&&(0,E.hasFileFolderCopyCapability)(s))await s.copy(t,i,{overwrite:o});else{const h=await this.resolve(t);h.isDirectory?await this.J(s,h,n,i):await this.I(s,t,n,i)}return r}else return s===n?(await s.rename(t,i,{overwrite:o}),r):(await this.H(s,t,n,i,"copy",o),await this.del(t,{recursive:!0}),"copy")}async I(s,t,n,i){if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.db(s,t,n,i);if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.jb(s,t,n,i);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.hb(s,t,n,i);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.fb(s,t,n,i)}async J(s,t,n,i){await n.mkdir(i),Array.isArray(t.children)&&await O.Promises.settled(t.children.map(async r=>{const o=this.M(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.J(s,await this.resolve(r.resource),n,o):this.I(s,r.resource,n,o)}))}async L(s,t,n,i,r,o){let c=!1;if(s===n){const{providerExtUri:h,isPathCaseSensitive:D}=this.M(s);if(D||(c=h.isEqual(t,i)),c&&r==="copy")throw new Error((0,S.localize)(14,null,this.mb(t),this.mb(i)));if(!c&&h.isEqualOrParent(i,t))throw new Error((0,S.localize)(15,null,this.mb(t),this.mb(i)))}const a=await this.exists(i);if(a&&!c){if(!o)throw new E.FileOperationError((0,S.localize)(16,null,this.mb(t),this.mb(i)),4);if(s===n){const{providerExtUri:h}=this.M(s);if(h.isEqualOrParent(t,i))throw new Error((0,S.localize)(17,null,this.mb(t),this.mb(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}M(s){const t=this.N(s);return{providerExtUri:t?I.extUri:I.extUriIgnorePathCase,isPathCaseSensitive:t}}N(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.kb(await this.j(s),s);await this.O(t,s);const n=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,0,n)),n}async O(s,t){const n=[],{providerExtUri:i}=this.M(s);for(;!i.isEqual(t,i.dirname(t));)try{if(((await s.stat(t)).type&E.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.mb(t)));break}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(t)),t=i.dirname(t)}for(let r=n.length-1;r>=0;r--){t=i.joinPath(t,n[r]);try{await s.mkdir(t)}catch(o){if((0,E.toFileSystemProviderErrorCode)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,t){try{await this.P(s,t)}catch(n){return n}return!0}async P(s,t){const n=this.kb(await this.j(s),s);if(!!t?.useTrash&&!(n.capabilities&4096))throw new Error((0,S.localize)(19,null,this.mb(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.lb(s,r);else throw new E.FileOperationError((0,S.localize)(20,null,this.mb(s)),1);if(!!!t?.recursive){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,S.localize)(21,null,this.mb(s)))}return n}async del(s,t){const n=await this.P(s,t),i=!!t?.useTrash,r=!!t?.recursive;await n.delete(s,{recursive:r,useTrash:i}),this.m.fire(new E.FileOperationEvent(s,1))}async cloneFile(s,t){const n=await this.j(s),i=this.kb(await this.l(t),t);if(n===i&&this.M(n).providerExtUri.isEqual(s,t))return;if(n===i&&(0,E.hasFileCloneCapability)(n))return n.cloneFile(s,t);await this.O(i,this.M(i).providerExtUri.dirname(t));const r=this.W.queueFor(s,this.M(n).providerExtUri);return n===i&&(0,E.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,t,{overwrite:!0})):r.queue(()=>this.I(n,s,i,t))}watch(s,t={recursive:!1,excludes:[]}){const n=new u.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,u.toDisposable)(()=>r())),(async()=>{try{const o=await this.U(s,t);i?(0,u.dispose)(o):r=()=>(0,u.dispose)(o)}catch(o){this.b.error(o)}})(),n}async U(s,t){const n=await this.j(s),i=(0,P.hash)([this.M(n).providerExtUri.getComparisonKey(s),t]);let r=this.S.get(i);return r||(r={count:0,disposable:n.watch(s,t)},this.S.set(i,r)),r.count+=1,(0,u.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,u.dispose)(r.disposable),this.S.delete(i)))})}dispose(){super.dispose();for(const[,s]of this.S)(0,u.dispose)(s.disposable);this.S.clear()}async X(s,t,n,i){return this.W.queueFor(t,this.M(s).providerExtUri).queue(async()=>{const r=await s.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,w.isReadableStream)(i)||(0,w.isReadableBufferedStream)(i)?await this.Y(s,r,i):await this.Z(s,r,i)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async Y(s,t,n){let i=0,r;if((0,w.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=k.VSBuffer.concat(n.buffer);await this.ab(s,t,o,o.byteLength,i,0),i+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,c)=>{(0,w.listenStream)(r,{onData:async a=>{r.pause();try{await this.ab(s,t,a,a.byteLength,i,0)}catch(h){return c(h)}i+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>c(a),onEnd:()=>o()})})}async Z(s,t,n){let i=0,r;for(;(r=n.read())!==null;)await this.ab(s,t,r,r.byteLength,i,0),i+=r.byteLength}async ab(s,t,n,i,r,o){let c=0;for(;c<i;)c+=await s.write(t,r+c,n.buffer,o+c,i-c)}async bb(s,t,n,i){return this.W.queueFor(t,this.M(s).providerExtUri).queue(()=>this.cb(s,t,n,i))}async cb(s,t,n,i){let r;i instanceof k.VSBuffer?r=i:(0,w.isReadableStream)(i)?r=await(0,k.streamToBuffer)(i):(0,w.isReadableBufferedStream)(i)?r=await(0,k.bufferedStreamToBuffer)(i):r=(0,k.readableToBuffer)(i),await s.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async db(s,t,n,i){return this.W.queueFor(i,this.M(n).providerExtUri).queue(()=>this.eb(s,t,n,i))}async eb(s,t,n,i){let r,o;try{r=await s.open(t,{create:!1}),o=await n.open(i,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.a);let a=0,h=0,D=0;do D=await s.read(r,a,c.buffer,h,c.byteLength-h),await this.ab(n,o,c,D,a,h),a+=D,h+=D,h===c.byteLength&&(h=0);while(D>0)}catch(c){throw(0,E.ensureFileSystemProviderError)(c)}finally{await O.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async fb(s,t,n,i){return this.W.queueFor(i,this.M(n).providerExtUri).queue(()=>this.gb(s,t,n,i))}async gb(s,t,n,i){return n.writeFile(i,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async hb(s,t,n,i){return this.W.queueFor(i,this.M(n).providerExtUri).queue(()=>this.ib(s,t,n,i))}async ib(s,t,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(t);await this.ab(n,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async jb(s,t,n,i){const r=await(0,k.streamToBuffer)(this.z(s,t,L.CancellationToken.None));await this.bb(n,i,void 0,r)}kb(s,t){if(s.capabilities&2048)throw new E.FileOperationError((0,S.localize)(22,null,this.mb(t)),6);return s}lb(s,t){if((t.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,S.localize)(23,null,this.mb(s)),6)}mb(s){return s.scheme===y.Schemas.file?s.fsPath:s.toString(!0)}};v=de([_(0,g.ILogService)],v),e.FileService=v}),define(Y[118],Z([0,1,119,158,3,36,15,4,159,2,14,12,17,43,20,96,13,60,115,34,113,112]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w,S,E,l,g,v,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(T)}catch(n){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(n)}`)}})();class t extends g.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=P.Event.None,this.H=new L.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,y.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:r,symbolicLink:o}=await w.SymlinkSupport.stat(this.C(i));return{type:this.G(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.Y(r)}}async readdir(i){try{const r=await w.Promises.readdir(this.C(i),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,p.joinPath)(i,c.name))).type:a=this.G(c),o.push([c.name,a])}catch(a){this.a.trace(a)}})),o}catch(r){throw this.Y(r)}}G(i,r){let o;return r?.dangling?o=E.FileType.Unknown:i.isFile()?o=E.FileType.File:i.isDirectory()?o=E.FileType.Directory:o=E.FileType.Unknown,r&&(o|=E.FileType.SymbolicLink),o}async I(i){const r=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const c=new k.Barrier;return this.H.set(i,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,u.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.H.get(i)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(i,r){let o;try{r?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),o=await this.I(i));const c=this.C(i);return await w.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{o?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,r,o){const c=(0,I.newWriteableStream)(a=>N.VSBuffer.concat(a.map(h=>N.VSBuffer.wrap(h))).buffer);return(0,l.readFileIntoStream)(this,i,c,a=>a.buffer,{...r,bufferSize:256*1024},o),c}async writeFile(i,r,o){let c;try{const a=this.C(i);if(!o.create||!o.overwrite){if(await w.Promises.exists(a)){if(!o.overwrite)throw(0,E.createFileSystemProviderError)((0,S.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,E.createFileSystemProviderError)((0,S.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(i){t.O=i}async open(i,r){const o=this.C(i);let c;(0,E.isFileOpenForWriteOptions)(r)&&(c=await this.I(i));let a;try{if((0,E.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:D}=await w.SymlinkSupport.stat(o);D.mode&128||await w.Promises.chmod(o,D.mode|128)}catch(D){this.a.trace(D)}let h;if((0,E.isFileOpenForWriteOptions)(r)){if(y.isWindows)try{await w.Promises.truncate(o,0),h="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}h||(h="w")}else h="r";a=await w.Promises.open(o,h)}catch(h){throw c?.dispose(),(0,E.isFileOpenForWriteOptions)(r)?await this.Z(i,h):this.Y(h)}if(this.L.set(a,0),(0,E.isFileOpenForWriteOptions)(r)&&this.N.set(a,i),c){const h=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.M.set(a,c),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),h.dispose())}return a}async close(i){const r=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await w.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await w.Promises.close(i)}catch(o){throw this.Y(o)}finally{r&&(this.M.get(i)===r&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,o,c,a){const h=this.P(i,r);let D=null;try{D=(await w.Promises.read(i,o,c,a,h)).bytesRead}catch(j){throw this.Y(j)}finally{this.Q(i,h,D)}return D}P(i,r){return r===this.L.get(i)?null:r}Q(i,r,o){const c=this.L.get(i);typeof c=="number"&&(typeof r=="number"||(typeof o=="number"?this.L.set(i,c+o):this.L.delete(i)))}async write(i,r,o,c,a){return(0,k.retry)(()=>this.R(i,r,o,c,a),100,3)}async R(i,r,o,c,a){const h=this.P(i,r);let D=null;try{D=(await w.Promises.write(i,o,c,a,h)).bytesWritten}catch(j){throw await this.Z(this.N.get(i),j)}finally{this.Q(i,h,D)}return D}async mkdir(i){try{await w.Promises.mkdir(this.C(i))}catch(r){throw this.Y(r)}}async delete(i,r){try{const o=this.C(i);r.recursive?await w.Promises.rm(o,w.RimRafMode.MOVE):await w.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(i,r,o){const c=this.C(i),a=this.C(r);if(c!==a)try{await this.S(i,r,"move",o.overwrite),await w.Promises.move(c,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(2,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(a)),h.toString()))),this.Y(h)}}async copy(i,r,o){const c=this.C(i),a=this.C(r);if(c!==a)try{await this.S(i,r,"copy",o.overwrite),await w.Promises.copy(c,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(3,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(a)),h.toString()))),this.Y(h)}}async S(i,r,o,c){const a=this.C(i),h=this.C(r);let D=!1;if(!!(this.capabilities&1024)||(D=(0,d.isEqual)(a,h,!0)),D&&o==="copy")throw(0,E.createFileSystemProviderError)((0,S.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!D&&await w.Promises.exists(h)){if(!c)throw(0,E.createFileSystemProviderError)((0,S.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.U(i,r,!1)}async U(i,r,o){const c=this.C(i),a=this.C(r),h=!!(this.capabilities&1024);if((0,d.isEqual)(c,a,!h))return;const D=new u.DisposableStore;try{const[j,W]=await Promise.all([this.I(i),this.I(r)]);D.add(j),D.add(W),o&&await w.Promises.mkdir((0,m.dirname)(a),{recursive:!0}),await w.Promises.copyFile(c,a)}catch(j){if(j.code==="ENOENT"&&!o)return this.U(i,r,!0);throw this.Y(j)}finally{D.dispose()}}p(i,r,o){return new f.UniversalWatcherClient(c=>i(c),c=>r(c),o)}y(i,r,o){return new s.NodeJSWatcherClient(c=>i(c),c=>r(c),o)}Y(i){if(i instanceof E.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=E.FileSystemProviderErrorCode.NoPermissions;break;default:r=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(i,r)}async Z(i,r){let o=this.Y(r);if(i&&o.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await w.SymlinkSupport.stat(this.C(i));c.mode&128||(o=(0,E.createFileSystemProviderError)(r,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(Y[120],Z([0,1,13,9]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(k||(k={}));async function L(u,m,y,p,I){try{const w=await new Promise((E,l)=>{$(["spdlog"],E,l)});w.setFlushOn(k.Trace);const S=await w.createAsyncRotatingLogger(u,m,y,p);return I?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(w){console.error(w)}return null}function N(u,m,y){switch(m){case O.LogLevel.Trace:u.trace(y);break;case O.LogLevel.Debug:u.debug(y);break;case O.LogLevel.Info:u.info(y);break;case O.LogLevel.Warning:u.warn(y);break;case O.LogLevel.Error:u.error(y);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function P(u,m){switch(m){case O.LogLevel.Trace:u.setLevel(k.Trace);break;case O.LogLevel.Debug:u.setLevel(k.Debug);break;case O.LogLevel.Info:u.setLevel(k.Info);break;case O.LogLevel.Warning:u.setLevel(k.Warning);break;case O.LogLevel.Error:u.setLevel(k.Error);break;case O.LogLevel.Off:u.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class d extends O.AbstractMessageLogger{constructor(m,y,p,I,w){super(),this.k=[],this.setLevel(w),this.l=this.n(m,y,p,I),this.B(this.onDidChangeLogLevel(S=>{this.m&&P(this.m,S)}))}async n(m,y,p,I){const w=p?6:1,S=30/w*T.ByteSize.MB,E=await L(m,y,S,w,I);if(E){this.m=E,P(this.m,this.getLevel());for(const{level:l,message:g}of this.k)N(this.m,l,g);this.k=[]}}g(m,y){this.m?N(this.m,m,y):this.getLevel()<=m&&this.k.push({level:m,message:y})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=d}),define(Y[38],Z([0,1,4,64,2,8]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class N extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const m=Object.keys(this.f).length;return this.f={...u,...this.f},m!==Object.keys(this.f).length&&await this.i(u),O.Iterable.reduce(this.g.entries(),(y,[p,I])=>({...y,[p]:I}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(u,[m,y])=>({...u,[m]:{definition:y,value:this.g.get(m)}}),{})}}e.AbstractPolicyService=N;class P{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(Y[121],Z([0,1,3,4,64,5,13,9,38]),function($,e,T,O,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(y,p){const I=[];for(const w of k.Iterable.concat(y.keys(),p.keys()))y.get(w)!==p.get(w)&&I.push(w);return I}let m=class extends d.AbstractPolicyService{constructor(p,I,w){super(),this.j=p,this.k=I,this.l=w,this.c=this.B(new T.ThrottledDelayer(500));const S=O.Event.filter(I.onDidFilesChange,E=>E.affects(p));this.B(I.watch(p)),this.B(S(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const p=new Map;try{const I=await this.k.readFile(this.j),w=JSON.parse(I.value.toString());if(!(0,L.isObject)(w))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(w))this.f[S]&&p.set(S,w[S])}catch(I){I.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",I)}return p}async p(){const p=await this.n(),I=u(this.g,p);this.g=p,I.length>0&&this.h.fire(I)}};m=de([_(1,N.IFileService),_(2,P.ILogService)],m),e.FilePolicyService=m}),define(Y[26],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Y[37],Z([0,1,70,5]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(N,P){T.ok(O.isString(N)),T.ok(O.isObject(P)),T.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,P)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new k}),define(Y[122],Z([0,1,4,37]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,u){this.a[k(d)]=u,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const N=new L;O.Registry.add(e.Extensions.JSONContribution,N)}),define(Y[40],Z([0,1,19,4,5,85,21,122,37]),function($,e,T,O,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=d.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.Emitter,this.onDidSchemaChange=this.i.event,this.j=new O.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const i=this.k(t,n);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const n=this.l(t);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const i=[];i.push(...this.l(n)),i.push(...this.k(t,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,T.distinct)(i)})}registerDefaultConfigurations(t){const n=[],i=[];for(const{overrides:r,source:o}of t)for(const c in r)if(n.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.a.get(c),h=a?.valuesSources??new Map;if(o)for(const J of Object.keys(r[c]))h.set(J,o);const D={...a?.value||{},...r[c]};this.a.set(c,{source:o,value:D,valuesSources:h});const j=(0,N.getLanguageTagSettingPlainKey)(c),W={type:"object",default:D,description:L.localize(1,null,j),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:k.isString(o)?void 0:o,defaultValueSource:o};i.push(...S(c)),this.d[c]=W,this.b.properties[c]=W}else{this.a.set(c,{value:r[c],source:o});const a=this.d[c];a&&(this.s(c,a),this.o(c,a))}this.registerOverrideIdentifiers(i),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const n=[];for(const{overrides:i,source:r}of t)for(const o in i){const c=this.a.get(o),a=k.isString(r)?r:r?.id,h=k.isString(c?.source)?c?.source:c?.source?.id;if(a===h)if(n.push(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const D=this.d[o];D&&(this.s(o,D),this.o(o,D))}}this.q(),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){for(const n of t)this.h.add(n);this.q()}k(t,n){const i=[];return t.forEach(r=>{i.push(...this.m(r,n,r.extensionInfo,r.restrictedProperties)),this.c.push(r),this.n(r)}),i}l(t){const n=[],i=r=>{if(r.properties)for(const o in r.properties){n.push(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.p(o,r.properties[o])}r.allOf?.forEach(o=>i(o))};for(const r of t){i(r);const o=this.c.indexOf(r);o!==-1&&this.c.splice(o,1)}return n}m(t,n=!0,i,r,o=3){o=k.isUndefinedOrNull(t.scope)?o:t.scope;const c=[],a=t.properties;if(a)for(const D in a){const j=a[D];if(n&&v(D,j)){delete a[D];continue}if(j.source=i,j.defaultDefaultValue=a[D].default,this.s(D,j),e.OVERRIDE_PROPERTY_REGEX.test(D)?j.scope=void 0:(j.scope=k.isUndefinedOrNull(j.scope)?o:j.scope,j.restricted=k.isUndefinedOrNull(j.restricted)?!!r?.includes(D):j.restricted),a[D].hasOwnProperty("included")&&!a[D].included){this.f[D]=a[D],delete a[D];continue}else this.d[D]=a[D],a[D].policy?.name&&this.e.set(a[D].policy.name,D);!a[D].deprecationMessage&&a[D].markdownDeprecationMessage&&(a[D].deprecationMessage=a[D].markdownDeprecationMessage),c.push(D)}const h=t.allOf;if(h)for(const D of h)c.push(...this.m(D,n,i,r,o));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(t){const n=i=>{const r=i.properties;if(r)for(const c in r)this.o(c,r[c]);i.allOf?.forEach(n)};n(t)}o(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.g.properties[t]=n;break}}p(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}q(){for(const t of this.h.values()){const n=`[${t}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(n,i),e.allSettings.properties[n]=i,e.applicationSettings.properties[n]=i,e.machineSettings.properties[n]=i,e.machineOverridableSettings.properties[n]=i,e.windowSettings.properties[n]=i,e.resourceSettings.properties[n]=i}this.i.fire()}r(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}s(t,n){const i=this.a.get(t);let r=i?.value,o=i?.source;k.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),k.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const I="\\[([^\\]]+)\\]",w=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(s){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=w.exec(s);for(;n?.length;){const i=n[1].trim();i&&t.push(i),n=w.exec(s)}}return(0,T.distinct)(t)}e.overrideIdentifiersFromKey=S;function E(s){return s.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=E;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const g=new p;d.Registry.add(e.Extensions.Configuration,g);function v(s,t){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?L.localize(7,null,s):g.getConfigurationProperties()[s]!==void 0?L.localize(8,null,s):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,s,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=v;function f(){const s=[],t=g.getConfigurationProperties();for(const n of Object.keys(t))s.push([n,t[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=f}),define(Y[65],Z([0,1,19,4,50,2,36,29,5,11,21,40,37]),function($,e,T,O,k,L,N,P,d,u,m,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(n={},i=[],r=[],o){this.c=n,this.d=i,this.f=r,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof I)return i;const r=new w("");return r.parseRaw(i),r.configurationModel});this.g=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(n){return n?(0,m.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),o=i?this.rawConfiguration.getOverrideValue(n,i):void 0,c=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:o,merged:c}}getOverrideValue(n,i){const r=this.l(i);return r?n?(0,m.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return T.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return T.distinct(n)}override(n){let i=this.b.get(n);return i||(i=this.h(n),this.b.set(n,i)),i}merge(...n){const i=P.deepClone(this.contents),r=P.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of n)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(i,a.contents);for(const h of a.overrides){const[D]=r.filter(j=>T.equals(j.identifiers,h.identifiers));D?(this.j(D.contents,h.contents),D.keys.push(...h.keys),D.keys=T.distinct(D.keys)):r.push(P.deepClone(h))}for(const h of a.keys)o.indexOf(h)===-1&&o.push(h)}return new I(i,o,r,c.every(a=>a instanceof I)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new I(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}h(n){const i=this.l(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o];const a=i[o];a&&(typeof c=="object"&&typeof a=="object"?(c=P.deepClone(c),this.j(c,a)):c=a),r[o]=c}return new I(r,this.keys,this.overrides)}j(n,i){for(const r of Object.keys(i)){if(r in n&&d.isObject(n[r])&&d.isObject(i[r])){this.j(n[r],i[r]);continue}n[r]=P.deepClone(i[r])}}k(n){return this.a&&!Object.isFrozen(n)?P.deepFreeze(n):n}l(n){let i=null,r=null;const o=c=>{c&&(r?this.j(r,c):r=P.deepClone(c))};for(const c of this.overrides)T.equals(c.identifiers,[n])?i=c.contents:c.identifiers.includes(n)&&o(c.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.m(n),(0,m.addToValueTree)(this.contents,n,i,r=>{throw new Error(r)})}removeValue(n){this.n(n)&&(0,m.removeFromValueTree)(this.contents,n)}m(n){let i=this.keys.length;for(let r=0;r<i;r++)n.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,n)}n(n){const i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=I;class w{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new I}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!d.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:r,keys:o,overrides:c,restricted:a,hasExcludedProperties:h}=this.h(n,i);this.b=new I(r,o,c,h?[n]:void 0),this.c=a||[]}g(n){let i={},r=null,o=[];const c=[],a=[];function h(j){Array.isArray(o)?o.push(j):r!==null&&(o[r]=j)}const D={onObjectBegin:()=>{const j={};h(j),c.push(o),o=j,r=null},onObjectProperty:j=>{r=j},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const j=[];h(j),c.push(o),o=j,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:h,onError:(j,W,J)=>{a.push({error:j,offset:W,length:J})}};if(n)try{k.visit(n,D),i=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return i}h(n,i){const r=p.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.j(n,r,!0,i);n=o.raw;const c=(0,m.toValuesTree)(n,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),a=Object.keys(n),h=this.l(n,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:c,keys:a,overrides:h,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,i,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const a={},h=[];for(const D in n)if(y.OVERRIDE_PROPERTY_REGEX.test(D)&&r){const j=this.j(n[D],i,!1,o);a[D]=j.raw,c=c||j.hasExcludedProperties,h.push(...j.restricted)}else{const j=i[D],W=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&h.push(D),(W===void 0||o.scopes===void 0||o.scopes.includes(W))&&!(o.skipRestricted&&j?.restricted)?a[D]=n[D]:c=!0}return{raw:a,restricted:h,hasExcludedProperties:c}}l(n,i){const r=[];for(const o of Object.keys(n))if(y.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in n[o])c[a]=n[o][a];r.push({identifiers:(0,y.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,m.toValuesTree)(c,i)})}return r}}e.ConfigurationModelParser=w;class S extends L.Disposable{constructor(n,i,r,o){super(),this.f=n,this.g=i,this.h=o,this.c=this.B(new O.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(O.Event.any(O.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),O.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new I}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=S;class E{constructor(n,i,r,o,c,a,h,D,j,W,J,X,ee){this.a=n,this.b=i,this.value=r,this.overrideIdentifiers=o,this.c=c,this.d=a,this.f=h,this.g=D,this.h=j,this.j=W,this.k=J,this.l=X,this.m=ee}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(n,i,r,o,c=new I,a=new I,h=new N.ResourceMap,D=new I,j=new N.ResourceMap,W=!0){this.c=n,this.d=i,this.f=r,this.g=o,this.h=c,this.j=a,this.l=h,this.m=D,this.n=j,this.p=W,this.a=null,this.b=new N.ResourceMap,this.q=null}getValue(n,i,r){return this.s(n,i,r).getValue(n)}updateValue(n,i,r={}){let o;r.resource?(o=this.n.get(r.resource),o||(o=new I,this.n.set(r.resource,o))):o=this.m,i===void 0?o.removeValue(n):o.setValue(n,i),r.resource||(this.a=null)}inspect(n,i,r){const o=this.s(n,i,r),c=T.distinct(o.overrides.map(D=>D.identifiers).flat()).filter(D=>o.getOverrideValue(n,D)!==void 0),a=this.w(i.resource,r),h=i.resource?this.n.get(i.resource)||this.m:this.m;return new E(n,i,o.getValue(n),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this.j.freeze():void 0,a?a.freeze():void 0,h.inspect(n,i.overrideIdentifier))}keys(n){const i=this.w(void 0,n);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.j=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.l.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.r.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:o,updated:c,removed:a}=f(this.c,n);i=[...o,...c,...a]}for(const o of i)for(const c of(0,y.overrideIdentifiersFromKey)(o)){const a=this.c.getKeysForOverrideIdentifier(c),h=n.getKeysForOverrideIdentifier(c),D=[...h.filter(j=>a.indexOf(j)===-1),...a.filter(j=>h.indexOf(j)===-1),...a.filter(j=>!P.equals(this.c.override(c).getValue(j),n.override(c).getValue(j)))];r.push([c,D])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:o}=f(this.d,n),c=[...i,...r,...o];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=f(this.applicationConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=f(this.localUserConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=f(this.remoteUserConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=f(this.workspaceConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(n,i){const r=this.r.get(n),{added:o,updated:c,removed:a,overrides:h}=f(r,i),D=[...o,...c,...a];return(D.length||!r)&&this.updateFolderConfiguration(n,i),{keys:D,overrides:h}}compareAndDeleteFolderConfiguration(n){const i=this.r.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:c,overrides:a}=f(i,void 0);return{keys:[...r,...o,...c],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(n,i,r){let o=this.t(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(o=o.merge(this.d)),o}t({resource:n},i){let r=this.u();if(i&&n){const o=i.getFolder(n);o&&(r=this.v(o.uri)||r);const c=this.n.get(n);c&&(r=r.merge(c))}return r}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(n){let i=this.b.get(n);if(!i){const r=this.u(),o=this.l.get(n);o?(i=r.merge(o),this.p&&(i=i.freeze()),this.b.set(n,i)):i=r}return i}w(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this.l.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((n,i)=>{const{contents:r,overrides:o,keys:c}=this.l.get(i);return n.push([i,{contents:r,overrides:o,keys:c}]),n},[])}}allKeys(){const n=new Set;return this.c.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this.j.freeze().keys.forEach(i=>n.add(i)),this.l.forEach(i=>i.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}x(){const n=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.l.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}y(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.j.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.l.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o))),[...i.values()]}static parse(n){const i=this.z(n.defaults),r=this.z(n.policy),o=this.z(n.application),c=this.z(n.user),a=this.z(n.workspace),h=n.folders.reduce((D,j)=>(D.set(u.URI.revive(j[0]),this.z(j[1])),D),new N.ResourceMap);return new l(i,r,o,c,new I,a,h,new I,new N.ResourceMap,!1)}static z(n){return new I(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=l;function g(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const n=new Set,i=new Map;for(const o of t)o.keys.forEach(c=>n.add(c)),o.overrides.forEach(([c,a])=>{const h=(0,N.getOrSet)(i,c,new Set);a.forEach(D=>h.add(D))});const r=[];return i.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=g;class v{constructor(n,i,r,o){this.change=n,this.b=i,this.c=r,this.d=o,this.f=void 0;const c=new Set;n.keys.forEach(h=>c.add(h)),n.overrides.forEach(([,h])=>h.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const a=new I;this.affectedKeys.forEach(h=>a.setValue(h,{})),this.a=a.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(n,i){if(this.g(this.a,n)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.b?.workspace):void 0,o=this.c.getValue(n,i,this.d);return!P.equals(r,o)}return!0}return!1}g(n,i){let r=(0,m.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=v;function f(t,n){const{added:i,removed:r,updated:o}=s(n?.rawConfiguration,t?.rawConfiguration),c=[],a=t?.getAllOverrideIdentifiers()||[],h=n?.getAllOverrideIdentifiers()||[];if(n){const D=h.filter(j=>!a.includes(j));for(const j of D)c.push([j,n.getKeysForOverrideIdentifier(j)])}if(t){const D=a.filter(j=>!h.includes(j));for(const j of D)c.push([j,t.getKeysForOverrideIdentifier(j)])}if(n&&t){for(const D of a)if(h.includes(D)){const j=s({contents:t.getOverrideValue(void 0,D)||{},keys:t.getKeysForOverrideIdentifier(D)},{contents:n.getOverrideValue(void 0,D)||{},keys:n.getKeysForOverrideIdentifier(D)});c.push([D,[...j.added,...j.removed,...j.updated]])}}return{added:i,removed:r,updated:o,overrides:c}}function s(t,n){const i=t?n?t.keys.filter(c=>n.keys.indexOf(c)===-1):[...t.keys]:[],r=n?t?n.keys.filter(c=>t.keys.indexOf(c)===-1):[...n.keys]:[],o=[];if(t&&n){for(const c of n.keys)if(t.keys.indexOf(c)!==-1){const a=(0,m.getConfigurationValue)(n.contents,c),h=(0,m.getConfigurationValue)(t.contents,c);P.equals(a,h)||o.push(c)}}return{added:i,removed:r,updated:o}}}),define(Y[123],Z([0,1,19,4,2,29,5,21,65,40,9,38,37]),function($,e,T,O,k,L,N,P,d,u,m,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class I extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new w(this.f())),this.b}async initialize(){return this.b=void 0,this.B(p.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:v})=>this.c(g,v))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(g,v){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}}e.DefaultConfiguration=I;class w extends d.ConfigurationModel{constructor(g={}){const v=p.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(v),s=Object.create(null),t=[];for(const n in v){const i=g[n],r=i!==void 0?i:v[n].default;(0,P.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))u.OVERRIDE_PROPERTY_REGEX.test(n)&&t.push({identifiers:(0,u.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,P.toValuesTree)(s[n],i=>console.error(`Conflict in default settings file: ${i}`))});super(s,f,t)}}e.DefaultConfigurationModel=w;class S{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new d.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let E=class extends k.Disposable{get configurationModel(){return this.b}constructor(g,v,f){super(),this.c=g,this.f=v,this.g=f,this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new d.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.i(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.j(await this.h(g),!0))),this.b}async h(g){const v={},f=[],s=p.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const t of g){const n=s[t];if(!n){f.push(t);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.g.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(t),v[n.policy.name]={type:n.type}}}return(0,N.isEmptyObject)(v)||await this.f.updatePolicyDefinitions(v),f}i(g){const v=p.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),f=(0,T.coalesce)(g.map(s=>v.get(s)));this.j(f,!0)}j(g,v){const f=p.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),s=[],t=this.b.isEmpty();for(const n of g){const i=f[n]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(t?r!==void 0:!(0,L.equals)(this.b.getValue(n),r))&&s.push([n,r])}else this.b.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this.b;this.b=new d.ConfigurationModel;for(const i of n.keys)this.b.setValue(i,n.getValue(i));for(const[i,r]of s)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);v&&this.a.fire(this.b)}}};E=de([_(1,y.IPolicyService),_(2,m.ILogService)],E),e.PolicyConfiguration=E}),define(Y[124],Z([0,1,3,4,2,17,21,65,123,38]),function($,e,T,O,k,L,N,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class m extends k.Disposable{constructor(p,I,w,S){super(),this.i=p,this.h=this.B(new O.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.DefaultConfiguration),this.c=w instanceof u.NullPolicyService?new d.NullPolicyConfiguration:this.B(new d.PolicyConfiguration(this.b,w,S)),this.f=this.B(new P.UserSettings(this.i,void 0,L.extUriBiasedIgnorePathCase,I)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:E,properties:l})=>this.k(E,l))),this.B(this.c.onDidChangeConfiguration(E=>this.l(E))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,I,w]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(p,I,new P.ConfigurationModel,w)}getConfigurationData(){return this.a.toData()}getValue(p,I){const w=typeof p=="string"?p:void 0,S=(0,N.isConfigurationOverrides)(p)?p:(0,N.isConfigurationOverrides)(I)?I:{};return this.a.getValue(w,S,void 0)}updateValue(p,I,w,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const I=this.a.toData(),w=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(w,I,2)}k(p,I){const w=this.a.toData(),S=this.a.compareAndUpdateDefaultConfiguration(p,I);this.m(S,w,7)}l(p){const I=this.a.toData(),w=this.a.compareAndUpdatePolicyConfiguration(p);this.m(w,I,7)}m(p,I,w){const S=new P.ConfigurationChangeEvent(p,{data:I},this.a);S.source=w,S.sourceConfig=this.n(w),this.h.fire(S)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=m}),define(Y[66],Z([0,1,16]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(u){return u.scheme===T.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=O;function k(u){if(!u)return;const m=u.indexOf("+");return m<0?u:u.substr(0,m)}e.getRemoteName=k;function L(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=L;function N(u){const{host:m,port:y}=d(u);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:y}}e.parseAuthorityWithPort=N;function P(u,m){let{host:y,port:p}=d(u);return typeof p>"u"&&(p=m),{host:y,port:p}}e.parseAuthorityWithOptionalPort=P;function d(u){const m=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const y=u.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const p=u.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:u,port:void 0}}}),define(Y[27],Z([0,1,31,8,66]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=L;function N(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var d;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(d=e.TargetPlatform||(e.TargetPlatform={}));class u{constructor(S){this.value=S,this.c=S.toLowerCase()}static equals(S,E){if(typeof S>"u"||S===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof S=="string"||typeof E=="string"){const l=typeof S=="string"?S:S.value,g=typeof E=="string"?E:E.value;return T.equalsIgnoreCase(l,g)}return S.c===E.c}static toKey(S){return typeof S=="string"?S.toLowerCase():S.c}}e.ExtensionIdentifier=u;function m(w){return y(w)}e.isApplicationScopedExtension=m;function y(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function p(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function I(w,S){if(S){const E=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return w.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[24],Z([0,1,31,23,27,12,11,10,35]),function($,e,T,O,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function u(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,T.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=u;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,r,o)}static parse(i){const r=m.exec(i);return r&&r[1]&&r[2]?new y({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?u(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=y;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(n){const i=p.exec(n);return i&&i[1]?[S(i[1]),i[2]]:[S(n),void 0]}e.getIdAndVersion=I;function w(n,i){return`${n}.${i}`}e.getExtensionId=w;function S(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function E(n,i){return S(w(n,i))}e.getGalleryExtensionId=E;function l(n,i){const r=[],o=c=>{for(const a of r)if(a.some(h=>u(i(h),i(c))))return a;return null};for(const c of n){const a=o(c);a?a.push(c):r.push([c])}return r}e.groupByExtension=l;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function v(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(n,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(a=>!u(a.identifier,{id:c}))){const a=n.filter(h=>u(h.identifier,{id:c}));a.length===1&&(r.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function s(n,i){if(!L.isLinux)return!1;let r;try{r=(await n.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function t(n,i){const r=await s(n,i),o=(0,O.getTargetPlatform)(r?"alpine":L.platform,d.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=t}),define(Y[125],Z([0,1,22,10,16,17,39,11,88,23,24,27]),function($,e,T,O,k,L,N,P,d,u,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const p=E=>(0,d.localize)(0,null,E),I=(0,d.localize)(1,null,"ms-dotnettools.csharp");function w(E,l){return l?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let S=class{constructor(l,g){this.a=l,this.b=g}get d(){}async listExtensions(l,g,v,f=console){let s=await this.a.getInstalled(1,v);const t=y.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(g&&g!==""){if(t.indexOf(g.toLowerCase())<0){f.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(i=>i.manifest.categories?i.manifest.categories.map(o=>o.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){f.log("Possible Categories: "),t.forEach(i=>{f.log(i)});return}this.d&&f.log((0,d.localize)(2,null,this.d)),s=s.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let n;for(const i of s)n!==i.identifier.id&&(n=i.identifier.id,f.log(w(i.manifest,l)))}async installExtensions(l,g,v,f,s=console){const t=[],n=[];l.length&&s.log(this.d?(0,d.localize)(3,null,this.d):(0,d.localize)(4,null));const i=await this.a.getInstalled(1,v.profileLocation),r=(h,D)=>{const j=i.find(W=>(0,m.areSameExtensions)(W.identifier,{id:h}));if(j){if(!f&&(!D||D==="prerelease"&&j.preRelease))return s.log((0,d.localize)(5,null,h,j.manifest.version,h)),!1;if(D&&j.manifest.version===D)return s.log((0,d.localize)(6,null,`${h}@${D}`)),!1}return!0},o=(h,D,j)=>{a.push({id:h,version:D!=="prerelease"?D:void 0,installOptions:{...v,isBuiltin:j,installPreReleaseVersion:D==="prerelease"||v.installPreReleaseVersion}})},c=[],a=[];for(const h of l)if(h instanceof P.URI)c.push(h);else{const[D,j]=(0,m.getIdAndVersion)(h);r(D,j)&&o(D,j,!1)}for(const h of g){const[D,j]=(0,m.getIdAndVersion)(h);r(D,j)&&o(D,j,!0)}if(c.length&&await Promise.all(c.map(async h=>{try{const D=await this.f(h,{...v,isBuiltin:!1},f,s);D&&n.push(D)}catch(D){s.error(D.message||D.stack||D),t.push(h.toString())}})),a.length){const h=await this.g(a);await Promise.all(a.map(async D=>{const j=h.get(D.id.toLowerCase());if(j)try{const W=await this.h(D,j,i,f,s);W&&n.push(W)}catch(W){s.error(W.message||W.stack||W),t.push(D.id)}else s.error(`${p(D.version?`${D.id}@${D.version}`:D.id)}
${I}`),t.push(D.id)}))}if(t.length)throw new Error((0,d.localize)(7,null,t.join(", ")))}async f(l,g,v,f){const s=await this.a.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.k(s,v,g.profileLocation,f))try{return await this.a.install(l,g),f.log((0,d.localize)(8,null,(0,L.basename)(l))),s}catch(n){if((0,O.isCancellationError)(n))return f.log((0,d.localize)(9,null,(0,L.basename)(l))),null;throw n}return null}async g(l){const g=new Map,v=l.some(s=>s.installOptions.installPreReleaseVersion),f=await this.b.getExtensions(l.map(s=>({...s,preRelease:v})),T.CancellationToken.None);for(const s of f)g.set(s.identifier.id.toLowerCase(),s);return g}async h({id:l,version:g,installOptions:v},f,s,t,n){const i=await this.b.getManifest(f,T.CancellationToken.None);if(i&&!this.j(i,n))return null;const r=s.find(o=>(0,m.areSameExtensions)(o.identifier,f.identifier));if(r){if(f.version===r.manifest.version)return n.log((0,d.localize)(10,null,g?`${l}@${g}`:l)),null;n.log((0,d.localize)(11,null,l,f.version))}try{v.isBuiltin?n.log(g?(0,d.localize)(12,null,l,g):(0,d.localize)(13,null,l)):n.log(g?(0,d.localize)(14,null,l,g):(0,d.localize)(15,null,l));const o=await this.a.installFromGallery(f,{...v,installGivenVersion:!!g});return n.log((0,d.localize)(16,null,l,o.manifest.version)),i}catch(o){if((0,O.isCancellationError)(o))return n.log((0,d.localize)(17,null,l)),null;throw o}}j(l,g){return!0}async k(l,g,v,f){const s={id:(0,m.getGalleryExtensionId)(l.publisher,l.name)},n=(await this.a.getInstalled(1,v)).find(i=>(0,m.areSameExtensions)(s,i.identifier)&&(0,N.gt)(i.manifest.version,l.version));return n&&!g?(f.log((0,d.localize)(18,null,n.identifier.id,n.manifest.version,l.version)),!1):this.j(l,f)}async uninstallExtensions(l,g,v,f=console){const s=async n=>{if(n instanceof P.URI){const i=await this.a.getManifest(n);return w(i)}return n},t=[];for(const n of l){const i=await s(n),o=(await this.a.getInstalled(void 0,v)).filter(c=>(0,m.areSameExtensions)(c.identifier,{id:i}));if(!o.length)throw new Error(`${this.l(i)}
${I}`);if(o.some(c=>c.type===0)){f.log((0,d.localize)(19,null,i));return}if(!g&&o.some(c=>c.isBuiltin)){f.log((0,d.localize)(20,null,i));return}f.log((0,d.localize)(21,null,i));for(const c of o)await this.a.uninstall(c,{profileLocation:v}),t.push(c);this.d?f.log((0,d.localize)(22,null,i,this.d)):f.log((0,d.localize)(23,null,i))}}async locateExtension(l,g=console){const v=await this.a.getInstalled();l.forEach(f=>{v.forEach(s=>{if(s.identifier.id===f&&s.location.scheme===k.Schemas.file){g.log(s.location.fsPath);return}})})}l(l){return this.d?(0,d.localize)(24,null,l,this.d):(0,d.localize)(25,null,l)}};S=de([_(0,u.IExtensionManagementService),_(1,u.IExtensionGalleryService)],S),e.ExtensionManagementCLI=S}),define(Y[126],Z([0,1,3,10,2,16,12,17,39,5,30,20,21,18,23,24,59,13,9,26]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w,S,E,l,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class Ve extends k.Disposable{constructor(t,n,i,r,o,c,a,h){super(),this.h=t,this.i=i,this.j=r,this.k=o,this.l=c,this.m=a,this.n=h,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(t,n){await this.g;const i=(0,P.joinPath)(this.extensionsDownloadDir,this.y(t));try{await this.u(t,i,o=>this.j.download(t,o,n))}catch(o){throw new w.ExtensionManagementError(o.message,w.ExtensionManagementErrorCode.Download)}let r=!1;if(await this.r(t)){const o=await this.t(t);try{r=await this.m.verify(i.fsPath,o.fsPath),this.n.info(`Verified extension: ${t.identifier.id}`,r)}catch(c){throw await this.delete(o),await this.delete(i),new w.ExtensionManagementError(c.code,w.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:r}}async r(t){if(!t.isSigned||await this.h==="linux-armhf")return!1;const i=this.k.getValue("extensions.verifySignature");return(0,u.isBoolean)(i)?i:this.l.quality!=="stable"}async t(t){await this.g;const n=(0,P.joinPath)(this.extensionsDownloadDir,`${this.y(t)}${Ve.c}`);return await this.u(t,n,i=>this.j.downloadSignatureArchive(t,i)),n}async u(t,n,i){if(await this.i.exists(n))return;if(n.scheme!==L.Schemas.file){await i(n);return}const r=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.i.exists(r)||await i(r);try{await this.v(r,n,Date.now()+2*60*1e3)}catch(o){try{await this.i.del(r)}catch{}if(o.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.n.info(`Rename failed because of ${(0,O.getErrorMessage)(o)}. Deleted the file from downloaded location`,r.path),o}}async delete(t){await this.g,await this.i.del(t)}async v(t,n,i){try{await y.Promises.rename(t.fsPath,n.fsPath)}catch(r){if(N.isWindows&&r&&r.code==="EPERM"&&Date.now()<i)return this.n.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`),this.v(t,n,i);throw r}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],i=[],r=[];for(const a of t.children)if(a.name.endsWith(Ve.c))r.push(a.resource);else{const h=S.ExtensionKey.parse(a.name);h&&i.push([h,a])}const o=(0,S.groupByExtension)(i,([a])=>a),c=[];for(const a of o)a.sort((h,D)=>d.rcompare(h[0].version,D[0].version)),n.push(...a.slice(1).map(h=>h[1].resource)),c.push(a[0][1]);c.sort((a,h)=>a.mtime-h.mtime),n.push(...c.slice(0,Math.max(0,c.length-this.f)).map(a=>a.resource)),n.push(...r),await T.Promises.settled(n.map(a=>(this.n.trace("Deleting from cache",a.path),this.i.del(a))))}}catch(t){this.n.error(t)}}y(t){return this.f?S.ExtensionKey.create(t).toString().toLowerCase():(0,m.generateUuid)()}};f.c=".sigzip",f=de([_(1,I.INativeEnvironmentService),_(2,l.IFileService),_(3,w.IExtensionGalleryService),_(4,p.IConfigurationService),_(5,v.IProductService),_(6,E.IExtensionSignatureVerificationService),_(7,g.ILogService)],f),e.ExtensionsDownloader=f}),define(Y[127],Z([0,1,2,14,20,27]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends T.Disposable{constructor(d,u){super(),this.b=d,this.a=(0,O.join)(this.b.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this.B(u.onDidInstallExtensions(m=>this.c(m))),this.B(u.onDidUninstallExtension(m=>this.f(m)))}c(d){d.some(u=>!!u.local)&&this.invalidate()}f(d){d.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(Y[128],Z([0,1,4,2,36,24,27]),function($,e,T,O,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends O.Disposable{constructor(u,m,y,p,I,w,S){super(),this.f=u,this.g=m,this.h=y,this.i=p,this.j=I,this.k=w,this.l=S,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.DisposableMap),this.m().then(null,E=>S.error(E))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(u=>this.p(u.added,u.removed))),this.B(this.i.onAddExtensions(u=>this.r(u))),this.B(this.i.onDidAddExtensions(u=>this.s(u))),this.B(this.i.onRemoveExtensions(u=>this.t(u))),this.B(this.i.onDidRemoveExtensions(u=>this.u(u))),this.B(this.k.onDidFilesChange(u=>this.v(u)))}async p(u,m){try{await Promise.all(m.map(y=>(this.c.deleteAndDispose(y.id),this.z(y.extensionsResource))))}catch(y){this.l.error(y)}try{u.length&&await Promise.all(u.map(y=>(this.c.set(y.id,(0,O.combinedDisposable)(this.k.watch(this.j.extUri.dirname(y.extensionsResource)),this.k.watch(y.extensionsResource))),this.y(y.extensionsResource))))}catch(y){this.l.error(y)}}async r(u){for(const m of u.extensions)this.D(this.G(m.identifier,m.version),u.profileLocation)}async s(u){for(const m of u.extensions){const y=this.G(m.identifier,m.version);u.error?this.F(y,u.profileLocation):this.D(y,u.profileLocation)}}async t(u){for(const m of u.extensions)this.F(this.G(m.identifier,m.version),u.profileLocation)}async u(u){let m=!1;for(const y of u.extensions){const p=this.G(y.identifier,y.version);u.error?this.D(p,u.profileLocation):(this.F(p,u.profileLocation),m=m||!this.b.has(p))}m&&await this.C()}v(u){for(const m of this.h.profiles)u.contains(m.extensionsResource,0,1)&&this.w(m.extensionsResource)}async w(u){const m=[],y=[],p=await this.i.scanProfileExtensions(u),I=new Set,w=new Set;for(const[S,E]of this.b)E.has(u)&&w.add(S);for(const S of p){const E=this.G(S.identifier,S.version);I.add(E),w.has(E)||(m.push(S.identifier),this.D(E,u))}for(const S of w)if(!I.has(S)){const E=this.H(S);E&&(y.push(E.identifier),this.F(S,u))}(m.length||y.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:u}:void 0,removed:y.length?{extensions:y,profileLocation:u}:void 0})}async y(u){const m=await this.i.scanProfileExtensions(u);for(const y of m)this.D(this.G(y.identifier,y.version),u)}async z(u){for(const m of[...this.b.keys()])this.F(m,u);await this.C()}async C(){const m=(await this.f.getAllUserInstalled()).filter(y=>y.installedTimestamp&&!this.b.has(this.G(y.identifier,y.manifest.version)));m.length&&await this.f.markAsUninstalled(...m)}D(u,m){let y=this.b.get(u);y||this.b.set(u,y=new k.ResourceSet(p=>this.j.extUri.getComparisonKey(p))),y.add(m)}F(u,m){const y=this.b.get(u);y&&y.delete(m),y?.size||this.b.delete(u)}G(u,m){return`${N.ExtensionIdentifier.toKey(u.id)}@${m}`}H(u){const[m,y]=(0,L.getIdAndVersion)(u);return y?{identifier:{id:m},version:y}:void 0}}e.ExtensionsWatcher=P}),define(Y[129],Z([0,1,160,19,3,2,16,14,20,18,23,24,9,63,12,11]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends I.LanguagePackBaseService{constructor(f,s,t,n){super(t),this.h=f,this.i=n,this.g=this.B(new l(s,n)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(f){const t=(await this.g.getLanguagePacks())[w.Language.value()];if(!t){this.i.warn(`No language pack found for ${w.Language.value()}`);return}const n=t.translations[f];return n?S.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),s=Object.keys(f).map(t=>{const n=f[t];return{...this.f(t,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return s.push({...this.f("en","English"),extensionId:"default"}),s.sort((t,n)=>t.label.localeCompare(n.label)),s}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const s=await this.g.getLanguagePacks();Object.keys(s).some(t=>s[t]&&s[t].extensions.some(n=>(0,y.areSameExtensions)(n.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,s]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(s);return!(0,O.equals)(Object.keys(f),Object.keys(t))}};E=de([_(0,m.IExtensionManagementService),_(1,u.INativeEnvironmentService),_(2,m.IExtensionGalleryService),_(3,p.ILogService)],E),e.NativeLanguagePackService=E;let l=class extends L.Disposable{constructor(f,s){super(),this.i=s,this.c={},this.f=(0,P.join)(f.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(s=>{Object.keys(s).forEach(t=>delete s[t]),this.j(s,...f)}).then(()=>this.c)}j(f,...s){for(const t of s)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(f,t);Object.keys(f).forEach(t=>this.l(f[t]))}k(f,s){const t=s.identifier,n=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of n)if(s.location.scheme===N.Schemas.file&&g(i)){let r=f[i.languageId];r||(r={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},f[i.languageId]=r);const o=r.extensions.filter(c=>(0,y.areSameExtensions)(c.extensionIdentifier,t))[0];o?o.version=s.manifest.version:r.extensions.push({extensionIdentifier:t,version:s.manifest.version});for(const c of i.translations)r.translations[c.id]=(0,P.join)(s.location.fsPath,c.path)}}l(f){if(f){const s=(0,T.createHash)("md5");for(const t of f.extensions)s.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);f.hash=s.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let s=null;return d.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(s=f(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),d.Promises.writeFile(this.f,n)}).then(()=>s,t=>this.i.error(t))})}};l=de([_(0,u.INativeEnvironmentService),_(1,p.ILogService)],l);function g(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const f of v.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(Y[47],Z([0,1,15,98,40,8,37]),function($,e,T,O,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=P;function d(S){return S.res.statusCode===204}async function u(S){return d(S)?null:(await(0,T.streamToBuffer)(S.stream)).toString()}e.asText=u;async function m(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);return u(S)}e.asTextOrError=m;async function y(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);if(d(S))return null;const l=(await(0,T.streamToBuffer)(S.stream)).toString();try{return JSON.parse(l)}catch(g){throw g.message+=`:
`+l,g}}e.asJson=y;function p(S){w(S)}e.updateProxyConfigurationsScope=p;let I;function w(S){const E=N.Registry.as(k.Extensions.Configuration),l=I;I={id:"http",order:15,title:(0,O.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(4,null),(0,O.localize)(5,null),(0,O.localize)(6,null),(0,O.localize)(7,null)],default:"override",description:(0,O.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[I],remove:l?[l]:[]})}w(2)}),define(Y[130],Z([0,1,22,16,13,47]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(d,u){this.a=d,this.b=u}async download(d,u,m=T.CancellationToken.None){if(d.scheme===O.Schemas.file||d.scheme===O.Schemas.vscodeRemote){await this.b.copy(d,u);return}const y={type:"GET",url:d.toString(!0)},p=await this.a.request(y,m);if(p.res.statusCode===200)await this.b.writeFile(u,p.stream);else{const I=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${I}`)}}};N=de([_(0,L.IRequestService),_(1,k.IFileService)],N),e.DownloadService=N}),define(Y[131],Z([0,1,132,5]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(N,P){return N.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:N.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function L(N,P,d={}){const u=(0,T.parse)(N),m=d.proxyUrl||k(u,P);if(!m)return null;const y=(0,T.parse)(m);if(!/^https?:$/.test(y.protocol||""))return null;const p={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,O.isBoolean)(d.strictSSL)?d.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((I,w)=>{$(["http-proxy-agent"],I,w)}))(p):new(await new Promise((I,w)=>{$(["https-proxy-agent"],I,w)}))(p)}e.getProxyAgent=L}),define(Y[133],Z([0,1,57,14,99,22,34,10,12,30,81,161,3]),function($,e,T,O,k,L,N,P,d,u,m,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const I=1e4;let w;async function S(l,g,v){return g["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(v)&&!g["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(v)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=p.Promises.withAsyncBody(async(f,s)=>{const t=new L.CancellationTokenSource,n=setTimeout(()=>{t.dispose(!0),s(new Error((0,k.localize)(0,null)))},I);try{f(await E(l,t.token))}catch(i){!(0,P.isCancellationError)(i)&&!t.token.isCancellationRequested?s(new Error((0,k.localize)(1,null,(0,N.toErrorMessage)(i)))):f({})}finally{clearTimeout(n),t.dispose()}})),w)}e.getResolvedShellEnv=S;async function E(l,g){const v=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",v);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",f);const s=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const i=await(0,m.getSystemShell)(d.OS,n);return l.trace("getUnixShellEnvironment#shell",i),new Promise((r,o)=>{if(g.isCancellationRequested)return o((0,P.canceled)());const c=(0,O.basename)(i);let a,h;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${D} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${D} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,c==="tcsh"?h=["-ic"]:h=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const j=(0,T.spawn)(i,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});g.onCancellationRequested(()=>(j.kill(),o((0,P.canceled)()))),j.on("error",X=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(X)),o(X)});const W=[];j.stdout.on("data",X=>W.push(X));const J=[];j.stderr.on("data",X=>J.push(X)),j.on("close",(X,ee)=>{const ne=Buffer.concat(W).toString("utf8");l.trace("getUnixShellEnvironment#raw",ne);const Q=Buffer.concat(J).toString("utf8");if(Q.trim()&&l.trace("getUnixShellEnvironment#stderr",Q),X||ee)return o(new Error((0,k.localize)(2,null,X,ee)));const ge=t.exec(ne),ce=ge?ge[1]:"{}";try{const re=JSON.parse(ce);v?re.ELECTRON_RUN_AS_NODE=v:delete re.ELECTRON_RUN_AS_NODE,f?re.ELECTRON_NO_ATTACH_CONSOLE=f:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",re),r(re)}catch(re){l.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(re)),o(re)}})})}}),define(Y[67],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,T.createDecorator)("stateService")}),define(Y[134],Z([0,1,3,15,5,18,13,9]),function($,e,T,O,k,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class d{constructor(y,p,I){this.f=y,this.g=p,this.h=I,this.a=Object.create(null),this.b="",this.c=new T.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.g.error(y)}}getItem(y,p){const I=this.a[y];return(0,k.isUndefinedOrNull)(I)?p:I}setItem(y,p){this.setItems([{key:y,data:p}])}setItems(y){let p=!1;for(const{key:I,data:w}of y)this.a[I]!==w&&((0,k.isUndefinedOrNull)(w)?(0,k.isUndefined)(this.a[I])||(this.a[I]=void 0,p=!0):(this.a[I]=w,p=!0));p&&this.j()}removeItem(y){(0,k.isUndefined)(this.a[y])||(this.a[y]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.h.writeFile(this.f,O.VSBuffer.fromString(y)),this.b=y}catch(p){this.g.error(p)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=d;let u=class{constructor(y,p,I){this.a=new d(y.stateResource,p,I)}async init(){await this.a.init()}getItem(y,p){return this.a.getItem(y,p)}};u=de([_(0,L.IEnvironmentService),_(1,P.ILogService),_(2,N.IFileService)],u),e.StateService=u}),define(Y[68],Z([0,1,12,35,11,30]),function($,e,T,O,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(u){if(T.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}async function P(u,m,y,p,I,w,S,E,l,g){const v=Object.create(null);v["common.machineId"]=S,v.sessionID=(0,L.generateUuid)()+Date.now(),v.commitHash=I,v.version=w,v["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,T.PlatformToString)(T.platform),v["common.nodePlatform"]=O.platform,v["common.nodeArch"]=p,v["common.product"]=g||"desktop",E&&(v["common.msftInternal"]=E);let f=0;const s=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),T.isLinuxSnap&&(v["common.snap"]="true");const t=N(y);t&&(v["common.platformDetail"]=t);try{const n=await u.readFile(k.URI.file(l));v["common.source"]=n.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=P;function d(u){const m=O.env.USERDNSDOMAIN;if(!m)return!1;const y=m.toLowerCase();return u.some(p=>y===p)}e.verifyMicrosoftInternalDomain=d}),define(Y[32],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(O=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Y[41],Z([0,1,29,5,21,66,68,32]),function($,e,T,O,k,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class d{constructor(c){this.value=c}}e.TrustedTelemetryValue=d;class u{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,a){return Promise.resolve(void 0)}publicLog2(c,a){return this.publicLog(c,a)}publicLogError(c,a){return Promise.resolve(void 0)}publicLogError2(c,a){return this.publicLogError(c,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class m{async publicLog(c,a,h){}async publicLogError(c,a,h){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(o,c){return c.onDidChangeConfiguration(a=>{a.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(a.source),configurationKeys:v(a.sourceConfig)})})}e.configurationTelemetry=y;function p(o,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!o.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=p;function I(o,c){return!(c.isBuilt||c.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=I;function w(o){const c=o.getValue(P.TELEMETRY_SETTING_ID),a=o.getValue("telemetry.enableCrashReporter");if(o.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function S(o){const c={},a={},h={};g(o,h);for(let D in h){D=D.length>150?D.substr(D.length-149):D;const j=h[D];typeof j=="number"?a[D]=j:typeof j=="boolean"?a[D]=j?1:0:typeof j=="string"?(j.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${j.length}`),c[D]=j.substring(0,8191)):typeof j<"u"&&j!==null&&(c[D]=j)}return{properties:c,measurements:a}}e.validateTelemetryData=S;const E=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(o){if(!o)return"none";const c=(0,L.getRemoteName)(o);return E.has(c)?c:"other"}e.cleanRemoteAuthority=l;function g(o,c,a=0,h){if(!!o)for(const D of Object.getOwnPropertyNames(o)){const j=o[D],W=h?h+D:D;Array.isArray(j)?c[W]=(0,T.safeStringify)(j):j instanceof Date?c[W]=j.toISOString():(0,O.isObject)(j)?a<2?g(j,c,a+1,W+"."):c[W]=(0,T.safeStringify)(j):c[W]=j}}function v(o){if(!o)return[];const c=[];return f(c,"",o),c}function f(o,c,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(h=>f(o,c?`${c}.${h}`:h,a[h])):o.push(c)}function s(o,c){const a=o.msftInternalDomains||[],h=c.getValue("telemetry.internalTesting");return(0,N.verifyMicrosoftInternalDomain)(a)||h}e.isInternalTelemetry=s;function t(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=t;function n(o,c){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let a=o;const h=[];for(const J of c)for(;;){const X=J.exec(o);if(!X)break;h.push([X.index,J.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,j=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let W=0;for(a="";;){const J=j.exec(o);if(!J)break;const X=h.some(([ee,ne])=>J.index<ne&&ee<j.lastIndex);!D.test(J[0])&&!X&&(a+=o.substring(W,J.index)+"<REDACTED: user-file-path>",W=j.lastIndex)}return W<o.length&&(a+=o.substr(W)),a}function i(o){if(!o)return o;const c=o.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of a)if(h.regex.test(c))return`<REDACTED: ${h.label}>`;return o}function r(o,c){return(0,T.cloneAndChange)(o,a=>{if(a instanceof d)return a.value;if(typeof a=="string"){let h=a.replaceAll("%20"," ");h=n(h,c);for(const D of c)h=h.replace(D,"");return h=i(h),h}})}e.cleanData=r}),define(Y[135],Z([0,1,108,41]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(L,N,P,d,u,m,y){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${N.nameShort})`};if((0,O.supportsTelemetry)(N,P)&&(0,O.getTelemetryLevel)(d)===3){const I=await(0,T.getServiceMachineId)(P,u,m),{machineId:w}=await y.getTelemetryInfo();p["X-Market-User-Id"]=I,p["VSCode-SessionId"]=w||I}return p}e.resolveMarketplaceHeaders=k}),define(Y[136],Z([0,1,10,29,41]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function N(d,u,m){const y=await new Promise((E,l)=>{$(["@microsoft/1ds-core-js"],E,l)}),p=await new Promise((E,l)=>{$(["@microsoft/1ds-post-js"],E,l)}),I=new y.AppInsightsCore,w=new p.PostChannel,S={instrumentationKey:d,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(m){S.extensionConfig={};const E={alwaysUseXhrOverride:!0,httpXHROverride:m};S.extensionConfig[w.identifier]=E}return I.initialize(S,[]),I.addTelemetryInitializer(E=>{u&&(E.ext=E.ext??{},E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),I}class P{constructor(u,m,y,p,I){this.d=u,this.e=m,this.f=y,this.g=I,this.c=L,this.f||(this.f={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}h(u){if(!!this.a){if(typeof this.a!="string"){u(this.a);return}this.b||(this.b=N(this.a,this.d,this.g)),this.b.then(m=>{u(m)},m=>{(0,T.onUnexpectedError)(m),console.error(m)})}}log(u,m){if(!this.a)return;m=(0,O.mixin)(m,this.f),m=(0,k.validateTelemetryData)(m);const y=this.e+"/"+u;try{this.h(p=>{p.pluginVersionString=m?.properties.version??"Unknown",p.track({name:y,baseData:{name:y,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(u=>{this.h(m=>{m.unload(!0,()=>{this.a=void 0,u(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(Y[137],Z([0,1,2,29,12,31,100,21,40,138,26,37,32,41]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(l,g,v){this.k=g,this.l=v,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this.f)this.j.push(new RegExp((0,L.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(l,g){this.d[l]=g}m(){let l=(0,I.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const v=g.usage?3:g.error?2:0;l=Math.min(l,v)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,g=l.sessionID,v=l["common.machineId"],f=l["common.firstSessionDate"],s=l["common.msftInternal"];return{sessionId:g,machineId:v,firstSessionDate:f,msftInternal:s}}dispose(){this.i.dispose()}n(l,g,v){return this.g<g?Promise.resolve(void 0):this.c.then(f=>{v=(0,O.mixin)(v,this.d),v=(0,I.cleanData)(v,this.j),v=(0,O.mixin)(v,f),this.b.forEach(s=>s.log(l,v))},f=>{console.error(f)})}publicLog(l,g){return this.n(l,3,g)}publicLog2(l,g){return this.publicLog(l,g)}publicLogError(l,g){return this.h?this.n(l,2,g):Promise.resolve(void 0)}publicLogError2(l,g){return this.publicLogError(l,g)}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=de([_(1,P.IConfigurationService),_(2,m.IProductService)],w),e.TelemetryService=w;function S(){const E=(0,N.localize)(0,null,u.default.nameLong),l=u.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=k.isWeb?"":(0,N.localize)(3,null),v=(0,N.localize)(4,null),f=(0,N.localize)(5,null),s=(0,N.localize)(6,null),t=(0,N.localize)(7,null),n=`
|       | ${v} | ${f} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${E} ${l} ${g}

&nbsp;

${t}
${n}

&nbsp;

${i}
`}y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(9,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,N.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,N.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[139],Z([0,1,162,136]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends O.AbstractOneDataSystemAppender{constructor(N,P,d,u){const m={sendPOST:(y,p)=>{const I={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const w=T.request(y.urlString,I,S=>{S.on("data",function(E){p(S.statusCode??200,S.headers,E.toString())}),S.on("error",function(E){p(0,{})})});w.write(y.data),w.end()}catch{p(0,{})}}};super(N,P,d,u,m)}}e.OneDataSystemAppender=k}),define(Y[140],Z([0,1,14,20]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(L,N){const P=Object.create(null),d=(m,y)=>{const p=JSON.parse(m);P[y]=p};if(N){const m=[],y=await O.Promises.readdir(N);for(const I of y)try{(await O.Promises.stat((0,T.join)(N,I))).isDirectory()&&m.push(I)}catch{}const p=[];for(const I of m)(await O.Promises.readdir((0,T.join)(N,I))).filter(S=>S==="telemetry.json").length===1&&p.push(I);for(const I of p){const w=(await O.Promises.readFile((0,T.join)(N,I,"telemetry.json"))).toString();d(w,I)}}let u=(await O.Promises.readFile((0,T.join)(L,"telemetry-core.json"))).toString();return d(u,"vscode-core"),u=(await O.Promises.readFile((0,T.join)(L,"telemetry-extensions.json"))).toString(),d(u,"vscode-extensions"),JSON.stringify(P,null,4)}e.buildTelemetryMessage=k}),define(Y[141],Z([0,1,12,79,32]),function($,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function L(N){let P=N.getItem(k.machineIdKey);return(typeof P!="string"||T.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,O.getMachineId)()),P}e.resolveMachineId=L}),define(Y[28],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Y[142],Z([0,1,28,109,13,17,71,4,2]),function($,e,T,O,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(p){this.uri=p,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let m=class{constructor(p){this.g=p,this.c=new d.DisposableStore,this.f=2**16;const I=new Map,w=S=>{let E=I.get(S.scheme);return E===void 0&&(E=p.hasProvider(S)&&!this.g.hasCapability(S,1024),I.set(S.scheme,E)),E};this.c.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{I.delete(S.scheme)})),this.extUri=new L.ExtUri(w),this.d=new N.SkipList((S,E)=>this.extUri.compare(S,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,L.normalizePath)(p));const I=this.d.get(p);return I?I.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new u(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((w,S)=>w[1].touch<S[1].touch?1:w[1].touch>S[1].touch?-1:0);u._clock=0,this.d.clear();const I=this.f*.5;for(let w=0;w<I;w++)this.d.set(p[w][0],p[w][1].touch())}};m=de([_(0,k.IFileService)],m),e.UriIdentityService=m,(0,O.registerSingleton)(T.IUriIdentityService,m,1)}),define(Y[143],Z([0,1,102,14,54,17,11,8,16]),function($,e,T,O,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function u(n){const i=n;return typeof i?.id=="string"&&N.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=u,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function m(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.basename)(n)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=m;function y(n){const i=n;return typeof i?.id=="string"&&N.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=y;function p(n){const i=n;if(i?.uri)return{id:i.id,uri:N.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=p;var I;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function w(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=w;function S(n){const i=n;return!!(i&&typeof i=="object"&&N.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=S;class E{constructor(i,r,o,c,a){this.h=i,this.j=o,this.k=c,this.l=a,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class l{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,L.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function g(n){return new l({uri:n,index:0,name:(0,L.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(n,i){return L.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function f(n){let i;return N.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=f;function s(n,i){return!v(n,i)&&!f(n)}e.isSavedWorkspace=s;function t(n){return(typeof n=="string"?(0,O.extname)(n):(0,L.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Y[25],Z([0,1,52,4,2,17,11,101,18,13,8,9,143,36,28,3,30,31,5]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w,S,E,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function v(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&N.URI.isUri(r.location)&&N.URI.isUri(r.globalStorageHome)&&N.URI.isUri(r.settingsResource)&&N.URI.isUri(r.keybindingsResource)&&N.URI.isUri(r.tasksResource)&&N.URI.isUri(r.snippetsHome)&&N.URI.isUri(r.extensionsResource))}e.isUserDataProfile=v,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function f(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:N.URI.revive(i.location).with({scheme:r}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:N.URI.revive(i.extensionsResource)?.with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=f;function s(i,r,o,c){return{id:i,name:r,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,L.joinPath)(o,"globalStorage"),settingsResource:(0,L.joinPath)(o,"settings.json"),keybindingsResource:(0,L.joinPath)(o,"keybindings.json"),tasksResource:(0,L.joinPath)(o,"tasks.json"),snippetsHome:(0,L.joinPath)(o,"snippets"),extensionsResource:(0,L.joinPath)(o,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=s;let t=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(r,o,c,a){super(),this.m=r,this.n=o,this.r=c,this.s=a,this.f=!1,this.g=this.B(new O.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new O.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new O.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new O.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new I.ResourceMap},this.profilesHome=(0,L.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(r){this.f!==r&&(this.t=void 0,this.f=r)}isEnabled(){return this.f}get u(){if(!this.t){const r=[];if(this.f)for(const h of this.H()){if(!h.name||!(0,g.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}r.push(s((0,L.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}let o;const c=new I.ResourceMap,a=s((0,T.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(r.unshift({...a,extensionsResource:this.M()??a.extensionsResource,isDefault:!0}),r.length){const h=this.J();if(h.workspaces)for(const[D,j]of Object.entries(h.workspaces)){const W=N.URI.parse(D),J=N.URI.parse(j),X=r.find(ee=>this.r.extUri.isEqual(ee.location,J));X&&c.set(W,X)}if(h.emptyWindow){const D=N.URI.parse(h.emptyWindow);o=r.find(j=>this.r.extUri.isEqual(j.location,D))}}this.t={profiles:r,workspaces:c,emptyWindow:o}}return this.t}async createTransientProfile(r){const o="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const D of this.profiles){const j=c.exec(D.name),W=j?parseInt(j[1]):0;a=W>a?W:a}const h=`${o} ${a+1}`;return this.createProfile((0,T.hash)((0,E.generateUuid)()).toString(16),h,{transient:!0},r)}async createNamedProfile(r,o,c){return this.createProfile((0,T.hash)((0,E.generateUuid)()).toString(16),r,o,c)}async createProfile(r,o,c,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=await this.v(r,o,c);return a&&await this.setProfileForWorkspace(a,h),h}async v(r,o,c){if(!(0,g.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(o);return a||(a=(async()=>{try{const h=this.profiles.find(W=>W.name===o||W.id===r);if(h)return h;const D=s(r,o,(0,L.joinPath)(this.profilesHome,r),c);await this.n.createFolder(D.location);const j=[];return this.h.fire({profile:D,join(W){j.push(W)}}),await S.Promises.settled(j),this.C([D],[],[]),D}finally{this.k.delete(o)}})(),this.k.set(o,a)),a}async updateProfile(r,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(a=>a.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);return c=s(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.C([],[],[c]),c}async removeProfile(r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const c=[];this.i.fire({profile:o,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.s.error(a)}o.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const a of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.G(),this.C([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(a){this.s.error(a)}}getOrSetProfileForWorkspace(r,o=this.defaultProfile){if(!this.f)return this.defaultProfile;let c=this.w(r);return c||(c=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,c)),c}async setProfileForWorkspace(r,o){this.setProfileForWorkspaceSync(r,o)}setProfileForWorkspaceSync(r,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(a=>a.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.F(r,c)}unsetWorkspace(r,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(r,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const r=await this.n.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.l.profiles.filter(o=>!this.z(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}w(r){const o=this.y(r);return N.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindow??this.u.emptyWindow}y(r){return(0,p.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,p.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}z(r){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,r.location)||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,r.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,r.location)||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,r.location)))}C(r,o,c){const a=[...this.profiles,...r],h=[];this.l.profiles=[];for(let D of a)D.isDefault||o.some(j=>D.id===j.id)||(D=c.find(j=>D.id===j.id)??D,D.isTransient?this.l.profiles.push(D):h.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.I(h),this.t=void 0,this.D(r,o,c)}D(r,o,c){this.g.fire({added:r,removed:o,updated:c,all:this.profiles})}F(r,o,c){c=o?.isTransient?!0:c,c||this.F(r,void 0,!0);const a=this.y(r),h=c?this.l:this.u;N.URI.isUri(a)?(h.workspaces.delete(a),o&&h.workspaces.set(a,o)):h.emptyWindow=o,c||this.G()}G(){const r={};for(const[c,a]of this.u.workspaces.entries())r[c.toString()]=a.location.toString();const o=this.u.emptyWindow?.location.toString();this.L({workspaces:r,emptyWindow:o}),this.t=void 0}H(){return[]}I(r){throw new Error("not implemented")}J(){return{}}L(r){throw new Error("not implemented")}M(){}};t.b="userDataProfiles",t.c="profileAssociations",t=de([_(0,d.IEnvironmentService),_(1,u.IFileService),_(2,w.IUriIdentityService),_(3,y.ILogService)],t),e.UserDataProfilesService=t;class n extends t{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(r){this.a=r}J(){return this.P}L(r){this.P=r}}e.InMemoryUserDataProfilesService=n}),define(Y[144],Z([0,1,19,3,22,10,4,2,12,11,86,23,24,27,9,26,32,25]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w,S,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,r,o,c,a){super(),this.t=i,this.u=r,this.v=o,this.w=c,this.y=a,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:h})=>h.cancel()),this.k.forEach(h=>h.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,y.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.t.isEnabled())throw new y.ExtensionManagementError(m.localize(0,null),y.ExtensionManagementErrorCode.Internal);const o=await this.G(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw s(this.u,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(i),error:o}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(o),f(o)}}async uninstall(i,r={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,r,o){const c={...o,installOnlyNewlyAddedFromExtensionPack:u.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,I.isApplicationScopedExtension)(i)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},a=X=>`${p.ExtensionKey.create(X).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!u.URI.isUri(r)){const X=this.j.get(a(r));if(X){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ee}=await X.task.waitUntilTaskIsFinished();return ee}}const h=[],D=[],j=[],W=this.Q(i,r,c);u.URI.isUri(r)||this.j.set(a(r),{task:W,waitingTasks:[]}),this.l.fire({identifier:W.identifier,source:r,profileLocation:c.profileLocation}),this.v.info("Installing extension:",W.identifier.id),h.push({task:W,manifest:i});let J=!1;try{if(c.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",W.identifier.id);else try{const ee=await this.F(W.identifier,i,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),ne=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:Q,manifest:ge}of ee){J=J||!!ge.extensionDependencies?.some(me=>(0,p.areSameExtensions)({id:me},W.identifier));const ce=a(Q),re=this.j.get(ce);if(re){if(this.C(W,re.task)){this.v.info("Waiting for already requested installing extension",Q.identifier.id,W.identifier.id),re.waitingTasks.push(W);const me=re.task.identifier;D.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,M=>M.some(A=>(0,p.areSameExtensions)(A.identifier,me)))).then(M=>{if(!M.find(U=>(0,p.areSameExtensions)(U.identifier,me))?.local)throw new Error(`Extension ${me.id} is not installed`)}))}}else if(!ne.some(({identifier:me})=>(0,p.areSameExtensions)(me,Q.identifier))){const me=this.Q(ge,Q,{...c,donotIncludePackAndDependencies:!0});this.j.set(ce,{task:me,waitingTasks:[W]}),this.l.fire({identifier:me.identifier,source:Q,profileLocation:c.profileLocation}),this.v.info("Installing extension:",me.identifier.id,W.identifier.id),h.push({task:me,manifest:ge})}}}catch(ee){if(u.URI.isUri(W.source))(0,T.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",W.identifier.id,ee.message),(0,T.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",W.identifier.id,ee.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",W.identifier.id),ee}const X=h.reduce((ee,{task:ne,manifest:Q})=>(ee.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:Q}),ee),new Map);for(;X.size;){let ee;const ne=[...X.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(ge=>X.has(ge.toLowerCase())));ne.length?ee=X.size===1?ne:ne.filter(({task:Q})=>!(Q===W&&!J)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:Q})=>Q.identifier.id)),ee=[...X.values()]),await this.D(ee.map(async({task:Q})=>{const ge=new Date().getTime();try{const{local:ce}=await Q.run();if(await this.D(this.s.map(re=>re.postInstall(ce,Q.source,c,k.CancellationToken.None))),!u.URI.isUri(Q.source)){const re=Q.operation===3,me=re?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(s(this.u,re?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Q.source),wasVerified:Q.wasVerified,duration:new Date().getTime()-ge,durationSinceUpdate:me}),d.isWeb&&Q.operation!==3)try{await this.t.reportStatistic(ce.manifest.publisher,ce.manifest.name,ce.manifest.version,"install")}catch{}}j.push({local:ce,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:ce.isApplicationScoped})}catch(ce){throw u.URI.isUri(Q.source)||s(this.u,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Q.source),wasVerified:Q.wasVerified,duration:new Date().getTime()-ge,error:ce}),this.v.error("Error while installing the extension:",Q.identifier.id),ce}finally{X.delete(Q.identifier.id.toLowerCase())}}))}return D.length&&await this.D(D),j.forEach(({identifier:ee})=>this.v.info("Extension installed successfully:",ee.id)),this.m.fire(j),j.filter(({identifier:ee})=>(0,p.areSameExtensions)(ee,W.identifier))[0].local}catch(X){if(h.forEach(({task:ee})=>ee.cancel()),j.length)try{const ee=await Promise.allSettled(j.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let ne=0;ne<ee.length;ne++){const Q=ee[ne],{identifier:ge}=j[ne];Q.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",ge.id):this.v.warn("Rollback: Error while uninstalling extension",ge.id,(0,L.getErrorMessage)(Q.reason))}}catch(ee){this.v.warn("Error while rolling back extensions",(0,L.getErrorMessage)(ee),j.map(({identifier:ne})=>ne.id))}throw this.m.fire(h.map(({task:ee})=>({identifier:ee.identifier,operation:2,source:ee.source,context:c.context,profileLocation:c.profileLocation}))),X}finally{for(const[X,{task:ee,waitingTasks:ne}]of this.j.entries()){const Q=ne.indexOf(W);Q!==-1&&ne.splice(Q,1),ne.length===0&&(ee===W||Q!==-1)&&this.j.delete(X)}}}C(i,r){for(const[,{task:o,waitingTasks:c}]of this.j.entries())if(o===i&&(c.includes(r)||c.some(a=>this.C(a,r)))||o===r&&c[0]&&!this.C(i,c[0]))return!1;return!0}async D(i){const r=[],o=[],c=await Promise.allSettled(i);for(const a of c)a.status==="fulfilled"?r.push(a.value):o.push(a.reason);if(o.length)throw v(o);return r}async F(i,r,o,c,a){if(!this.t.isEnabled())return[];const h=await this.getInstalled(void 0,a),D=[i],j=[],W=async(J,X)=>{const ee=X.extensionDependencies||[],ne=[...ee];if(X.extensionPack){const Q=o?h.find(ge=>(0,p.areSameExtensions)(ge.identifier,J)):void 0;for(const ge of X.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(ce=>(0,p.areSameExtensions)({id:ce},{id:ge}))||ne.every(ce=>!(0,p.areSameExtensions)({id:ce},{id:ge}))&&ne.push(ge)}if(ne.length){const Q=[...D,...j.map(ce=>ce.gallery.identifier)],ge=ne.filter(ce=>Q.every(re=>!(0,p.areSameExtensions)(re,{id:ce})));if(ge.length){const ce=await this.t.getExtensions(ge.map(re=>({id:re,preRelease:c})),k.CancellationToken.None);for(const re of ce){if(Q.find(A=>(0,p.areSameExtensions)(A,re.identifier)))continue;const me=ee.some(A=>(0,p.areSameExtensions)({id:A},re.identifier));let M;try{M=await this.G(re,!1,c)}catch(A){if(A instanceof y.ExtensionManagementError&&A.code===y.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!me){this.v.info("Skipping the packed extension as it cannot be installed",re.identifier.id);continue}else throw A}j.push({gallery:M.extension,manifest:M.manifest}),await W(M.extension.identifier,M.manifest)}}}};return await W(i,r),j}async G(i,r,o){if((await this.getExtensionsControlManifest()).malicious.some(D=>(0,p.areSameExtensions)(i.identifier,D)))throw new y.ExtensionManagementError(m.localize(1,null,i.identifier.id),y.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const D=await this.getTargetPlatform();throw new y.ExtensionManagementError(m.localize(2,null,i.identifier.id,this.w.nameLong,(0,y.TargetPlatformToString)(D)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.H(i,r,o);if(a){if(o&&!r&&i.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new y.ExtensionManagementError(m.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),y.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],k.CancellationToken.None))[0]?new y.ExtensionManagementError(m.localize(4,null,i.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.ExtensionManagementError(m.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),y.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",a.identifier.id);const h=await this.t.getManifest(a,k.CancellationToken.None);if(h===null)throw new y.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(h.version!==a.version)throw new y.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:h}}async H(i,r,o){const c=await this.getTargetPlatform();let a=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(a=(await this.t.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.t.isExtensionCompatible(i,o,c)&&(a=i),a||(r?a=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.t.getCompatibleExtension(i,o,c)),a}async I(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},c=J=>`${J.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,a=this.k.get(c(i.identifier));if(a)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),a.waitUntilTaskIsFinished();const h=J=>{const X=this.R(J,o);return this.k.set(c(X.extension.identifier),X),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${J.identifier.id}@${J.manifest.version}`),this.n.fire({identifier:J.identifier,profileLocation:o.profileLocation,applicationScoped:J.isApplicationScoped}),X},D=(J,X)=>{X?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,o.profileLocation.toString(),X.message):this.v.error("Failed to uninstall extension:",`${J.identifier.id}@${J.manifest.version}`,X.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${J.identifier.id}@${J.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${J.identifier.id}@${J.manifest.version}`),s(this.u,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(J),error:X}),this.p.fire({identifier:J.identifier,error:X?.code,profileLocation:o.profileLocation,applicationScoped:J.isApplicationScoped})},j=[],W=[];try{j.push(h(i));const J=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const X=this.M(i,J);for(const ee of X)this.k.has(c(ee.identifier))?this.v.info("Extensions is already requested to uninstall",ee.identifier.id):j.push(h(ee))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(j.map(X=>X.extension),J,i),await this.D(j.map(async X=>{try{if(await X.run(),await this.D(this.s.map(ee=>ee.postUninstall(X.extension,o,k.CancellationToken.None))),X.extension.identifier.uuid)try{await this.t.reportStatistic(X.extension.manifest.publisher,X.extension.manifest.name,X.extension.manifest.version,"uninstall")}catch{}D(X.extension)}catch(ee){const ne=ee instanceof y.ExtensionManagementError?ee:new y.ExtensionManagementError((0,L.getErrorMessage)(ee),y.ExtensionManagementErrorCode.Internal);throw D(X.extension,ne),ne}finally{W.push(X)}}))}catch(J){const X=J instanceof y.ExtensionManagementError?J:new y.ExtensionManagementError((0,L.getErrorMessage)(J),y.ExtensionManagementErrorCode.Internal);for(const ee of j){try{ee.cancel()}catch{}W.includes(ee)||D(ee.extension,X)}throw X}finally{for(const J of j)this.k.delete(c(J.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",J.extension.identifier.id)}}J(i,r,o){for(const c of i){const a=this.N(c,r);if(a.length){const h=a.filter(D=>!i.some(j=>(0,p.areSameExtensions)(j.identifier,D.identifier)));if(h.length)throw new Error(this.L(c,h,o))}}}L(i,r,o){return o===i?r.length===1?m.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?m.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const a=r.filter(D=>!D.isBuiltin&&c.some(j=>(0,p.areSameExtensions)({id:j},D.identifier))),h=[];for(const D of a)h.push(...this.M(D,r,o));return[...a,...h]}return[]}N(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,p.areSameExtensions)({id:c},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};g=de([_(0,y.IExtensionGalleryService),_(1,E.ITelemetryService),_(2,w.ILogService),_(3,S.IProductService),_(4,l.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function v(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=v;function f(n){if(n instanceof y.ExtensionManagementError)return n;const i=new y.ExtensionManagementError(n.message,y.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function s(n,i,{extensionData:r,wasVerified:o,duration:c,error:a,durationSinceUpdate:h}){let D,j;a&&(a instanceof y.ExtensionManagementError?(D=a.code,a.code===y.ExtensionManagementErrorCode.Signature&&(j=a.message)):D=y.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,wasVerified:o,success:!a,duration:c,errorcode:D,errorcodeDetail:j,durationSinceUpdate:h})}e.reportTelemetry=s;class t{constructor(){this.d=new O.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.createCancelablePromise)(i=>new Promise((r,o)=>{const c=i.onCancellationRequested(()=>{c.dispose(),o(new L.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=t}),define(Y[42],Z([0,1,3,15,2,4,36,11,24,27,13,8,9,25,28]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let S=class extends k.Disposable{constructor(g,v,f,s){super(),this.h=g,this.i=v,this.j=f,this.k=s,this.a=this.B(new L.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new L.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new L.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new L.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(g){return this.l(g)}async addExtensionsToProfile(g,v){const f=[],s=[];try{return await this.l(v,t=>{const n=[];for(const i of t)g.some(([r])=>(0,d.areSameExtensions)(r.identifier,i.identifier)&&r.manifest.version!==i.version)?f.push(i):n.push(i);for(const[i,r]of g)if(!n.some(o=>(0,d.areSameExtensions)(o.identifier,i.identifier)&&o.version===i.manifest.version)){const o={identifier:i.identifier,version:i.manifest.version,location:i.location,metadata:r};s.push(o),n.push(o)}return s.length&&this.a.fire({extensions:s,profileLocation:v}),f.length&&this.c.fire({extensions:f,profileLocation:v}),n}),s.length&&this.b.fire({extensions:s,profileLocation:v}),f.length&&this.f.fire({extensions:f,profileLocation:v}),s}catch(t){throw s.length&&this.b.fire({extensions:s,error:t,profileLocation:v}),f.length&&this.f.fire({extensions:f,error:t,profileLocation:v}),t}}async removeExtensionFromProfile(g,v){const f=[];this.c.fire({extensions:f,profileLocation:v});try{await this.l(v,s=>{const t=[];for(const n of s)(0,d.areSameExtensions)(n.identifier,g.identifier)?f.push(n):t.push(n);return f.length&&this.c.fire({extensions:f,profileLocation:v}),t}),f.length&&this.f.fire({extensions:f,profileLocation:v})}catch(s){throw f.length&&this.f.fire({extensions:f,error:s,profileLocation:v}),s}}async l(g,v){return this.p(g).queue(async()=>{let f=[],s;try{const t=await this.h.readFile(g);s=JSON.parse(t.value.toString())}catch(t){if((0,m.toFileOperationResult)(t)!==1)throw t;this.j.extUri.isEqual(g,this.i.defaultProfile.extensionsResource)&&(s=await this.n())}if(s)for(const t of s){if(!t.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",t);continue}if(!t.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",t);continue}if(!t.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",t);continue}f.push({identifier:t.identifier,location:P.URI.revive(t.location),version:t.version,metadata:t.metadata})}if(v){f=v(f);const t=f.map(n=>({identifier:n.identifier,version:n.version,location:n.location.toJSON(),metadata:n.metadata}));await this.h.writeFile(g,O.VSBuffer.fromString(JSON.stringify(t)))}return f})}async n(){return this.m||(this.m=(async()=>{const g=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let v;try{v=(await this.h.readFile(g)).value.toString()}catch(s){if((0,m.toFileOperationResult)(s)===1)return;throw s}this.k.info("Migrating extensions from old default profile location",g.toString());let f;try{const s=JSON.parse(v);Array.isArray(s)&&s.every(t=>!!(t&&typeof t=="object"&&(0,u.isIExtensionIdentifier)(t.identifier)&&E(t.location)&&t.version&&typeof t.version=="string"))?f=s:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.k.error(s)}if(f)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(f)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",g.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(s){if((0,m.toFileOperationResult)(s)===3)this.k.info("Migration from old default profile location to new location is done by another window",g.toString(),this.i.defaultProfile.extensionsResource.toString());else throw s}try{await this.h.del(g)}catch(s){(0,m.toFileOperationResult)(s)!==1&&this.k.error(s)}return f})()),this.m}p(g){let v=this.g.get(g);return v||(v=new T.Queue,this.g.set(g,v)),v}};S=de([_(0,m.IFileService),_(1,I.IUserDataProfilesService),_(2,w.IUriIdentityService),_(3,p.ILogService)],S),e.ExtensionsProfileScannerService=S;function E(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}}),define(Y[48],Z([0,1,19,3,29,15,10,50,77,2,16,14,12,17,39,53,5,11,90,18,24,27,45,13,8,9,26,4,44,42,25,28,106,107]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w,S,E,l,g,v,f,s,t,n,i,r,o,c,a,h,D,j,W,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(me){function M(A,U){if(A===U)return!0;const V=Object.keys(A),G=new Set;for(const q of Object.keys(U))G.add(q);if(V.length!==G.size)return!1;for(const q of V){if(A[q]!==U[q])return!1;G.delete(q)}return G.size===0}me.equals=M})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ee=class extends u.Disposable{constructor(M,A,U,V,G,q,te,b,R,C,F,B){super(),this.systemExtensionsLocation=M,this.userExtensionsLocation=A,this.l=U,this.m=V,this.n=G,this.p=q,this.r=te,this.s=b,this.t=R,this.u=C,this.v=F,this.w=B,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,I.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ge,(0,I.joinPath)(this.m,s.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ge,(0,I.joinPath)(this.m,s.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(Q,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,f.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(M,A,U){const[V,G]=await Promise.all([this.scanSystemExtensions(M),this.scanUserExtensions(A)]),q=U?await this.scanExtensionsUnderDevelopment(M,[...V,...G]):[];return this.D(V,G,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(M){const A=[];A.push(this.F(!!M.useCache,M.language)),A.push(this.G(M.language,!!M.checkControlFile));const[U,V]=await Promise.all(A);return this.C([...U,...V],0,M,!1)}async scanUserExtensions(M){const A=M.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",A);const U=await this.I(A,!!M.profileLocation,1,!M.includeUninstalled,M.language);let G=await(M.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k).scanExtensions(U);return G=await this.C(G,1,M,!0),this.s.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(M,A){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(V=>V.scheme===m.Schemas.file).map(async V=>{const G=await this.I(V,!1,1,!0,M.language,!1);return(await this.k.scanOneOrMultipleExtensions(G)).map(te=>(te.type=A.find(b=>(0,f.areSameExtensions)(b.identifier,te.identifier))?.type??te.type,this.k.validate(te,G)))}))).flat();return this.C(U,"development",M,!0)}return[]}async scanExistingExtension(M,A,U){const V=await this.I(M,!1,A,!0,U.language),G=await this.k.scanExtension(V);return!G||!U.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(M,A,U){const V=await this.I(M,!1,A,!0,U.language),G=await this.k.scanOneOrMultipleExtensions(V);return this.C(G,A,U,!0)}async scanMetadata(M){const A=(0,I.joinPath)(M,"package.json"),U=(await this.r.readFile(A)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(M,A){const U=(0,I.joinPath)(M,"package.json"),V=(await this.r.readFile(U)).value.toString(),G=JSON.parse(V);A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0,G.__metadata={...G.__metadata,...A},await this.r.writeFile((0,I.joinPath)(M,"package.json"),L.VSBuffer.fromString(JSON.stringify(G,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const M=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(M))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const A=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(A.map(U=>[U,U.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(M,L.VSBuffer.fromString(""))}catch(A){(0,n.toFileOperationResult)(A)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(A))}}catch(M){throw this.s.error(M),M}})()),this.z}async C(M,A,U,V){return U.includeAllVersions||(M=this.D(A===0?M:void 0,A===1?M:void 0,A==="development"?M:void 0,await this.getTargetPlatform(),V)),U.includeInvalid||(M=M.filter(G=>G.isValid)),M.sort((G,q)=>{const te=y.basename(G.location.fsPath),b=y.basename(q.location.fsPath);return te<b?-1:te>b?1:0})}D(M,A,U,V,G){const q=(b,R,C)=>{if(b.isValid&&!R.isValid)return!1;if(b.isValid===R.isValid){if(G&&w.gt(b.manifest.version,R.manifest.version))return this.s.debug(`Skipping extension ${R.location.path} with lower version ${R.manifest.version} in favour of ${b.location.path} with version ${b.manifest.version}`),!1;if(w.eq(b.manifest.version,R.manifest.version)){if(b.type===0)return this.s.debug(`Skipping extension ${R.location.path} in favour of system extension ${b.location.path} with same version`),!1;if(b.targetPlatform===V)return this.s.debug(`Skipping extension ${R.location.path} from different target platform ${R.targetPlatform}`),!1}}return C?this.s.warn(`Overwriting user extension ${b.location.path} with ${R.location.path}.`):this.s.debug(`Overwriting user extension ${b.location.path} with ${R.location.path}.`),!0},te=new Map;return M?.forEach(b=>{const R=s.ExtensionIdentifier.toKey(b.identifier.id),C=te.get(R);(!C||q(C,b,!1))&&te.set(R,b)}),A?.forEach(b=>{const R=s.ExtensionIdentifier.toKey(b.identifier.id),C=te.get(R);if(!C&&M&&b.type===0){this.s.debug(`Skipping obsolete system extension ${b.location.path}.`);return}(!C||q(C,b,!1))&&te.set(R,b)}),U?.forEach(b=>{const R=s.ExtensionIdentifier.toKey(b.identifier.id),C=te.get(R);(!C||q(C,b,!0))&&te.set(R,b),te.set(R,b)}),[...te.values()]}async F(M,A){this.s.trace("Started scanning system extensions");const U=await this.I(this.systemExtensionsLocation,!1,0,!0,A),G=await(M&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",G.length),G}async G(M,A){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const V=A?await this.H():{},G=[],q=l.URI.file(y.normalize(y.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const b of U){const R=V[b.name]||"marketplace";switch(R){case"disabled":break;case"marketplace":G.push((0,I.joinPath)(q,b.name));break;default:G.push(l.URI.file(R));break}}const te=await Promise.all(G.map(async b=>this.k.scanExtension(await this.I(b,!1,0,!0,M))));return this.s.trace("Scanned dev system extensions:",te.length),(0,T.coalesce)(te)}async H(){try{const M=await this.r.readFile(this.l);return JSON.parse(M.value.toString())}catch{return{}}}async I(M,A,U,V,G,q=!0){const te=await this.f(G??p.language),b=await this.J(M),R=A&&!this.v.extUri.isEqual(M,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,C=R?await this.J(R):void 0;return new ne(M,b,R,C,A,U,V,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,G,te)}async J(M){try{const A=await this.r.stat(M);if(typeof A.mtime=="number")return A.mtime}catch{}}};ee=de([_(4,D.IUserDataProfilesService),_(5,h.IExtensionsProfileScannerService),_(6,n.IFileService),_(7,r.ILogService),_(8,v.IEnvironmentService),_(9,o.IProductService),_(10,j.IUriIdentityService),_(11,i.IInstantiationService)],ee),e.AbstractExtensionsScannerService=ee;class ne{constructor(M,A,U,V,G,q,te,b,R,C,F,B,x,ie){this.location=M,this.mtime=A,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=V,this.profile=G,this.type=q,this.excludeObsolete=te,this.validate=b,this.productVersion=R,this.productDate=C,this.productCommit=F,this.devMode=B,this.language=x,this.translations=ie}static createNlsConfiguration(M){return{language:M.language,pseudo:M.language==="pseudo",devMode:M.devMode,translations:M.translations}}static equals(M,A){return(0,I.isEqual)(M.location,A.location)&&M.mtime===A.mtime&&(0,I.isEqual)(M.applicationExtensionslocation,A.applicationExtensionslocation)&&M.applicationExtensionslocationMtime===A.applicationExtensionslocationMtime&&M.profile===A.profile&&M.type===A.type&&M.excludeObsolete===A.excludeObsolete&&M.validate===A.validate&&M.productVersion===A.productVersion&&M.productDate===A.productDate&&M.productCommit===A.productCommit&&M.devMode===A.devMode&&M.language===A.language&&X.equals(M.translations,A.translations)}}let Q=class extends u.Disposable{constructor(M,A,U,V,G){super(),this.f=M,this.g=A,this.h=U,this.i=V,this.j=G}async scanExtensions(M){const A=M.profile?await this.l(M):await this.k(M);let U={};if(M.excludeObsolete&&M.type===1)try{const V=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(V)}catch{}return(0,E.isEmptyObject)(U)?A:A.filter(V=>!U[f.ExtensionKey.create(V).toString()])}async k(M){const A=await this.i.resolve(M.location);if(!A.children?.length)return[];const U=await Promise.all(A.children.map(async V=>{if(!V.isDirectory||M.type===1&&(0,I.basename)(V.resource).indexOf(".")===0)return null;const G=new ne(V.resource,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(G)}));return(0,T.coalesce)(U).sort((V,G)=>V.location.path<G.location.path?-1:1)}async l(M){let A=await this.m(M.location,()=>!0,M);if(M.applicationExtensionslocation&&!this.h.extUri.isEqual(M.location,M.applicationExtensionslocation)){A=A.filter(V=>!V.metadata?.isApplicationScoped);const U=await this.m(M.applicationExtensionslocation,V=>!!V.metadata?.isApplicationScoped,M);A.push(...U)}return A}async m(M,A,U){const V=await this.g.scanProfileExtensions(M);if(!V.length)return[];const G=await Promise.all(V.map(async q=>{if(A(q)){const te=new ne(q.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(te,q.metadata)}return null}));return(0,T.coalesce)(G)}async scanOneOrMultipleExtensions(M){try{if(await this.i.exists((0,I.joinPath)(M.location,"package.json"))){const A=await this.scanExtension(M);return A?[A]:[]}else return await this.scanExtensions(M)}catch(A){return this.j.error(`Error scanning extensions at ${M.location.path}:`,(0,N.getErrorMessage)(A)),[]}}async scanExtension(M,A){try{let U=await this.scanExtensionManifest(M.location);if(U){U.publisher||(U.publisher=s.UNDEFINED_PUBLISHER),A=A??U.__metadata,delete U.__metadata;const V=(0,f.getGalleryExtensionId)(U.publisher,U.name),G=A?.id?{id:V,uuid:A.id}:{id:V},q=A?.isSystem?0:M.type,te=q===0||!!A?.isBuiltin;J.ImplicitActivationEvents.updateManifest(U),U=await this.n(M.location,U,ne.createNlsConfiguration(M));const b={type:q,identifier:G,manifest:U,location:M.location,isBuiltin:te,targetPlatform:A?.targetPlatform??"undefined",metadata:A,isValid:!0,validations:[]};return M.validate?this.validate(b,M):b}}catch(U){M.type!==0&&this.j.error(U)}return null}validate(M,A){let U=!0;const V=(0,t.validateExtensionManifest)(A.productVersion,A.productDate,A.location,M.manifest,M.isBuiltin);for(const[G,q]of V)G===S.default.Error&&(U=!1,this.j.error(this.t(A.location,q)));return M.isValid=U,M.validations=V,M}async scanExtensionManifest(M){const A=(0,I.joinPath)(M,"package.json");let U;try{U=(await this.i.readFile(A)).value.toString()}catch(G){return(0,n.toFileOperationResult)(G)!==1&&this.j.error(this.t(M,(0,g.localize)(0,null,A.path,G.message))),null}let V;try{V=JSON.parse(U)}catch{const q=[];(0,P.parse)(U,q);for(const te of q)this.j.error(this.t(M,(0,g.localize)(1,null,A.path,te.offset,te.length,(0,d.getParseErrorMessage)(te.error))));return null}return(0,P.getNodeType)(V)!=="object"?(this.j.error(this.t(M,(0,g.localize)(2,null,A.path))),null):V}async n(M,A,U){const V=await this.p(M,A,U);if(V)try{const G=[],q=await this.r(V.default,G);if(G.length>0)return G.forEach(b=>{this.j.error(this.t(M,(0,g.localize)(3,null,V.default?.path,(0,d.getParseErrorMessage)(b.error))))}),A;if((0,P.getNodeType)(V)!=="object")return this.j.error(this.t(M,(0,g.localize)(4,null,V.default?.path))),A;const te=V.values||Object.create(null);return(0,W.localizeManifest)(A,te,q)}catch{}return A}async p(M,A,U){const V=(0,I.joinPath)(M,"package.nls.json"),G=(R,C)=>{C.forEach(F=>{this.j.error(this.t(M,(0,g.localize)(5,null,R?.path,(0,d.getParseErrorMessage)(F.error))))})},q=R=>{this.j.error(this.t(M,(0,g.localize)(6,null,R?.path)))},te=`${A.publisher}.${A.name}`,b=U.translations[te];if(b)try{const R=l.URI.file(b),C=(await this.i.readFile(R)).value.toString(),F=[],B=(0,P.parse)(C,F);return F.length>0?(G(R,F),{values:void 0,default:V}):(0,P.getNodeType)(B)!=="object"?(q(R),{values:void 0,default:V}):{values:B.contents?B.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.i.exists(V))return;let C;try{C=await this.s(M,U)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const F=(await this.i.readFile(C.localized)).value.toString(),B=[],x=(0,P.parse)(F,B);return B.length>0?(G(C.localized,B),{values:void 0,default:C.original}):(0,P.getNodeType)(x)!=="object"?(q(C.localized),{values:void 0,default:C.original}):{values:x,default:C.original}}catch{return{values:void 0,default:C.original}}}}async r(M,A){if(M)try{const U=(await this.i.readFile(M)).value.toString();return(0,P.parse)(U,A)}catch{}}s(M,A){return new Promise((U,V)=>{const G=q=>{const te=(0,I.joinPath)(M,`package.nls.${q}.json`);this.i.exists(te).then(b=>{b&&U({localized:te,original:(0,I.joinPath)(M,"package.nls.json")});const R=q.lastIndexOf("-");R===-1?U({localized:(0,I.joinPath)(M,"package.nls.json"),original:null}):(q=q.substring(0,R),G(q))})};if(A.devMode||A.pseudo||!A.language)return U({localized:(0,I.joinPath)(M,"package.nls.json"),original:null});G(A.language)})}t(M,A){return`[${M.path}]: ${A}`}};Q=de([_(1,h.IExtensionsProfileScannerService),_(2,j.IUriIdentityService),_(3,n.IFileService),_(4,r.ILogService)],Q);let ge=class extends Q{constructor(M,A,U,V,G,q){super(A,U,V,G,q),this.y=M,this.v=this.B(new O.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(M){const A=await this.z();if(this.u=M,A&&A.input&&ne.equals(A.input,this.u))return this.v.trigger(()=>this.D()),A.result.map(V=>(V.location=l.URI.revive(V.location),V));const U=await super.scanExtensions(M);return await this.C({input:M,result:U}),U}async z(){try{const M=await this.i.readFile(this.y),A=JSON.parse(M.value.toString());return{result:A.result,input:(0,a.revive)(A.input)}}catch(M){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(M))}return null}async C(M){try{await this.i.writeFile(this.y,L.VSBuffer.fromString(JSON.stringify(M)))}catch(A){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(A))}}async D(){if(!this.u)return;const M=await this.z();if(!M)return;const A=M.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(U,A))try{await this.i.del(this.y),this.w.fire()}catch(V){this.j.error(V)}}};ge=de([_(2,h.IExtensionsProfileScannerService),_(3,j.IUriIdentityService),_(4,n.IFileService),_(5,r.ILogService)],ge);function ce(me,M){const A=(0,f.getExtensionId)(me.manifest.publisher,me.manifest.name);return{id:A,identifier:new s.ExtensionIdentifier(A),isBuiltin:me.type===0,isUserBuiltin:me.type===1&&me.isBuiltin,isUnderDevelopment:M,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,...me.manifest}}e.toExtensionDescription=ce;class re extends ee{constructor(M,A,U,V,G,q,te,b,R,C,F,B){super(M,A,(0,I.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,I.joinPath)(V,s.MANIFEST_CACHE_FOLDER),G,q,te,b,R,C,F,B),this.L=(async()=>{if(p.translationsConfigFile)try{const x=await this.r.readFile(l.URI.file(p.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(M){return this.L}}e.NativeExtensionsScannerService=re}),define(Y[145],Z([0,1,57,3,34,4,2,16,14,20,9,25]),function($,e,T,O,k,L,N,P,d,u,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends N.Disposable{constructor(w,S){super(),this.b=w,this.f=S,this.a=new O.Limiter(5)}async postUninstall(w){const S=this.g(w,"uninstall");return S&&(this.f.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(S.script,"uninstall",S.args,!0,w).then(()=>this.f.info(w.identifier.id,w.manifest.version,"Finished running post uninstall script"),E=>this.f.error(w.identifier.id,w.manifest.version,`Failed to run post uninstall script: ${E}`)))),u.Promises.rm(this.j(w)).then(void 0,E=>this.f.error("Error while removing extension storage path",E))}g(w,S){const E=`vscode:${S}`;if(w.location.scheme===P.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[E]=="string"){const l=w.manifest.scripts[E].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(w.identifier.id,w.manifest.version,`${E} should be a node script`),null):{script:(0,d.join)(w.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(w,S,E,l,g){return new Promise((v,f)=>{const s=this.i(w,S,E,g);let t;const n=i=>{t&&(clearTimeout(t),t=null),i?f(i):v(void 0)};s.on("error",i=>{n((0,k.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,r)=>{n(i?`post-${S} process exited with code ${i}`:void 0)}),l&&(t=setTimeout(()=>{t=null,s.kill(),f("timed out")},5e3))})}i(w,S,E,l){const g={silent:!0,execArgv:void 0},v=(0,T.fork)(w,[`--type=extension-post-${S}`,...E],g);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(v.stdout,"data"),s=L.Event.fromNodeEventEmitter(v.stderr,"data");f(i=>this.f.info(l.identifier.id,l.manifest.version,`post-${S}`,i)),s(i=>this.f.error(l.identifier.id,l.manifest.version,`post-${S}`,i));const t=L.Event.any(L.Event.map(f,i=>({data:`%c${i}`,format:[""]})),L.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(t,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(l.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),v}j(w){return(0,d.join)(this.b.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};p=de([_(0,y.IUserDataProfilesService),_(1,m.ILogService)],p),e.ExtensionsLifecycle=p}),define(Y[146],Z([0,1,11,18,42,48,13,8,9,26,28,25]),function($,e,T,O,k,L,N,P,d,u,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends L.NativeExtensionsScannerService{constructor(w,S,E,l,g,v,f,s){super(T.URI.file(g.builtinExtensionsPath),T.URI.file(g.extensionsPath),g.userHome,T.URI.file(g.userDataPath),w,S,E,l,g,v,f,s)}};p=de([_(0,y.IUserDataProfilesService),_(1,k.IExtensionsProfileScannerService),_(2,N.IFileService),_(3,d.ILogService),_(4,O.INativeEnvironmentService),_(5,u.IProductService),_(6,m.IUriIdentityService),_(7,P.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(Y[147],Z([0,1,3,4,2,117,5,83,8,25]),function($,e,T,O,k,L,N,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var m;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var p;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function I(g){const v=g.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=I;class w extends k.Disposable{constructor(v={flushInterval:w.a}){super(),this.j=v,this.b=this.B(new O.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new O.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.J()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(v,f){if(f===e.TARGET_KEY){switch(v){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:f,target:this.F(v)[f]})}r(v){this.f.fire({reason:v})}get(v,f,s){return this.L(f)?.get(v,s)}getBoolean(v,f,s){return this.L(f)?.getBoolean(v,s)}getNumber(v,f,s){return this.L(f)?.getNumber(v,s)}store(v,f,s,t){if((0,N.isUndefinedOrNull)(f)){this.remove(v,s);return}this.t(()=>{this.u(v,s,t),this.L(s)?.set(v,f)})}remove(v,f){this.t(()=>{this.u(v,f,void 0),this.L(f)?.delete(v)})}t(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,f){const s=[],t=this.F(v);for(const n of Object.keys(t))t[n]===f&&s.push(n);return s}u(v,f,s){const t=this.F(f);typeof s=="number"?t[v]!==s&&(t[v]=s,this.L(f)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[v]=="number"&&(delete t[v],this.L(f)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(v){switch(v){case-1:return this.D;case 0:return this.z;default:return this.w}}G(v){const f=this.L(v);return f?I(f):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=m.NONE){this.f.fire({reason:v});const f=this.L(-1),s=this.L(0),t=this.L(1);switch(v){case m.NONE:await T.Promises.settled([f?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await T.Promises.settled([f?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.L(-1)?.items??new Map,f=this.L(0)?.items??new Map,s=this.L(1)?.items??new Map;return l(v,f,s,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(v,f){return this.r(m.NONE),(0,u.isUserDataProfile)(v)?this.N(v,f):this.O(v,f)}H(v,f){return!(v.id===f.id||S(f)&&S(v))}I(v,f,s,t){this.t(()=>{if(t)for(const[n,i]of v)f.set(n,i);else{const n=new Set;for(const[i,r]of v)n.add(i),f.get(i)!==r&&this.n(s,i);for(const[i]of f.items)n.has(i)||this.n(s,i)}})}}e.AbstractStorageService=w,w.a=60*1e3;function S(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class E extends w{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(v=>this.n(1,v))),this.B(this.P.onDidChangeStorage(v=>this.n(0,v))),this.B(this.p.onDidChangeStorage(v=>this.n(-1,v)))}L(v){switch(v){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(v){return!1}}e.InMemoryStorageService=E;async function l(g,v,f,s,t,n){const i=J=>{try{return JSON.parse(J)}catch{return J}},r=new Map,o=new Map;g.forEach((J,X)=>{r.set(X,J),o.set(X,i(J))});const c=new Map,a=new Map;v.forEach((J,X)=>{c.set(X,J),a.set(X,i(J))});const h=new Map,D=new Map;f.forEach((J,X)=>{h.set(X,J),D.set(X,i(J))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const j=[];if(r.forEach((J,X)=>{j.push({key:X,value:J})}),console.table(j),console.groupEnd(),console.log(o),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const J=[];c.forEach((X,ee)=>{J.push({key:ee,value:X})}),console.table(J),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${n})`);const W=[];h.forEach((J,X)=>{W.push({key:X,value:J})}),console.table(W),console.groupEnd(),console.log(D)}e.logStorage=l}),define(Y[148],Z([0,1,19,22,10,12,35,5,11,21,18,23,24,45,13,9,26,47,135,147,32]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w,S,E,l,g,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=L.isWeb?"web":(0,y.getTargetPlatform)(L.platform,N.arch);var t;(function(b){b[b.None=0]="None",b[b.IncludeVersions=1]="IncludeVersions",b[b.IncludeFiles=2]="IncludeFiles",b[b.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",b[b.IncludeSharedAccounts=8]="IncludeSharedAccounts",b[b.IncludeVersionProperties=16]="IncludeVersionProperties",b[b.ExcludeNonValidated=32]="ExcludeNonValidated",b[b.IncludeInstallationTargets=64]="IncludeInstallationTargets",b[b.IncludeAssetUri=128]="IncludeAssetUri",b[b.IncludeStatistics=256]="IncludeStatistics",b[b.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",b[b.Unpublished=4096]="Unpublished",b[b.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...b){return String(b.reduce((R,C)=>R|C,0))}var i;(function(b){b[b.Tag=1]="Tag",b[b.ExtensionId=4]="ExtensionId",b[b.Category=5]="Category",b[b.ExtensionName=7]="ExtensionName",b[b.Target=8]="Target",b[b.Featured=9]="Featured",b[b.SearchText=10]="SearchText",b[b.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class h{constructor(R=a){this.d=R}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(R,C=this.d.pageSize){return new h({...this.d,pageNumber:R,pageSize:C})}withFilter(R,...C){const F=[...this.d.criteria,...C.length?C.map(B=>({filterType:R,value:B})):[{filterType:R}]];return new h({...this.d,criteria:F})}withSortBy(R){return new h({...this.d,sortBy:R})}withSortOrder(R){return new h({...this.d,sortOrder:R})}withFlags(...R){return new h({...this.d,flags:R.reduce((C,F)=>C|F,0)})}withAssetTypes(...R){return new h({...this.d,assetTypes:R})}withSource(R){return new h({...this.d,source:R})}get raw(){const{criteria:R,pageNumber:C,pageSize:F,sortBy:B,sortOrder:x,flags:ie,assetTypes:se}=this.d;return{filters:[{criteria:R,pageNumber:C,pageSize:F,sortBy:B,sortOrder:x}],assetTypes:se,flags:ie}}get searchText(){const R=this.d.criteria.filter(C=>C.filterType===i.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(R=>String(R.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(b,R){const C=(b||[]).filter(F=>F.statisticName===R)[0];return C?C.value:0}function j(b){const R="Microsoft.VisualStudio.Code.Translation.";return b.files.filter(F=>F.assetType.indexOf(R)===0).reduce((F,B)=>{const x=X(b,B.assetType);return x&&F.push([B.assetType.substring(R.length),x]),F},[])}function W(b){if(b.properties){const R=b.properties.filter(B=>B.key===r.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=R.filter(B=>C.test(B.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return X(b,r.Repository)}function J(b){return{uri:`${b.fallbackAssetUri}/${r.VSIX}?redirect=true${b.targetPlatform?`&targetPlatform=${b.targetPlatform}`:""}`,fallbackUri:`${b.fallbackAssetUri}/${r.VSIX}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`}}function X(b,R){return b.files.filter(F=>F.assetType===R)[0]?{uri:`${b.assetUri}/${R}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`,fallbackUri:`${b.fallbackAssetUri}/${R}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`}:null}function ee(b,R){const C=b.properties?b.properties.filter(B=>B.key===R):[],F=C.length>0&&C[0].value;return F?F.split(",").map(B=>(0,p.adoptToGalleryExtensionId)(B)):[]}function ne(b){const R=b.properties?b.properties.filter(C=>C.key===o.Engine):[];return R.length>0&&R[0].value||""}function Q(b){const R=b.properties?b.properties.filter(C=>C.key===o.PreRelease):[];return R.length>0&&R[0].value==="true"}function ge(b){const R=b.properties?b.properties.filter(F=>F.key===o.LocalizedLanguages):[],C=R.length>0&&R[0].value||"";return C?C.split(","):[]}function ce(b){return b.properties?.find(R=>R.key===o.SponsorLink)?.value}function re(b){return b.indexOf("preview")!==-1}function me(b){return b.targetPlatform?(0,y.toTargetPlatform)(b.targetPlatform):"undefined"}function M(b){const R=(0,T.distinct)(b.versions.map(me)),C=!!b.tags?.includes(y.WEB_EXTENSION_TAG),F=R.indexOf("web");return C?F===-1&&R.push("web"):F!==-1&&R.splice(F,1),R}function A(b,R){const C=(0,y.getFallbackTargetPlarforms)(R);for(let F=0;F<b.length;F++){const B=b[F];if(B.version===b[F-1]?.version){let x=F;const ie=me(B);if(ie===R)for(;x>0&&b[x-1].version===B.version;)x--;else if(C.includes(ie))for(;x>0&&b[x-1].version===B.version&&me(b[x-1])!==R;)x--;x!==F&&(b.splice(F,1),b.splice(x,0,B))}}return b}e.sortExtensionVersions=A;function U(b,R,C){b.telemetryData={index:R,querySource:C}}function V(b,R,C){const F=b.versions[0],B={manifest:X(R,r.Manifest),readme:X(R,r.Details),changelog:X(R,r.Changelog),license:X(R,r.License),repository:W(R),download:J(R),icon:X(R,r.Icon),signature:X(R,r.Signature),coreTranslations:j(R)};return{identifier:{id:(0,p.getGalleryExtensionId)(b.publisher.publisherName,b.extensionName),uuid:b.extensionId},name:b.extensionName,version:R.version,displayName:b.displayName,publisherId:b.publisher.publisherId,publisher:b.publisher.publisherName,publisherDisplayName:b.publisher.displayName,publisherDomain:b.publisher.domain?{link:b.publisher.domain,verified:!!b.publisher.isDomainVerified}:void 0,publisherSponsorLink:ce(F),description:b.shortDescription||"",installCount:D(b.statistics,"install"),rating:D(b.statistics,"averagerating"),ratingCount:D(b.statistics,"ratingcount"),categories:b.categories||[],tags:b.tags||[],releaseDate:Date.parse(b.releaseDate),lastUpdated:Date.parse(b.lastUpdated),allTargetPlatforms:C,assets:B,properties:{dependencies:ee(R,o.Dependency),extensionPack:ee(R,o.ExtensionPack),engine:ne(R),localizedLanguages:ge(R),targetPlatform:me(R),isPreReleaseVersion:Q(R)},hasPreReleaseVersion:Q(F),hasReleaseVersion:!0,preview:re(b.flags),isSigned:!!B.signature}}let G=class{constructor(R,C,F,B,x,ie,se,pe){this.k=C,this.l=F,this.n=B,this.o=x,this.q=ie,this.u=se,this.w=pe;const ye=se.extensionsGallery,ae=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=ae?ye.servicePPEUrl:ye?.serviceUrl,this.g=ae?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,g.resolveMarketplaceHeaders)(se.version,se,this.n,this.w,this.q,R,this.o)}x(R=""){return`${this.d}${R}`}isEnabled(){return!!this.d}async getExtensions(R,C,F){const B=O.CancellationToken.isCancellationToken(C)?{}:C,x=O.CancellationToken.isCancellationToken(C)?C:F,ie=[],se=[],pe=[],ye=[];let ae=!0;for(const oe of R){oe.uuid?se.push(oe.uuid):ie.push(oe.id);const fe=!!(oe.version||oe.preRelease);pe.push({id:oe.id,uuid:oe.uuid,includePreRelease:fe}),oe.version&&ye.push({id:oe.id,uuid:oe.uuid,version:oe.version}),ae=ae&&!!oe.hasPreRelease&&!fe}if(!se.length&&!ie.length)return[];let ue=new h().withPage(1,R.length);se.length&&(ue=ue.withFilter(i.ExtensionId,...se)),ie.length&&(ue=ue.withFilter(i.ExtensionName,...ie)),(B.queryAllVersions||ae)&&(ue=ue.withFlags(ue.flags,t.IncludeVersions)),B.source&&(ue=ue.withSource(B.source));const{extensions:le}=await this.z(ue,{targetPlatform:B.targetPlatform??s,includePreRelease:pe,versions:ye,compatible:!!B.compatible},x);return B.source&&le.forEach((oe,fe)=>U(oe,fe,B.source)),le}async getCompatibleExtension(R,C,F){if((0,y.isNotWebExtensionInWebTargetPlatform)(R.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(R,C,F))return R;const B=new h().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,R.identifier.uuid),{extensions:x}=await this.z(B,{targetPlatform:F,compatible:!0,includePreRelease:C},O.CancellationToken.None);return x[0]||null}async isExtensionCompatible(R,C,F){if(!(0,y.isTargetPlatformCompatible)(R.properties.targetPlatform,R.allTargetPlatforms,F)||!C&&R.properties.isPreReleaseVersion)return!1;let B=R.properties.engine;if(!B){const x=await this.getManifest(R,O.CancellationToken.None);if(!x)throw new Error("Manifest was not found");B=x.engines.vscode}return(0,I.isEngineValid)(B,this.u.version,this.u.date)}async y(R,C,F,B,x){if(!(0,y.isTargetPlatformCompatible)(me(R),B,x)||C!=="any"&&Q(R)!==(C==="prerelease"))return!1;if(F)try{const ie=await this.E(R);if(!(0,I.isEngineValid)(ie,this.u.version,this.u.date))return!1}catch(ie){return this.l.error(`Error while getting the engine for the version ${R.version}.`,(0,k.getErrorMessage)(ie)),!1}return!0}async query(R,C){let F=R.text||"";const B=R.pageSize??50;let x=new h().withPage(1,B);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,ue,le)=>(x=x.withFilter(i.Category,le||ue),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,ue,le)=>(x=x.withFilter(i.Tag,le||ue),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(x=x.withFilter(i.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),x=x.withFilter(i.SearchText,F)),x=x.withSortBy(0)):R.ids?x=x.withFilter(i.ExtensionId,...R.ids):R.names?x=x.withFilter(i.ExtensionName,...R.names):x=x.withSortBy(4),typeof R.sortBy=="number"&&(x=x.withSortBy(R.sortBy)),typeof R.sortOrder=="number"&&(x=x.withSortOrder(R.sortOrder)),R.source&&(x=x.withSource(R.source));const ie=async(ae,ue)=>{const{extensions:le,total:oe}=await this.z(ae,{targetPlatform:s,compatible:!1,includePreRelease:!!R.includePreRelease},ue);return le.forEach((fe,Te)=>U(fe,(ae.pageNumber-1)*ae.pageSize+Te,R.source)),{extensions:le,total:oe}},{extensions:se,total:pe}=await ie(x,C),ye=async(ae,ue)=>{if(ue.isCancellationRequested)throw new k.CancellationError;const{extensions:le}=await ie(x.withPage(ae+1),ue);return le};return{firstPage:se,total:pe,pageSize:x.pageSize,getPage:ye}}async z(R,C,F){const B=R.flags;!!(R.flags&t.IncludeLatestVersionOnly)&&!!(R.flags&t.IncludeVersions)&&(R=R.withFlags(R.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(R.flags&t.IncludeLatestVersionOnly)&&!(R.flags&t.IncludeVersions)&&(R=R.withFlags(R.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(R=R.withFlags(R.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),R=R.withFlags(R.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:x,total:ie}=await this.B(R,F);if(!(R.flags&t.IncludeLatestVersionOnly)){const ae=[];for(const ue of x){const le=await this.A(ue,C);le&&ae.push(le)}return{extensions:ae,total:ie}}const pe=[],ye=new Map;for(let ae=0;ae<x.length;ae++){const ue=x[ae],le={id:(0,p.getGalleryExtensionId)(ue.publisher.publisherName,ue.extensionName),uuid:ue.extensionId},oe=(0,P.isBoolean)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(Te=>(0,p.areSameExtensions)(Te,le))?.includePreRelease;if(C.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(M(ue),C.targetPlatform))continue;const fe=await this.A(ue,C);!fe||fe.properties.isPreReleaseVersion&&(!oe||!fe.hasReleaseVersion)||!fe.properties.isPreReleaseVersion&&fe.properties.targetPlatform!==C.targetPlatform&&fe.hasPreReleaseVersion?ye.set(ue.extensionId,ae):pe.push([ae,fe])}if(ye.size){const ae=new Date().getTime(),ue=new h().withFlags(B&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ye.size).withFilter(i.ExtensionId,...ye.keys()),{extensions:le}=await this.z(ue,C,F);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ae,count:ye.size});for(const oe of le){const fe=ye.get(oe.identifier.uuid);pe.push([fe,oe])}}return{extensions:pe.sort((ae,ue)=>ae[0]-ue[0]).map(([,ae])=>ae),total:ie}}async A(R,C){const F={id:(0,p.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},B=C.versions?.find(pe=>(0,p.areSameExtensions)(pe,F))?.version,x=(0,P.isBoolean)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(pe=>(0,p.areSameExtensions)(pe,F))?.includePreRelease,ie=M(R),se=A(R.versions,C.targetPlatform);if(C.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(ie,C.targetPlatform))return null;for(let pe=0;pe<se.length;pe++){const ye=se[pe];if(!(B&&ye.version!==B)){if(await this.y(ye,x?"any":"release",C.compatible,ie,C.targetPlatform))return V(R,ye,ie);if(B&&ye.version===B)return null}}return B||C.compatible?null:V(R,R.versions[0],ie)}async B(R,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(t.Unpublished));const F=await this.j,B=JSON.stringify(R.raw),x={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},ie=new Date().getTime();let se,pe,ye=0;try{if(se=await this.k.request({type:"POST",url:this.g&&R.criteria.some(ue=>ue.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:B,headers:x},C),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ye};const ae=await(0,l.asJson)(se);if(ae){const ue=ae.results[0],le=ue.extensions,oe=ue.resultMetadata&&ue.resultMetadata.filter(fe=>fe.metadataType==="ResultCount")[0];return ye=oe&&oe.metadataItems.filter(fe=>fe.name==="TotalCount")[0].count||0,{galleryExtensions:le,total:ye}}return{galleryExtensions:[],total:ye}}catch(ae){throw pe=ae,ae}finally{this.o.publicLog2("galleryService:query",{...R.telemetryData,requestBodySize:String(B.length),duration:new Date().getTime()-ie,success:!!se&&(0,l.isSuccess)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:pe?(0,k.isCancellationError)(pe)?"canceled":(0,k.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(R,C,F,B){if(!this.isEnabled())return;const x=L.isWeb?this.x(`/itemName/${R}.${C}/version/${F}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${R}/extensions/${C}/${F}/stats?statType=${B}`),ie=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ie};try{await this.k.request({type:"POST",url:x,headers:pe},O.CancellationToken.None)}catch{}}async download(R,C,F){this.l.trace("ExtensionGalleryService#download",R.identifier.id);const B=(0,p.getGalleryExtensionTelemetryData)(R),x=new Date().getTime(),ie=ae=>this.o.publicLog("galleryService:downloadVSIX",{...B,duration:ae}),se=F===2?"install":F===3?"update":"",pe=se?{uri:`${R.assets.download.uri}${d.URI.parse(R.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${R.assets.download.fallbackUri}${d.URI.parse(R.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:R.assets.download,ye=await this.D(pe);await this.q.writeFile(C,ye.stream),ie(new Date().getTime()-x)}async downloadSignatureArchive(R,C){if(!R.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",R.identifier.id);const F=await this.D(R.assets.signature);await this.q.writeFile(C,F.stream)}async getReadme(R,C){if(R.assets.readme){const F=await this.D(R.assets.readme,{},C);return await(0,l.asTextOrError)(F)||""}return""}async getManifest(R,C){if(R.assets.manifest){const F=await this.D(R.assets.manifest,{},C),B=await(0,l.asTextOrError)(F);return B?JSON.parse(B):null}return null}async C(R,C){const F=X(R,r.Manifest);if(!F)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},x=await this.D(F,{headers:B});return await(0,l.asJson)(x)}async getCoreTranslation(R,C){const F=R.assets.coreTranslations.filter(B=>B[0]===C.toUpperCase())[0];if(F){const B=await this.D(F[1]),x=await(0,l.asTextOrError)(B);return x?JSON.parse(x):null}return null}async getChangelog(R,C){if(R.assets.changelog){const F=await this.D(R.assets.changelog,{},C);return await(0,l.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(R,C,F){let B=new h().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);R.identifier.uuid?B=B.withFilter(i.ExtensionId,R.identifier.uuid):B=B.withFilter(i.ExtensionName,R.identifier.id);const{galleryExtensions:x}=await this.B(B,O.CancellationToken.None);if(!x.length)return[];const ie=M(x[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(ie,F))return[];const se=[];await Promise.all(x[0].versions.map(async ae=>{try{await this.y(ae,C?"any":"release",!0,ie,F)&&se.push(ae)}catch{}}));const pe=[],ye=new Set;for(const ae of A(se,F))ye.has(ae.version)||(ye.add(ae.version),pe.push({version:ae.version,date:ae.lastUpdated,isPreReleaseVersion:Q(ae)}));return pe}async D(R,C={},F=O.CancellationToken.None){const B=await this.j,x={type:"GET"},ie={...B,...C.headers||{}};C={...C,...x,headers:ie};const se=R.uri,pe=R.fallbackUri,ye={...C,url:se};try{const ae=await this.k.request(ye,F);if(ae.res.statusCode===200)return ae;const ue=await(0,l.asTextOrError)(ae);throw new Error(`Expected 200, got back ${ae.res.statusCode} instead.

${ue}`)}catch(ae){if((0,k.isCancellationError)(ae))throw ae;const ue=(0,k.getErrorMessage)(ae);this.o.publicLog2("galleryService:cdnFallback",{url:se,message:ue});const le={...C,url:pe};return this.k.request(le,F)}}async E(R){let C=ne(R);if(!C){const F=await this.C(R,O.CancellationToken.None);if(!F)throw new Error("Manifest was not found");C=F.engines.vscode}return C}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const R=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,l.asJson)(R),F=[],B={};if(C){for(const x of C.malicious)F.push({id:x});if(C.migrateToPreRelease)for(const[x,ie]of Object.entries(C.migrateToPreRelease))(!ie.engine||(0,I.isEngineValid)(ie.engine,this.u.version,this.u.date))&&(B[x.toLowerCase()]={disallowInstall:!0,extension:{id:ie.id,displayName:ie.displayName,autoMigrate:{storage:!!ie.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[x,ie]of Object.entries(C.deprecated))ie&&(B[x.toLowerCase()]=(0,P.isBoolean)(ie)?{}:ie)}return{malicious:F,deprecated:B}}};G=de([_(1,l.IRequestService),_(2,S.ILogService),_(3,m.IEnvironmentService),_(4,f.ITelemetryService),_(5,w.IFileService),_(6,E.IProductService),_(7,u.IConfigurationService)],G);let q=class extends G{constructor(R,C,F,B,x,ie,se,pe){super(R,C,F,B,x,ie,se,pe)}};q=de([_(0,v.IStorageService),_(1,l.IRequestService),_(2,S.ILogService),_(3,m.IEnvironmentService),_(4,f.ITelemetryService),_(5,w.IFileService),_(6,E.IProductService),_(7,u.IConfigurationService)],q),e.ExtensionGalleryService=q;let te=class extends G{constructor(R,C,F,B,x,ie,se){super(void 0,R,C,F,B,x,ie,se)}};te=de([_(0,l.IRequestService),_(1,S.ILogService),_(2,m.IEnvironmentService),_(3,f.ITelemetryService),_(4,w.IFileService),_(5,E.IProductService),_(6,u.IConfigurationService)],te),e.ExtensionGalleryServiceWithNoStorageService=te}),define(Y[149],Z([0,1,44,11,18,13,9,67,28,25]),function($,e,T,O,k,L,N,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class $e extends u.UserDataProfilesService{constructor(p,I,w,S,E){super(w,S,I,E),this.a=p,this.N=w}H(){return(0,T.revive)(this.a.getItem($e.b,[]))}J(){return(0,T.revive)(this.a.getItem($e.c,{}))}M(){return this.r.extUri.joinPath(O.URI.file(this.N.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};m=de([_(0,P.IStateService),_(1,d.IUriIdentityService),_(2,k.INativeEnvironmentService),_(3,L.IFileService),_(4,N.ILogService)],m),e.UserDataProfilesService=m}),define(Y[150],Z([0,1,38,3,163,2,9]),function($,e,T,O,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends T.AbstractPolicyService{constructor(u,m){super(),this.j=u,this.k=m,this.a=new O.Throttler,this.b=this.B(new L.MutableDisposable)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise((m,y)=>{try{this.b.value=(0,k.createWatcher)(this.k,u,p=>{this.m(p),m()})}catch(p){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),y(p)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const m in u){const y=u[m];y===void 0?this.g.delete(m):this.g.set(m,y)}this.h.fire(Object.keys(u))}};P=de([_(0,N.ILogService)],P),e.NativePolicyService=P}),define(Y[69],Z([0,1,119,3,14,5,20,84,164,165]),function($,e,T,O,k,L,N,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class m extends Error{constructor(t,n){let i=n.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=n}}e.ExtractError=m;function y(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,i)=>n+i,t&61440)}function p(s){if(s instanceof m)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new m(t,s)}function I(s,t,n,i,r,o){const c=k.dirname(t),a=k.join(i,c);if(!a.startsWith(i))return Promise.reject(new Error(P.localize(0,null,t)));const h=k.join(i,t);let D;return o.onCancellationRequested(()=>{D?.destroy()}),Promise.resolve(N.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((j,W)=>{if(!o.isCancellationRequested)try{D=(0,T.createWriteStream)(h,{mode:n}),D.once("close",()=>j()),D.once("error",W),s.once("error",W),s.pipe(D)}catch(J){W(J)}}))}function w(s,t,n,i){let r=(0,O.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((c,a)=>{const h=new O.Sequencer,D=j=>{j.isCancellationRequested||(o++,s.readEntry())};s.once("error",a),s.once("close",()=>r.then(()=>{i.isCancellationRequested||s.entryCount===o?c():a(new m("Incomplete",new Error(P.localize(1,null,o,s.entryCount))))},a)),s.readEntry(),s.on("entry",j=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){D(i);return}const W=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(W)){const ee=k.join(t,W);r=(0,O.createCancelablePromise)(ne=>N.Promises.mkdir(ee,{recursive:!0}).then(()=>D(ne)).then(void 0,a));return}const J=E(s,j),X=y(j);r=(0,O.createCancelablePromise)(ee=>h.queue(()=>J.then(ne=>I(ne,W,X,t,n,ee).then(()=>D(ee)))).then(null,a))})})}function S(s,t=!1){return new Promise((n,i)=>{(0,d.open)(s,t?{lazyEntries:!0}:void 0,(r,o)=>{r?i(p(r)):n((0,L.assertIsDefined)(o))})})}function E(s,t){return new Promise((n,i)=>{s.openReadStream(t,(r,o)=>{r?i(p(r)):n((0,L.assertIsDefined)(o))})})}function l(s,t){return new Promise((n,i)=>{const r=new u.ZipFile;t.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,T.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>n(s))})}e.zip=l;function g(s,t,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=S(s,!0);return n.overwrite&&(o=o.then(c=>N.Promises.rm(t).then(()=>c))),o.then(c=>w(c,t,{sourcePathRegex:r},i))}e.extract=g;function v(s,t){return S(s).then(n=>new Promise((i,r)=>{n.on("entry",o=>{o.fileName===t&&E(n,o).then(c=>i(c),c=>r(c))}),n.once("close",()=>r(new Error(P.localize(2,null,t))))}))}function f(s,t){return v(s,t).then(n=>new Promise((i,r)=>{const o=[];n.once("error",r),n.on("data",c=>o.push(c)),n.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=f}),define(Y[151],Z([0,1,69,92]),function($,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(L){return(0,T.buffer)(L,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=k}),define(Y[152],Z([0,1,3,22,34,10,4,2,36,16,14,12,17,39,5,11,30,20,69,91,58,18,144,23,24,42,48,126,145,151,127,128,27,45,13,8,9,26,32,28,25]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w,S,E,l,g,v,f,s,t,n,i,r,o,c,a,h,D,j,W,J,X,ee,ne,Q,ge,ce,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(n.IExtensionManagementService);let me=class extends t.AbstractExtensionManagementService{constructor(b,R,C,F,B,x,ie,se,pe,ye,ae,ue){super(b,R,C,ye,ue),this.Y=B,this.Z=x,this.ab=ie,this.bb=pe,this.cb=ae,this.X=new Map,this.kb=new d.ResourceSet;const le=this.B(se.createInstance(a.ExtensionsLifecycle));this.S=this.B(se.createInstance(M,fe=>le.postUninstall(fe))),this.U=this.B(new D.ExtensionsManifestCache(F,this)),this.W=this.B(se.createInstance(c.ExtensionsDownloader,this.getTargetPlatform()));const oe=this.B(new j.ExtensionsWatcher(this,this.Y,ue,x,ae,pe,C));this.B(oe.onDidChangeExtensionsByAnotherSource(fe=>this.jb(fe))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,i.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(b){this.v.trace("ExtensionManagementService#zip",b.identifier.id);const R=await this.ib(b),C=await(0,g.zip)((0,p.joinPath)(this.W.extensionsDownloadDir,(0,E.generateUuid)()).fsPath,R);return S.URI.file(C)}async unzip(b){return this.v.trace("ExtensionManagementService#unzip",b.toString()),(await this.install(b)).identifier}async getManifest(b){const{location:R,cleanup:C}=await this.eb(b),F=m.resolve(R.fsPath);try{return await(0,h.getManifest)(F)}finally{await C()}}getInstalled(b,R){return this.S.scanExtensions(b??null,R)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(b,R={}){this.v.trace("ExtensionManagementService#install",b.toString());const{location:C,cleanup:F}=await this.eb(b);try{const B=await(0,h.getManifest)(m.resolve(C.fsPath));if(B.engines&&B.engines.vscode&&!(0,J.isEngineValid)(B.engines.vscode,this.w.version,this.w.date))throw new Error(v.localize(0,null,(0,i.getGalleryExtensionId)(B.publisher,B.name),this.w.version));return await this.z(B,C,R)}finally{await F()}}async installFromLocation(b,R){this.v.trace("ExtensionManagementService#installFromLocation",b.toString());const C=await this.S.scanUserExtensionAtLocation(b);if(!C)throw new Error(`Cannot find a valid extension from the location ${b.toString()}`);return await this.nb([C],R),this.v.info("Successfully installed extension",C.identifier.id,R.toString()),C}getMetadata(b){return this.Y.scanMetadata(b.location)}async updateMetadata(b,R){this.v.trace("ExtensionManagementService#updateMetadata",b.identifier.id);const C={...R};return R.isPreReleaseVersion&&(C.preRelease=!0),b=await this.S.updateMetadata(b,C),this.U.invalidate(),b}async updateExtensionScope(b,R){return this.v.trace("ExtensionManagementService#updateExtensionScope",b.identifier.id),b=await this.S.updateMetadata(b,{isMachineScoped:R}),this.U.invalidate(),b}async reinstallFromGallery(b){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",b.identifier.id),!this.t.isEnabled())throw new Error(v.localize(1,null));const R=await this.getTargetPlatform(),[C]=await this.t.getExtensions([{...b.identifier,preRelease:b.preRelease}],{targetPlatform:R,compatible:!0},O.CancellationToken.None);if(!C)throw new Error(v.localize(2,null));await this.S.setUninstalled(b);try{await this.S.removeUninstalledExtension(b)}catch(F){throw new Error(v.localize(3,null,(0,k.toErrorMessage)(F)))}await this.installFromGallery(C)}markAsUninstalled(...b){return this.S.setUninstalled(...b)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(b,R){const{location:C}=await this.W.download(b,R);return C}async eb(b){if(b.scheme===u.Schemas.file)return{location:b,async cleanup(){}};this.v.trace("Downloading extension from",b.toString());const R=(0,p.joinPath)(this.W.extensionsDownloadDir,(0,E.generateUuid)());return await this.ab.download(b,R),this.v.info("Downloaded extension to",R.toString()),{location:R,cleanup:async()=>{try{await this.bb.del(R)}catch(F){this.v.error(F)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(b,R,C){let F;if(S.URI.isUri(R))F=new V(b,R,C,this.t,this.S,this.v);else{const B=i.ExtensionKey.create(R).toString();F=this.X.get(B),F||(this.X.set(B,F=new U(b,R,C,this.W,this.S,this.v)),F.waitUntilTaskIsFinished().then(()=>this.X.delete(B)))}return new G(F,C.profileLocation,this.Z)}R(b,R){return new q(b,R.profileLocation,this.Z)}async ib(b){const R=async F=>{let B=await l.Promises.readdir(F);B=B.map(se=>m.join(F,se));const x=await Promise.all(B.map(se=>l.Promises.stat(se)));let ie=Promise.resolve([]);return x.forEach((se,pe)=>{const ye=B[pe];se.isFile()&&(ie=ie.then(ae=>[...ae,ye])),se.isDirectory()&&(ie=ie.then(ae=>R(ye).then(ue=>[...ae,...ue])))}),ie};return(await R(b.location.fsPath)).map(F=>({path:`extension/${m.relative(b.location.fsPath,F)}`,localPath:F}))}async jb({added:b,removed:R}){if(R)for(const C of R.extensions)this.v.info("Extensions removed from another source",C.id,R.profileLocation.toString()),this.p.fire({identifier:C,profileLocation:R.profileLocation});if(b){const F=(await this.S.scanExtensions(1,b.profileLocation)).filter(B=>b.extensions.some(x=>(0,i.areSameExtensions)(x,B.identifier)));this.m.fire(F.map(B=>(this.v.info("Extensions added from another source",B.identifier.id,b.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:b.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(R=>this.kb.add(R)));const b=await this.bb.resolve(this.Y.userExtensionsLocation);for(const R of b.children??[])R.isDirectory&&this.kb.add(R.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(R=>this.mb(R)))}async mb(b){const R=[];for(const C of b.rawAdded){if(this.kb.has(C)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(C),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(C,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(C).startsWith(".")||!(await this.bb.stat(C)).isDirectory)continue;const F=await this.S.scanUserExtensionAtLocation(C);F&&F.installedTimestamp===void 0&&(this.kb.add(C),R.push(F))}R.length&&(await this.nb(R,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",R.map(C=>C.identifier.id)))}async nb(b,R){await this.Z.addExtensionsToProfile(b.map(C=>[C,void 0]),R),this.m.fire(b.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:R})))}};me=de([_(0,n.IExtensionGalleryService),_(1,ge.ITelemetryService),_(2,ne.ILogService),_(3,s.INativeEnvironmentService),_(4,o.IExtensionsScannerService),_(5,r.IExtensionsProfileScannerService),_(6,f.IDownloadService),_(7,ee.IInstantiationService),_(8,X.IFileService),_(9,Q.IProductService),_(10,ce.IUriIdentityService),_(11,re.IUserDataProfilesService)],me),e.ExtensionManagementService=me;let M=class extends P.Disposable{constructor(b,R,C,F){super(),this.j=b,this.k=R,this.l=C,this.m=F,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,p.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new T.Queue}async cleanUp(){await this.v()}async scanExtensions(b,R){await this.l.initializeDefaultProfileExtensions();const C={includeInvalid:!0,profileLocation:R};let F=[];return b===null||b===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},C,!1)):b===1&&F.push(...await this.l.scanUserExtensions(C)),F=b!==null?F.filter(B=>B.type===b):F,Promise.all(F.map(B=>this.u(B)))}async scanAllUserExtensions(b){const R=await this.l.scanUserExtensions({includeAllVersions:!b,includeInvalid:!0});return Promise.all(R.map(C=>this.u(C)))}async scanUserExtensionAtLocation(b){try{const R=await this.l.scanExistingExtension(b,1,{includeInvalid:!0});if(R)return await this.u(R)}catch(R){this.m.error(R)}return null}async extractUserExtension(b,R,C,F){await this.l.initializeDefaultProfileExtensions();const B=b.toString(),x=m.join(this.l.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),ie=m.join(this.l.userExtensionsLocation.fsPath,B);try{await l.Promises.rm(ie)}catch{throw new n.ExtensionManagementError(v.localize(4,null,ie,b.id),n.ExtensionManagementErrorCode.Delete)}await this.p(b,R,x,F),await this.l.updateMetadata(S.URI.file(x),C);try{this.h.fire(S.URI.file(ie)),await this.s(b,x,ie,Date.now()+2*60*1e3),this.m.info("Renamed to",ie)}catch(se){try{await l.Promises.rm(x)}catch{}if(se.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",b.id);else throw this.m.info(`Rename failed because of ${(0,L.getErrorMessage)(se)}. Deleted from extracted location`,x),se}return this.t(S.URI.file(ie),1)}async updateMetadata(b,R){return await this.l.updateMetadata(b.location,R),this.t(b.location,b.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...b){const R=b.map(C=>i.ExtensionKey.create(C));await this.n(C=>R.forEach(F=>{C[F.toString()]=!0,this.m.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(b){await this.n(F=>delete F[b.toString()]);const C=(await this.scanAllUserExtensions(!0)).find(F=>i.ExtensionKey.create(F).equals(b))||null;return C?this.updateMetadata(C,{installedTimestamp:Date.now()}):null}async removeExtension(b,R){this.m.trace(`Deleting ${R} extension from disk`,b.identifier.id,b.location.fsPath),await l.Promises.rm(b.location.fsPath),this.m.info("Deleted from disk",b.identifier.id,b.location.fsPath)}async removeUninstalledExtension(b){await this.removeExtension(b,"uninstalled"),await this.n(R=>delete R[i.ExtensionKey.create(b).toString()])}async n(b){return this.g.queue(async()=>{let R;try{R=await l.Promises.readFile(this.c,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let C={};if(R)try{C=JSON.parse(R)}catch{}return b&&(b(C),Object.keys(C).length?await l.Promises.writeFile(this.c,JSON.stringify(C)):await l.Promises.rm(this.c)),C})}async p(b,R,C,F){this.m.trace(`Started extracting the extension from ${R} to ${C}`);try{await l.Promises.rm(C)}catch(B){throw new n.ExtensionManagementError(this.w(B).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(R,C,{sourcePath:"extension",overwrite:!0},F),this.m.info(`Extracted extension to ${C}:`,b.id)}catch(B){try{await l.Promises.rm(C)}catch{}let x=n.ExtensionManagementErrorCode.Extract;throw B instanceof g.ExtractError&&(B.type==="CorruptZip"?x=n.ExtensionManagementErrorCode.CorruptZip:B.type==="Incomplete"&&(x=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(B.message,x)}}async s(b,R,C,F){try{await l.Promises.rename(R,C)}catch(B){if(y.isWindows&&B&&B.code==="EPERM"&&Date.now()<F)return this.m.info(`Failed renaming ${R} to ${C} with 'EPERM' error. Trying again...`,b.id),this.s(b,R,C,F);throw new n.ExtensionManagementError(B.message||v.localize(5,null,R,C),B.code||n.ExtensionManagementErrorCode.Rename)}}async t(b,R){const C=await this.l.scanExistingExtension(b,R,{includeInvalid:!0});if(C)return this.u(C);throw new Error(v.localize(6,null,b.path))}async u(b){const R=await this.k.resolve(b.location);let C,F;return R.children&&(C=R.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,F=R.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:b.identifier,type:b.type,isBuiltin:b.isBuiltin||!!b.metadata?.isBuiltin,location:b.location,manifest:b.manifest,targetPlatform:b.targetPlatform,validations:b.validations,isValid:b.isValid,readmeUrl:C,changelogUrl:F,publisherDisplayName:b.metadata?.publisherDisplayName||null,publisherId:b.metadata?.publisherId||null,isApplicationScoped:!!b.metadata?.isApplicationScoped,isMachineScoped:!!b.metadata?.isMachineScoped,isPreReleaseVersion:!!b.metadata?.isPreReleaseVersion,preRelease:!!b.metadata?.preRelease,installedTimestamp:b.metadata?.installedTimestamp,updated:!!b.metadata?.updated}}async v(){const b=await this.getUninstalledExtensions(),R=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),C=new Set;for(const x of R)b[i.ExtensionKey.create(x).toString()]||C.add(x.identifier.id.toLowerCase());const F=(0,i.groupByExtension)(R,x=>x.identifier);await T.Promises.settled(F.map(async x=>{const ie=x.sort((se,pe)=>I.rcompare(se.manifest.version,pe.manifest.version))[0];C.has(ie.identifier.id.toLowerCase())||await this.j(await this.u(ie))}));const B=R.filter(x=>x.metadata&&b[i.ExtensionKey.create(x).toString()]);await T.Promises.settled(B.map(x=>this.removeUninstalledExtension(x)))}w(b){const R=Array.isArray(b)?b:[b];return R.length===1?R[0]instanceof Error?R[0]:new Error(R[0]):R.reduce((C,F)=>new Error(`${C.message}${C.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};M=de([_(1,X.IFileService),_(2,o.IExtensionsScannerService),_(3,ne.ILogService)],M),e.ExtensionsScanner=M;class A extends t.AbstractExtensionTask{get operation(){return(0,w.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(b,R,C,F,B){super(),this.identifier=b,this.source=R,this.k=C,this.l=F,this.m=B,this.wasVerified=!1,this.j=2}async n(b,R){try{const C=await this.o(b.key);if(C)return this.l.updateMetadata(C,b.metadata)}catch{throw y.isMacintosh?new n.ExtensionManagementError(v.localize(7,null),n.ExtensionManagementErrorCode.Internal):new n.ExtensionManagementError(v.localize(8,null),n.ExtensionManagementErrorCode.Internal)}return this.q(b,R)}async o(b){if(!await this.p(b))return null;this.m.trace("Removing the extension from uninstalled list:",b.id);const C=await this.l.setInstalled(b);return this.m.info("Removed the extension from uninstalled list:",b.id),C}async p(b){return!!(await this.l.getUninstalledExtensions())[b.toString()]}async q({zipPath:b,key:R,metadata:C},F){const B=await this.l.extractUserExtension(R,b,C,F);return this.m.info("Extracting completed.",R.id),B}}class U extends A{constructor(b,R,C,F,B,x){super(R.identifier,R,C,B,x),this.s=b,this.t=R,this.u=F}async h(b){const C=(await this.l.scanExtensions(null,void 0)).find(ie=>(0,i.areSameExtensions)(ie.identifier,this.t.identifier));C&&(this.j=3);const F={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,W.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||C?.isMachineScoped,isBuiltin:this.k.isBuiltin||C?.isBuiltin,isSystem:C?.type===0?!0:void 0,updated:!!C,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,w.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:C?.preRelease)};if(C?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(C,F),metadata:F};const{location:B,verified:x}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!x,this.w(B.fsPath),{local:await this.n({zipPath:B.fsPath,key:i.ExtensionKey.create(this.t),metadata:F},b),metadata:F}}catch(ie){try{await this.u.delete(B)}catch(se){this.m.warn("Error while deleting the downloaded file",B.toString(),(0,L.getErrorMessage)(se))}throw ie}}async w(b){try{await(0,h.getManifest)(b)}catch(R){throw new n.ExtensionManagementError((0,t.joinErrors)(R).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=U;class V extends A{constructor(b,R,C,F,B,x){super({id:(0,i.getGalleryExtensionId)(b.publisher,b.name)},R,C,B,x),this.s=b,this.t=R,this.u=F}async h(b){const R=new i.ExtensionKey(this.identifier,this.s.version),F=(await this.l.scanExtensions(1,void 0)).find(ie=>(0,i.areSameExtensions)(this.identifier,ie.identifier)),B=await this.w(this.identifier.id,this.s.version,b);if(B.isApplicationScoped=(0,W.isApplicationScopedExtension)(this.s),B.isMachineScoped=this.k.isMachineScoped||F?.isMachineScoped,B.isBuiltin=this.k.isBuiltin||F?.isBuiltin,B.installedTimestamp=Date.now(),F)if(this.j=3,R.equals(new i.ExtensionKey(F.identifier,F.manifest.version)))try{await this.l.removeExtension(F,"existing")}catch{throw new Error(v.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&I.gt(F.manifest.version,this.s.version)&&await this.l.setUninstalled(F);else{const ie=await this.o(R);if(ie)try{await this.l.removeExtension(ie,"existing")}catch{throw new Error(v.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:m.resolve(this.t.fsPath),key:R,metadata:B},b),metadata:B}}async w(b,R,C){try{let[F]=await this.u.getExtensions([{id:b,version:R}],C);if(F||([F]=await this.u.getExtensions([{id:b}],C)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class G{constructor(b,R,C){this.d=b,this.g=R,this.h=C,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const b=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[b.local,b.metadata]],this.g),b}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends t.AbstractExtensionTask{constructor(b,R,C){super(),this.extension=b,this.j=R,this.k=C}async h(b){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Y[153],Z([0,1,132,3,15,10,2,5,21,18,133,9,131,166]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends N.Disposable{constructor(E,l,g){super(),this.h=l,this.i=g,this.j(E.getValue()),this.B(E.onDidChangeConfiguration(()=>this.j(E.getValue()),this))}j(E){this.a=E.http&&E.http.proxy,this.b=!!(E.http&&E.http.proxyStrictSSL),this.f=E.http&&E.http.proxyAuthorization}async request(E,l){this.i.trace("RequestService#request (node) - begin",E.url);const{a:g,b:v}=this;let f;try{f=await(0,m.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(n){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...f},t=E.agent?E.agent:await(0,p.getProxyAgent)(E.url||"",s,{proxyUrl:g,strictSSL:v});E.agent=t,E.strictSSL=v,this.f&&(E.headers={...E.headers||{},"Proxy-Authorization":this.f});try{const n=await this.l(E,l);return this.i.trace("RequestService#request (node) - success",E.url),n}catch(n){throw this.i.trace("RequestService#request (node) - error",E.url,n),n}}async k(E){return((0,T.parse)(E.url).protocol==="https:"?await new Promise((v,f)=>{$(["https"],v,f)}):await new Promise((v,f)=>{$(["http"],v,f)})).request}l(E,l){return O.Promises.withAsyncBody(async(g,v)=>{const f=(0,T.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.k(E),t={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,P.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(t.auth=E.user+":"+E.password);const n=s(t,i=>{const r=(0,P.isNumber)(E.followRedirects)?E.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this.l({...E,url:i.headers.location,followRedirects:r-1},l).then(g,v);else{let o=i;!E.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,I.createGunzip)())),g({res:i,stream:(0,k.streamToBufferReadableStream)(o)})}});n.on("error",v),E.timeout&&n.setTimeout(E.timeout),E.isChromiumNetwork&&n.removeHeader("Content-Length"),E.data&&typeof E.data=="string"&&n.write(E.data),n.end(),l.onCancellationRequested(()=>{n.abort(),v(new L.CancellationError)})})}async resolveProxy(E){}};w=de([_(0,d.IConfigurationService),_(1,u.INativeEnvironmentService),_(2,y.ILogService)],w),e.RequestService=w}),define(Y[167],Z([0,1,33,3,15,34,10,2,16,14,12,35,11,20,21,124,58,130,18,105,148,23,59,125,42,48,152,146,13,116,118,46,114,62,63,129,9,120,121,38,150,138,26,47,153,67,134,68,32,137,41,139,140,28,142,25,149,141]),function($,e,T,O,k,L,N,P,d,u,m,y,p,I,w,S,E,l,g,v,f,s,t,n,i,r,o,c,a,h,D,j,W,J,X,ee,ne,Q,ge,ce,re,me,M,A,U,V,G,q,te,b,R,C,F,B,x,ie,se,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends P.Disposable{constructor(le){super(),this.b=le,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[le,oe]=await this.f();return le.invokeFunction(async fe=>{const Te=fe.get(ne.ILogService),Fe=fe.get(a.IFileService),De=fe.get(g.INativeEnvironmentService),Me=fe.get(ie.IUserDataProfilesService);Te.info("CLI main",this.b),this.g(Te),await this.h(De,Fe,Me,le),await Promise.all(oe.map(z=>{(0,O.raceTimeout)(z.flush(),1e3)}))})}async f(){const le=new J.ServiceCollection,oe={_serviceBrand:void 0,...me.default};le.set(M.IProductService,oe);const fe=new v.NativeEnvironmentService(this.b,oe);le.set(g.INativeEnvironmentService,fe),await Promise.all([fe.appSettingsHome.fsPath,fe.extensionsPath].map(Pe=>Pe?I.Promises.mkdir(Pe,{recursive:!0}):void 0));const Te=(0,ne.getLogLevel)(fe),Fe=[];Fe.push(new Q.SpdLogLogger("cli",(0,u.join)(fe.logsPath,"cli.log"),!0,!1,Te)),Te===ne.LogLevel.Trace&&Fe.push(new ne.ConsoleLogger(Te));const De=this.B(new ne.MultiplexLogService(Fe));le.set(ne.ILogService,De);const Me=this.B(new h.FileService(De));le.set(a.IFileService,Me);const z=this.B(new D.DiskFileSystemProvider(De));Me.registerProvider(d.Schemas.file,z);const H=new G.StateService(fe,De,Me);le.set(V.IStateService,H);const K=new x.UriIdentityService(Me);le.set(B.IUriIdentityService,K);const he=new se.UserDataProfilesService(H,K,fe,Me,De);le.set(ie.IUserDataProfilesService,he);const ve=m.isWindows&&oe.win32RegValueName?this.B(new re.NativePolicyService(De,oe.win32RegValueName)):fe.policyFile?this.B(new ge.FilePolicyService(fe.policyFile,Me,De)):new ce.NullPolicyService;le.set(ce.IPolicyService,ve);const Re=this.B(new S.ConfigurationService(he.defaultProfile.settingsResource,Me,ve,De));le.set(w.IConfigurationService,Re),await Promise.all([H.init(),Re.initialize()]),he.setEnablement(oe.quality!=="stable"||Re.getValue(ie.PROFILES_ENABLEMENT_CONFIG)),le.set(B.IUriIdentityService,new x.UriIdentityService(Me)),le.set(A.IRequestService,new j.SyncDescriptor(U.RequestService,void 0,!0)),le.set(E.IDownloadService,new j.SyncDescriptor(l.DownloadService,void 0,!0)),le.set(i.IExtensionsProfileScannerService,new j.SyncDescriptor(i.ExtensionsProfileScannerService,void 0,!0)),le.set(r.IExtensionsScannerService,new j.SyncDescriptor(c.ExtensionsScannerService,void 0,!0)),le.set(t.IExtensionSignatureVerificationService,new j.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),le.set(o.INativeServerExtensionManagementService,new j.SyncDescriptor(o.ExtensionManagementService,void 0,!0)),le.set(s.IExtensionGalleryService,new j.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),le.set(X.ILanguagePackService,new j.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1));const Se=[],Le=(0,R.isInternalTelemetry)(oe,Re);if((0,R.supportsTelemetry)(oe,fe)){oe.aiConfig&&oe.aiConfig.ariaKey&&Se.push(new C.OneDataSystemAppender(Le,"monacoworkbench",null,oe.aiConfig.ariaKey));const{installSourcePath:Pe}=fe,Oe={appenders:Se,sendErrorTelemetry:!1,commonProperties:(async()=>{let je;try{je=await(0,pe.resolveMachineId)(H)}catch(Ie){Ie.code!=="ENOENT"&&De.error(Ie)}return(0,q.resolveCommonProperties)(Me,(0,T.release)(),(0,T.hostname)(),process.arch,oe.commit,oe.version,je,Le,Pe)})(),piiPaths:(0,R.getPiiPathsFromEnvironment)(fe)};le.set(te.ITelemetryService,new j.SyncDescriptor(b.TelemetryService,[Oe],!1))}else le.set(te.ITelemetryService,R.NullTelemetryService);return[new W.InstantiationService(le),Se]}g(le){(0,N.setUnexpectedErrorHandler)(oe=>{const fe=(0,L.toErrorMessage)(oe,!0);!fe||le.error(`[uncaught exception in CLI]: ${fe}`)}),process.on("uncaughtException",oe=>(0,N.onUnexpectedError)(oe)),process.on("unhandledRejection",oe=>(0,N.onUnexpectedError)(oe))}async h(le,oe,fe,Te){const Fe=(le.args.profile?fe.profiles.find(De=>De.name===le.args.profile)??fe.defaultProfile:fe.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(le,oe,this.b["install-source"]);if(this.b["list-extensions"])return Te.createInstance(n.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Fe);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const De={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Fe};return Te.createInstance(n.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],De,!!this.b.force)}else{if(this.b["uninstall-extension"])return Te.createInstance(n.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Fe);if(this.b["locate-extension"])return Te.createInstance(n.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.buildTelemetryMessage)(le.appRoot,le.extensionsPath))}}i(le){return le.map(oe=>/\.vsix$/i.test(oe)?p.URI.file((0,u.isAbsolute)(oe)?oe:(0,u.join)((0,y.cwd)(),oe)):oe)}async j(le,oe,fe){await oe.writeFile(p.URI.file(le.installSourcePath),k.VSBuffer.fromString(fe.slice(0,30)))}}async function ae(ue){const le=new ye(ue);try{await le.run()}finally{le.dispose()}}e.main=ae})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8d585dbf89848ccb67527d81c6259325b17fecb8/core/vs/code/node/cliProcessMain.js.map
